*DECK BIVACT
      SUBROUTINE BIVACT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
C
C-----------------------------------------------------------------------
C
C BIVAC TYPE (2-D) TRACKING MODULE.
C
C INPUT/OUTPUT PARAMETERS:
C  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
C  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
C  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
C           =4 SEQUENTIAL ASCII FILE.
C  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
C           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
C           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
C  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
C           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
C           KENTRY(NENTRY)
C
C LINKED LIST / XSM FILE:
C  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TRACK).
C  HENTRY(2) : READ-ONLY TYPE(L_GEOM)
C
C-------------------------------------- AUTHOR: A. HEBERT ; 01/12/93 ---
C
      IMPLICIT NONE
C----
C PARAMETERS
C-----
      INTEGER       IOUT,NSTATE
      CHARACTER     NAMMOD*12
      PARAMETER    (IOUT=6,NSTATE=40,NAMMOD='BIVACT:     ')
C----
C INTERFACE VARIABLES
C----
      INTEGER      NENTRY                  	
      CHARACTER    HENTRY(NENTRY)*12
      INTEGER      IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C----
C  MEMORY ALLOCATION
C----
      INTEGER      IBASE(1)
      REAL          BASE(1)
      COMMON        BASE
      EQUIVALENCE  (BASE(1),IBASE(1))
      INTEGER      IMAT,IVOL,IIDL
C----
C LOCAL VARIABLES
C----
      INTEGER          I,ITYPE,IMPX,MAXPTS,IELEM,ICOL,ISPLH,INDIC,
     &                 NITMA
      INTEGER          ITITL(18),IGP(NSTATE),ISTATE(NSTATE),KCHAR(3),
     &                 NCODE(6)
      REAL             FLOTT
      CHARACTER        TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12
      DOUBLE PRECISION DFLOTT
      LOGICAL          LOG
C----
C  PRINT CREDITS
C----
      WRITE(IOUT,6900) NAMMOD
      WRITE(IOUT,6910)
C-----
C PARAMETER VALIDATION.
C----
      IF(NENTRY.LE.1) CALL XABORT('BIVACT: TWO PARAMETERS EXPECTED.')
      IF(IENTRY(1).NE.1) CALL XABORT('BIVACT: LINKED LIST EXPECTED AT L'
     1 //'HS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('BIVACT: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('BIVACT: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT RHS.')
      CALL LCMGET(KENTRY(2),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_GEOM') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('BIVACT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_GEOM EXPECTED.')
      ENDIF
      HSIGN='L_TRACK'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
      HSIGN='BIVAC'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'TRACK-TYPE',3,3,KCHAR)
      CALL LCMGET(KENTRY(2),'STATE-VECTOR',ISTATE)
      ITYPE=ISTATE(1)
*
      IMPX=1
      IF(JENTRY(1).EQ.0) THEN
         TITLE=' '
         MAXPTS=ISTATE(6)
         IELEM=1
         ICOL=2
         ISPLH=1
         CALL LCMGET(KENTRY(2),'NCODE',NCODE)
         LOG=.FALSE.
         DO 10 I=1,4
   10    LOG=LOG.OR.(NCODE(I).EQ.3)
         IF(LOG) MAXPTS=2*MAXPTS
      ELSE IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'L_TRACK') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('BIVACT: SIGNATURE OF '//TEXT12//' IS '//HSIGN
     1      //'. L_TRACK EXPECTED.')
         ENDIF
         CALL LCMGET(KENTRY(1),'TRACK-TYPE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'BIVAC') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('BIVACT: TRACK-TYPE OF '//TEXT12//' IS '//HSIGN
     1      //'. BIVAC EXPECTED.')
         ENDIF
         CALL LCMGET(KENTRY(1),'STATE-VECTOR',IGP)
         MAXPTS=IGP(1)
         IELEM=IGP(8)
         ICOL=IGP(9)
         ISPLH=IGP(10)
      ENDIF
   15 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 30
   20 IF(INDIC.NE.3) CALL XABORT('BIVACT: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TITLE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('BIVACT: TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED(2).')
      ELSE IF(TEXT4.EQ.'PRIM') THEN
*        MESH CORNER FINITE DIFFERENCES OR PRIMAL FINITE ELEMENTS.
         IELEM=-1
         ICOL=2
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=-NITMA
            CALL REDGET(INDIC,ICOL,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED('
     1      //'3).')
         ELSE
            GO TO 20
         ENDIF
         IF(ITYPE.EQ.8) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED('
     1      //'4).')
         ENDIF
      ELSE IF(TEXT4.EQ.'DUAL') THEN
*        MESH CENTERED FINITE DIFFERENCES OR MIXED-DUAL FINITE ELEMENTS.
         IELEM=1
         ICOL=2
         CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.EQ.1) THEN
            IELEM=NITMA
            CALL REDGET(INDIC,ICOL,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED('
     1      //'5).')
         ELSE
            GO TO 20
         ENDIF
         IF(ITYPE.EQ.8) THEN
            CALL REDGET(INDIC,ISPLH,FLOTT,TEXT4,DFLOTT)
            IF(INDIC.NE.1) CALL XABORT('BIVACT: INTEGER DATA EXPECTED('
     1      //'6).')
         ENDIF
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 30
      ELSE
         CALL XABORT('BIVACT: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 15
*
   30 IF(TITLE.NE.' ') THEN
         READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
         CALL LCMPUT(KENTRY(1),'TITLE',18,3,ITITL)
      ENDIF
      TEXT12=HENTRY(2)
      READ(TEXT12,'(3A4)') (ITITL(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'LINK.GEOM',3,3,ITITL)
      IF(IMPX.GT.1) WRITE(IOUT,100) TITLE
*
      IF(MAXPTS.EQ.0) CALL XABORT('BIVACT: MAXPTS NOT DEFINED.')
      CALL SETARA(BASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS,IVOL)
      CALL SETARA(BASE,MAXPTS,IIDL)
      CALL BIVTRK (MAXPTS,KENTRY(1),KENTRY(2),IMPX,IELEM,ICOL,ISPLH,
     1 BASE(IMAT),BASE(IVOL),BASE(IIDL))
      CALL RLSARA(BASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(BASE(IMAT))
*
      IF(IMPX.GT.1) THEN
         CALL LCMGET(KENTRY(1),'STATE-VECTOR',IGP)
         WRITE(IOUT,110) (IGP(I),I=1,13)
      ENDIF
      WRITE(IOUT,6901) NAMMOD
      RETURN
*
  100 FORMAT(1H1,36HBBBBBB  IIIIII VV  VV   AA    CCCCC ,95(1H*)/
     1 38H BBBBBBB IIIIII VV  VV  AAAA  CCCCCCC ,56(1H*),
     2 38H MULTIGROUP VERSION.  A. HEBERT (1993)/
     3 37H BB   BB   II   VV  VV  AAAA  CC   CC/
     4 37H BBBBB     II   VV  VV AA  AA CC     /
     5 37H BBBBB     II   VV  VV AAAAAA CC     /
     6 37H BB   BB   II   VV  VV AAAAAA CC   CC/
     7 37H BBBBBBB IIIIII  VVVV  AA  AA CCCCCCC/
     8 37H BBBBBB  IIIIII   VV   AA  AA  CCCCC //1X,A72//)
  110 FORMAT(/14H STATE VECTOR:/
     1 7H NREG  ,I6,22H   (NUMBER OF REGIONS)/
     2 7H NUN   ,I6,23H   (NUMBER OF UNKNOWNS)/
     3 7H ILK   ,I6,39H   (0=LEAKAGE PRESENT/1=LEAKAGE ABSENT)/
     4 7H NBMIX ,I6,36H   (MAXIMUM NUMBER OF MIXTURES USED)/
     5 7H NSURF ,I6,29H   (NUMBER OF OUTER SURFACES)/
     6 7H ITYPE ,I6,21H   (TYPE OF GEOMETRY)/
     7 7H IHEX  ,I6,31H   (TYPE OF HEXAGONAL SYMMETRY)/
     8 7H IELEM ,I6,28H   (TYPE OF FINITE ELEMENTS)/
     9 7H ICOL  ,I6,47H   (TYPE OF QUADRATURE USED TO INTEGRATE THE MA,
     1 10HSS MATRIX)/
     2 7H ISPLH ,I6,37H   (TYPE OF HEXAGONAL MESH-SPLITTING)/
     3 7H LL4   ,I6,45H   (ORDER OF THE MATRICES PER GROUP IN BIVAC)/
     4 7H LX    ,I6,40H   (NUMBER OF ELEMENTS ALONG THE X AXIS)/
     4 7H LY    ,I6,40H   (NUMBER OF ELEMENTS ALONG THE Y AXIS))
 6900 FORMAT('->@BEGIN MODULE : ',A12)
 6901 FORMAT('->@END MODULE   : ',A12)
 6910 FORMAT('->@DESCRIPTION  : 2-D DIFFUSION TRACKING MODULE'/
     >       '->@CREDITS      : A. HEBERT'/
     >       '->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL ')
      END
