*DECK CPOREM
      SUBROUTINE CPOREM(NGROUP,NL    ,NPROC ,INDPRO,DENCPO,
     >                  DXSMIC,DSCMIC,DXSREM,DSCREM)
C
C---------------------------  CPOREM  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : CPOREM
C      USE      : REMOVE CPO ISOTOPE XS FROM MACRO XS
C      MODIFIED : 97-07-18 (G.M.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      NGROUP   : NUMBER OF GROUPS CONDENSED         I
C      NL       : NUMBER OF LEGENDRE ORDERS          I
C      NPROC    : NUMBER OF MIC XS TO PROCESS        I
C      INDPRO   : IDENTIFIER FOR XS PROCESSING       I(NPROC)
C      DENCPO   : CPO ISOTOPES CONCENTRATION         D
C      DXSMIC   : MICRO VECTOR XS                    D(NGROUP,NPROC)
C      DSCMIC   : MICRO SCAT MATRIX XS               D(NGROUP,NGROUP,NL)
C    INPUT/OUTPUT
C      DXSREM   : AVERAGED REGION/GROUP X-S          D(NGROUP,NPROC)
C      DSCREM   : DOUBLE PRECISION SCATTERING RATES  D(NGROUP,NGROUP,
C                                                          NL)
C---------------------------   CPOREM  --------------------------------
C
      IMPLICIT         NONE
      INTEGER          NGROUP,NL,NPROC,INDPRO(NPROC)
      DOUBLE PRECISION DENCPO,
     >                 DXSMIC(NGROUP,NPROC),
     >                 DSCMIC(NGROUP,NGROUP,NL),
     >                 DXSREM(NGROUP,NPROC),
     >                 DSCREM(NGROUP,NGROUP,NL)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          NDPROC
      PARAMETER       (NDPROC=20)
      INTEGER          IGR,JGR,IXSR,IL
C----
C  REMOVE STANDARD XS
C----
      DO 100 IXSR=1,NDPROC
        IF(IXSR.NE.16.AND.INDPRO(IXSR).GT.0) THEN
          DO 110 IGR=1,NGROUP
            DXSREM(IGR,IXSR)=DXSREM(IGR,IXSR)
     >                      +DENCPO*DXSMIC(IGR,IXSR)
 110      CONTINUE
        ENDIF
 100  CONTINUE
C----
C  REMOVE SCATTERING XS
C----
      IL=0
      DO 120 IXSR=NDPROC+1,NDPROC+NL
        IL=IL+1
        IF(INDPRO(IXSR).GT.0) THEN
          DO 130 IGR=1,NGROUP
            DXSREM(IGR,IXSR)=DXSREM(IGR,IXSR)
     >        +DENCPO*DXSMIC(IGR,IXSR)
            DO 131 JGR=1,NGROUP
              DSCREM(IGR,JGR,IL)=DSCREM(IGR,JGR,IL)
     >          +DENCPO*DSCMIC(IGR,JGR,IL)
 131        CONTINUE
 130      CONTINUE
        ENDIF
 120  CONTINUE
      RETURN
      END
