*DECK DRAGON
      PROGRAM DRAGON
      IMPLICIT         NONE
*----
*  Local parameters
*----
      INTEGER          IINP,IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IINP=5,IOUT=6,NAMSBR='DRAGON')
*----
*  Memory allocation variables
*----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          IC0,IC1,IC2
*----
*  Variables for DRAGON version
*----
      INTEGER          IMVERS,ISVERS,IVDATE(3),IYMD
*----
*  Variables for data structures
*----
      INTEGER          MAXENT
      PARAMETER       (MAXENT=64)
      CHARACTER        HENTRY(MAXENT)*12
      INTEGER          IENTRY(MAXENT),JENTRY(MAXENT),KENTRY(MAXENT)
*----
*  Variables for CLE-2000
*----
      INTEGER          CLECST
      EXTERNAL         CLECST
      INTEGER          KERNEL
*----
*  Variables for module identification
*----
      INTEGER          NMODDG,NMODDJ,NMODXT
      PARAMETER       (NMODDG=26,NMODDJ=0,NMODXT=NMODDG+NMODDJ)
      CHARACTER        CMODXT(NMODXT)*12,NAMMOD*12
*----
*  Variables for Bickley and exponential integral functions
*----
      INTEGER          NBX,NBEX,NBICK
      DOUBLE PRECISION DX,DEX
      PARAMETER       (DX=0.02D0,NBX=600,NBICK=5,DEX=1.D0/512.D0,
     >                 NBEX=7936)
      INTEGER          IBICL,IEXP,MLOG(NBICK)
*----
*  Local variables
*----
      CHARACTER        NAMOUT*20
      INTEGER          IMODUL,NENTRY,ILEVEL,IPRINT,IOS,IBLANK,IBEAF
*----
*  Data
*----
      SAVE             IBICL,IEXP,MLOG,CMODXT
      DATA             IBICL
     >                /0/
      DATA             IEXP
     >                /0/
      DATA            MLOG
     >                /30,15,0,0,0/
      DATA             CMODXT
     >   /'ASM:        ','CFC:        ','CPO:        ','EDI:        ',
     >    'EVO:        ','EXCELL:     ','EXCELT:     ','FLU:        ',
     >    'GEO:        ','INFO:       ','JPMT:       ','LIB:        ',
     >    'MAC:        ','MOCC:       ','MRG:        ','PSP:        ',
     >    'SHI:        ','SYBILT:     ','HST:        ','SAD:        ',
     >    'PER:        ','MCU:        ','NXT:        ','TLM:        ',
     >    'SUS:        ','NDIST:      '/
*----
*  Initialisation of various variables
*----
      NAMOUT=' '
      IMODUL=0
      NENTRY=0
      ILEVEL= 0
      IPRINT= 0
      IOS=0
      IBLANK=0
      CALL XDRVER(IMVERS,ISVERS,IVDATE)
      WRITE(IOUT,6000) NAMSBR,IMVERS,ISVERS,(IVDATE(IYMD),IYMD=1,3)
*----
*  Uncomments for partial update
*----
      IVDATE(1)=2008
      IVDATE(2)=06
      IVDATE(3)=01
      WRITE(IOUT,6001) NAMSBR,IMVERS,ISVERS,'F ',
     >                (IVDATE(IYMD),IYMD=1,3)
      WRITE(IOUT,6010) NAMSBR
*----
*  Initialize Bickley functions common blocks
*----
      IF(IBICL .EQ. 0) THEN
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC0)
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC1)
        CALL SETARA(RBASE,2*NBICK*(NBX+1),IC2)
        CALL XDRKIN(DX,NBX,MLOG,RBASE(IC0),RBASE(IC1),RBASE(IC2))
        CALL RLSARA(RBASE(IC2))
        CALL RLSARA(RBASE(IC1))
        CALL RLSARA(RBASE(IC0))
        IBICL=1
      ENDIF
*----
*  Initialize exponential integral functions common blocks
*----
      IF(IEXP .EQ. 0) THEN
        CALL XDREXP(DEX,NBEX)
        IEXP=1
      ENDIF
*----
*  Infinite Loop over modules
*----
 100  CONTINUE
        IMODUL= KERNEL(CMODXT,NMODXT,ILEVEL,MAXENT,
     >                 CLECST,IPRINT,
     >                 NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*----
*  Run terminated when ILEVEL=0
*----
        IF(ILEVEL .EQ. 0) GO TO 105
        IF(IMODUL .LE. 0 .OR. IMODUL .GT. NMODXT) THEN
*----
*  Illegal module, abort
*----
          WRITE(IOUT,9000) NAMSBR,IMODUL
          CALL XABORT(NAMSBR//': KERNEL ERROR')
        ELSE
*----
*  Print before credit if required, then call appropriate module
*----
          NAMMOD=CMODXT(IMODUL)
          IF(IPRINT .NE. -314159) THEN
            IBEAF=1
            CALL XDRCRE(NAMMOD,IBEAF )
          ENDIF
*----
*  Call appropriate DRAGON module
*----
          IF     (NAMMOD .EQ.  'ASM:        ') THEN      
            CALL ASM   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'CFC:        ') THEN      
            CALL CFC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'CPO:        ') THEN      
            CALL CPO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'EDI:        ') THEN      
            CALL EDI   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'EVO:        ') THEN      
            CALL EVO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'EXCELL:     ') THEN      
            CALL XL3   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'EXCELT:     ') THEN      
            CALL EXCELT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'FLU:        ') THEN      
            CALL FLU   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'GEO:        ') THEN      
            CALL GEO   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'INFO:       ') THEN      
            CALL INF   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'JPMT:       ') THEN      
            CALL JPMT  (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'LIB:        ') THEN      
            CALL LIB   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'MAC:        ') THEN      
            CALL MAC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'MOCC:       ') THEN      
            CALL MOC   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'MRG:        ') THEN      
            CALL MRG   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'PSP:        ') THEN      
            CALL PSP   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'SHI:        ') THEN      
            CALL SHI   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'SYBILT:     ') THEN      
            CALL SYBILT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'HST:        ') THEN      
            CALL HST   (NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'SAD:        ') THEN      
            CALL SAD(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'PER:        ') THEN      
            CALL PER(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'MCU:        ') THEN      
            CALL MCU(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'NXT:        ') THEN      
            CALL NXT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'TLM:        ') THEN      
            CALL TLM(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'SUS:        ') THEN      
            CALL SUS(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ELSE IF(NAMMOD .EQ.  'NDIST:      ') THEN      
            CALL NDIST(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
          ENDIF
*----
*  Print after credit if required
*----
          IF(IPRINT .NE. -314159) THEN
            IBEAF=-1
            CALL XDRCRE(NAMMOD,IBEAF )
          ENDIF
*----
*  Return to process next module
*----
        ENDIF
      GO TO 100
*----
*  All modules processed, exit
*----
 105  CONTINUE
      WRITE(IOUT,6030) NAMSBR,IMVERS,ISVERS
      STOP
*----
*  FORMATS
*----
 6000 FORMAT(
     > ' DDDDDD   RRRRRR     AAA     GGGGG    OOOOO   NN     NN'/
     > ' DDDDDDD  RRRRRRR   AAAAA   GGGGGGG  OOOOOOO  NNN    NN'/
     > ' DD   DD  RR   RR  AA   AA  GG       OO   OO  NNNN   NN'/
     > ' DD   DD  RRRRRR   AA   AA  GG  GGG  OO   OO  NN NN  NN'/
     > ' DD   DD  RRRR     AAAAAAA  GG  GGG  OO   OO  NN  NN NN'/
     > ' DD   DD  RR RR    AAAAAAA  GG   GG  OO   OO  NN   NNNN'/
     > ' DDDDDDD  RR  RR   AA   AA  GGGGGGG  OOOOOOO  NN    NNN'/
     > ' DDDDDD   RR   RR  AA   AA   GGGGG    OOOOO   NN     NN'//
     > ' VERSION ',A6,I2,'.',I2.2,' (',I4,'/',I2.2,'/',I2.2,')'/
     > ' GROUPE D''ANALYSE NUCLEAIRE'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL'///)
 6001 FORMAT(' You are now using ',A6,1X,I2,'.',I2.2,
     >       ' Revision ',A2,' (',I4,'/',I2.2,'/',I2.2,')'//)
 6010 FORMAT(
     > ' COPYRIGHT NOTICE FOR THIS VERSION OF ',A6,':'/
     > ' --------------------------------------------'/
     > ' PERMISSION IS GRANTED TO THE PUBLIC TO COPY'/
     > ' DRAGON WITHOUT CHARGE PROVIDED THAT THIS'/
     > ' NOTICE IS REPRODUCED ON ALL COPIES.'/
     > ' ECOLE POLYTECHNIQUE DE MONTREAL MAKES NO'/
     > ' WARRANTY, EXPRESS OR IMPLIED, AND ASSUMES'/
     > ' NO LIABILITY OR RESPONSIBILITY FOR THE USE'/
     > ' OF DRAGON.'///)
 6030 FORMAT(//1X,'NORMAL END OF EXECUTION FOR ',A6,I2,'.',I2.2/
     >         1X,'CHECK FOR WARNING IN LISTING'/
     >         1x,'BEFORE ASSUMING YOUR RUN WAS SUCCESSFUL')
 9000 FORMAT('->@ERROR FROM KERNEL IN ',A6,' CODE = ',I10)
      END
