*DECK EDIMPR
      SUBROUTINE EDIMPR(NGROUP,NPROC ,MINLEG,MAXLEG,INDPRO,PERT  ,
     >                  XSREC ,XSSCT )
C
C---------------------------  EDIMPR  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIMPR
C      USE      : FIND CROSS SECTION FROM LINEAR EXPANSION
C      MODIFIED : 97-02-06 (G.M.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      NGROUP   : NUMBER OF GROUPS               I
C      NPROC    : NUMBER OF TERMS TO PROCESS     I
C      MINLEG   : MIMIMUM LEGENDRE ORDER TO      I
C                 PROCESS FOR SCATTERING
C      MAXLEG   : MIMIMUM LEGENDRE ORDER TO      I
C                 PROCESS FOR SCATTERING
C      INDPRO   : POINTER TO XS TYPE TO PROCESS  I(NPROC)
C      PERT     : TERM FOR PERTURBATION          R
C    OUTPUT
C      XSREC    : GENERAL XS                     R(NGROUP,NPROC,2)
C      XSSCT    : SCATTERING XS                  R(NGROUP,NGROUP,
C                                                  MAXLEG-MINLEG+1,2)
C
C---------------------------   EDIMPR  --------------------------------
C
      IMPLICIT          NONE
      INTEGER           IOUT,NDPROC
      CHARACTER         NAMSBR*6
      PARAMETER        (IOUT=6,NDPROC=20,NAMSBR='EDIMPR')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER           NGROUP,NPROC,MINLEG,MAXLEG
      INTEGER           INDPRO(NPROC)
      REAL              PERT,XSREC(NGROUP,NPROC,2),
     >                  XSSCT(NGROUP,NGROUP,MAXLEG-MINLEG+1,2)
C----
C  LOCAL PARAMETERS
C----
      INTEGER           IS,IGRC,ILSCAT,JGRC
C----
C  PROCESS VECTOR XS
C----
      DO 100 IS=1,NDPROC
        IF(INDPRO(IS).GT.0) THEN
          DO 101 IGRC=1,NGROUP
            XSREC(IGRC,IS,1)=XSREC(IGRC,IS,1)+XSREC(IGRC,IS,2)*PERT
 101      CONTINUE
        ENDIF
 100  CONTINUE
C----
C  PROCESS SCATTERING XS IF PRESENT
C----
      ILSCAT=0
      DO 120 IS=NDPROC+MINLEG+1,NDPROC+MAXLEG+1
        ILSCAT=ILSCAT+1
        IF(INDPRO(IS).GT.0) THEN
          DO 121 IGRC=1,NGROUP
            XSREC(IGRC,IS,1)=XSREC(IGRC,IS,1)+XSREC(IGRC,IS,2)*PERT
            DO 122 JGRC=1,NGROUP
              XSSCT(IGRC,JGRC,ILSCAT,1)=XSSCT(IGRC,JGRC,ILSCAT,1)+
     >                              XSSCT(IGRC,JGRC,ILSCAT,2)*PERT
 122        CONTINUE
 121      CONTINUE
        ENDIF
 120  CONTINUE
      RETURN
      END
