*DECK EDIPXS
      SUBROUTINE EDIPXS(IPEDIT,IPRINT,NSAVES,NGCOND,NMERGE,NL    ,
     >                  NIFISS,NEDMAC,NTAUXT,ILEAKS,NWGTH ,NTENER,
     >                  NBMICR,ITRANC,EIGENK,B2    ,ENERGY,VOLMER,
     >                  RATECM,SCATTD,EFISS ,DISFCT,NAMEAD,MATMC ,
     >                  FACT  ,TIMEF ,SPH   ,HVECT ,NAMFI ,MIXFI ,
     >                  MIXFF ,DIRC  ,NNTOTF,
     >                  SCATC ,DIFF  ,IJJ   ,NJJ   ,IPOS  ,IFGUPS,
     >                  XSFIS ,DLBDG )
C
C---------------------------  EDIPXS  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIPXS
C      USE      : EVALUATE PRINT CROSS SECTIONS
C      MODIFIED : 99-02-19 (G.M.)
C                 -> COMPUTE DIRECTIONAL WEIGHTING FACTOR TO
C                    CORRECT BUCKLING WEIGHTED ANISOTROPIC SCATTERING
C                 98-03-09 (G.M. + E.D.)
C                 -> CONSISTENT B1 HOMOGENIZATION FOR BUCKLING
C                    WEIGHTED ANISOTROPIC SCATTERING
C                 97-02-06 (G.M.)
C                 94-07-21 (G.M. + I.P.)
C                 91-12-04 (G.M.)
C                 91-04-03 (G.M.)
C                 89-08-24 (G.M.)
C                 88-10-25 (A.H.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IPEDIT   : POINTER TO THE EDIT                I
C      IPRINT   : PRINT LEVEL                        I
C                 = 0 NO PRINT
C                 = 1 PRINT FLUXES
C                 = 2 1+PRINT REACTION RATES
C                 = 3 2+PRINT HOMOGENIZED X-S
C      NSAVES   : HOMOGENIZED X-S COMPUTE, SAVE      I
C                 = 0  NO COMPUTE, NO SAVE
C                 = 1  COMPUTE, NO SAVE
C                 = 2  COMPUTE, SAVE
C                 = 3  COMPUTE, SAVE MICRO PERTURBATION
C      NGCOND   : NUMBER OF GROUPS CONDENSED         I
C      NMERGE   : NUMBER OF REGIONS MERGED           I
C      NL       : NUMBER OF LEGENDRE ORDERS          I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C      NEDMAC   : NUMBER OF EXTRA EDIT VECTORS       I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS      I
C      ILEAKS   : LEAK CALCULATION                   I
C                 = 0 NO LEAKAGE
C                 = 1 LEAKAGE BY SURFACE (ALBEDO>0.0)
C                 = 2 HOMOGENEOUS LEAKAGE COEFFICIENTS
C                 = 3 DIRECTIONAL LEAKAGE COEFFICIENTS
C      NWGTH    : P1 SCATTERING MERGE OPTION         I
C                 = 0 FLUX
C                 = 1 CURRENT
C                 = 2 BUCKLING-WEIGHTED COHERENT
C                 = 3 BUCKLING-WEIGHTED COHERENT
C                     AND DIRECTIONAL CORRECTION
C      NTENER   : NUMBER OF ENERGY GROUPS LIMITS     I
C      NBMICR   : TYPE OF MICRO EDIT                 I
C      ITRANC   : TYPE OF TRANSPORT CORRECTION       I
C      EIGENK   : EIGENVALUE FOR PROBLEM             R
C      B2       : SQUARE BUCKLING                    R(4)
C                 FOR ILEAKS = 2 B2(4) IS HOMOGENEOUS
C                 FOR ILEAKS = 3 B2(1),B2(2),B2(3)
C                 ARE DIRECTIONAL HETEROGENEOUS
C                 AND B2(4) IS HOMOGENEOUS
C      ENERGY   : ENERGY/LETHARGY GROUP LIMITS       R(2*NGCOND+1)
C      VOLMER   : VOLUME OF REGION MERGED            D(NMERGE)
C      RATECM   : AVERAGED REGION/GROUP X-S          D(0:NMERGE,
C                 = RATECM(*,1) = FLUXES             NGCOND,NTAUXT)
C                 = RATECM(*,2) = TOTAL
C                 = RATECM(*,3) = ABS
C                 = RATECM(*,4) = FISSIONS
C                 = RATECM(*,5) = PRODUCTIONS
C                 = RATECM(*,6) = TOTAL LEAKAGES
C                 = RATECM(*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,9) = CHI
C                 = RATECM(*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES  D(NMERGE,
C                                                      NGCOND,NGCOND,NL)
C      EFISS    : ENERGY PER FISSION             D(0:NMERGE,0:NIFISS+1)
C      DISFCT   : DISADVANTAGE FACTOR                R(NGCOND)
C      NAMEAD   : EXTRA EDIT NAMES                   I(2,NEDMAC)
C      MATMC    : MATERIAL PER MERGED REGION         I(NMERGE)
C      FACT     : NORMALIZATION VECTOR               R(NMERGE)
C      TIMEF    : TIME/BURNUP/IRRADIATION            R(3)
C                 STAMP IN DAYS FOR DIRECTORY
C      SPH      : SPH HOMOGENIZATION FACTORS         R(NMERGE,NGCOND)
C      HVECT    : EXTRA EDIT NAMES                   C(NEDMAC)*6
C      NAMFI    : NAME OF FISSILE ISOTOPE            I(2,NIFISS)
C      MIXFI    : MATERIAL OF FISSILE ISOTOPE        I(NIFISS)
C      MIXFF    : MATERIAL OF FISSILE ISOTOPE        I(NMERGE,NIFISS)
C      DIRC     : ADDED 99-02-19                     D(0:NMERGE,
C                 DIRECTIONAL CORRECTION               NGCOND,3)
C      NNTOTF   : FLAG FOR NFTOT                     I
C    WORK
C      SCATC    : COMPRESS SCATTERING                R(NMERGE*NGCOND)
C      DIFF     : DIFFUSION COEFFICIENTS             R(NGCOND)
C      IJJ      : POSITION OF FIRST DIFFUSION GROUP  I(NMERGE)
C      NJJ      : NUMBER OF DIFFUSION GROUP          I(NMERGE)
C      IPOS     : POSITION OF DIFFUSION GROUP        I(NMERGE)
C      IFGUPS   : FIRST GROUP WITH UP-SCATTERING     I(NMERGE,NL)
C      XSFIS    : WORK FISSION VECTOR                R(NMERGE,NIFISS)
C      DLBDG    : GROUP DEPENDENT LAMBDA             D(NGCOND)
C
C  3- INTERNAL PARAMETERS:
C
C      IOUT   : OUTPUT UNIT = 6                    I
C      CGRPNM   : GROUP INDEX NAME FOR LCM           C*12
C
C---------------------------   EDIPXS  --------------------------------
C
      IMPLICIT          NONE
      INTEGER           IOUT,NTC,ILCMUP,ILCMDN,NSTATE
      CHARACTER         NAMSBR*6
      PARAMETER        (IOUT=6,NTC=3,ILCMUP=1,ILCMDN=2,
     >                  NSTATE=40,NAMSBR='EDIPXS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER           IPEDIT,IPRINT,NSAVES,NGCOND,NMERGE,NL,
     >                  NIFISS,NEDMAC,NTAUXT,ILEAKS,NWGTH,NTENER,
     >                  NBMICR,ITRANC,NNTOTF
      CHARACTER         HVECT(NEDMAC)*6
      INTEGER           NAMEAD(2,NEDMAC),MATMC(NMERGE),
     >                  NAMFI(2,NIFISS),MIXFI(NIFISS),
     >                  MIXFF(NMERGE,NIFISS),IJJ(NMERGE),
     >                  NJJ(NMERGE),IPOS(NMERGE),IFGUPS(NMERGE,NL)
      REAL              EIGENK,B2(4),ENERGY(2*NGCOND+1),
     >                  DISFCT(NGCOND),FACT(NMERGE),TIMEF(3),
     >                  SPH(NMERGE,NGCOND),SCATC(NMERGE*NGCOND),
     >                  DIFF(NGCOND),XSFIS(NMERGE,NIFISS)
      DOUBLE PRECISION  VOLMER(NMERGE),RATECM(0:NMERGE,NGCOND,NTAUXT),
     >                  SCATTD(NMERGE,NGCOND,NGCOND,NL),
     >                  EFISS(0:NMERGE,0:NIFISS+1),
     >                  DIRC(0:NMERGE,NGCOND,3),
     >                  DLBDG(NGCOND)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER         HSIGN*12,CM*2,CGRPNM*12,NDC*4
      INTEGER           ISTATE(NSTATE),KCHAR(NTC),ILFI,ILFT,ILCH,
     >                  ILSC,ILED,ILOV,IMRG,IGRC,JGRC,IFIS,IL,NFFI,
     >                  JRAT,IPOSIT,J1,J2,JFIS,IDIR,IED,ITC,NKFI
      REAL              ZNU,DEN,FLXAVG
      DOUBLE PRECISION  SCATTN,TOTCHI,TOTFIS,DFACT,DFACTJ,
     >                  DXFACT,DYFACT,DTOTL,DFLUX,B2TOT
C----
C  INITIALIZE STATE VECTOR
C----
      CALL XDISET(ISTATE,NSTATE,0)
      ILFI=13
      ILCH=ILFI+NIFISS
      ILFT=ILCH+NIFISS
      ILSC=ILFT+NIFISS
      ILED=ILSC+NL
      ILOV=ILED+NEDMAC+1
C----
C  COMPUTE MERGED/CONDENSED X-S
C----
      IF(NSAVES .GE. 1) THEN
C----
C  FIND IF TOTAL PRODUCTION OR TOTAL FISSION DIFFERENT FROM 0
C----
        TOTCHI=0.0D0
        TOTFIS=0.0D0
        DO 100 IGRC=1,NGCOND
          DO 101 IMRG=1,NMERGE
            TOTCHI=TOTCHI+RATECM(IMRG,IGRC,4)
            TOTFIS=TOTFIS+RATECM(IMRG,IGRC,9)
 101      CONTINUE
 100    CONTINUE
        IF(TOTCHI .EQ. 0.0D0 .AND. TOTFIS .EQ. 0.0D0) THEN
          NFFI=0
          NKFI=0
        ELSE
          NKFI=0
          DO 110 IFIS=1,NIFISS
            DO 111 IMRG=1,NMERGE
              IF(MIXFF(IMRG,IFIS) .NE. 0) THEN
                NKFI=NKFI+1
                MIXFI(NKFI)=IFIS
                NAMFI(1,NKFI)=NAMFI(1,IFIS)
                NAMFI(2,NKFI)=NAMFI(2,IFIS)
                GO TO 115
              ENDIF
 111        CONTINUE
 115        CONTINUE
 110      CONTINUE
          IF(NBMICR .LE. -1) THEN
            NFFI=NKFI
          ELSE
            MIXFI(1)=1
            NFFI=-1
          ENDIF
        ENDIF
C----
C  COMPUTE GROUP DEPENDENT LAMBDA
C----
        CALL XDDSET(DLBDG,NGCOND,0.0D0)
        IF(NWGTH .GT. 1) THEN
          DO 116 IGRC=1,NGCOND
            DFLUX=0.0D0
            DTOTL=0.0D0
            DO 117 IMRG=1,NMERGE
              DFLUX=DFLUX+RATECM(IMRG,IGRC,1)
              DTOTL=DTOTL+RATECM(IMRG,IGRC,2)
 117        CONTINUE
            IF(DFLUX .NE. 0.0D0) THEN
              DTOTL=DTOTL/DFLUX
              DLBDG(IGRC)=DTOTL
              CALL EDILBD(1,DLBDG(IGRC),B2(4))
              DLBDG(IGRC)=1.0D0/DLBDG(IGRC)
            ELSE
              DLBDG(IGRC)=1.0D0
            ENDIF
 116      CONTINUE
        ENDIF
C----
C  STANDARD CROSS SECTIONS
C----
        DO 120 IGRC=1,NGCOND
          DO 121 IMRG=1,NMERGE
            DFACT=0.0D0
            IF(RATECM(IMRG,IGRC,1) .NE. 0.0D0)
     >        DFACT=1.0/RATECM(IMRG,IGRC,1)
            RATECM(IMRG,IGRC,2)=RATECM(IMRG,IGRC,2)*DFACT
            RATECM(IMRG,IGRC,3)=RATECM(IMRG,IGRC,3)*DFACT
            RATECM(IMRG,IGRC,4)=RATECM(IMRG,IGRC,4)*DFACT
            RATECM(IMRG,IGRC,5)=RATECM(IMRG,IGRC,5)*DFACT
            IF(NTENER .GT. 0)
     >        RATECM(IMRG,IGRC,ILOV)=RATECM(IMRG,IGRC,ILOV)*DFACT
              RATECM(IMRG,IGRC,10)=RATECM(IMRG,IGRC,10)*DFACT
            IF(NFFI .LT. 0) THEN
              DO 122 IFIS=1,NIFISS
                JRAT=ILFI+IFIS
                RATECM(IMRG,IGRC,JRAT)=RATECM(IMRG,IGRC,JRAT)*DFACT
                JRAT=ILFT+IFIS
                RATECM(IMRG,IGRC,JRAT)=RATECM(IMRG,IGRC,JRAT)*DFACT
 122          CONTINUE
            ELSE
              DO 124 IFIS=1,NKFI
                JRAT=ILFI+MIXFI(IFIS)
                RATECM(IMRG,IGRC,JRAT)=RATECM(IMRG,IGRC,JRAT)*DFACT
                JRAT=ILFT+MIXFI(IFIS)
                RATECM(IMRG,IGRC,JRAT)=RATECM(IMRG,IGRC,JRAT)*DFACT
 124          CONTINUE
            ENDIF
            RATECM(IMRG,IGRC,8)=SCATTD(IMRG,IGRC,IGRC,1)
            DO 123 IED=1,NEDMAC
              RATECM(IMRG,IGRC,ILED+IED)=
     >          RATECM(IMRG,IGRC,ILED+IED)*DFACT
 123        CONTINUE
 121      CONTINUE
C----
C  SCATTERING CORRECTIONS
C----
          DO 130 IMRG=1,NMERGE
            DFACT=0.0D0
            IF(RATECM(IMRG,IGRC,1) .NE. 0.0D0)
     >        DFACT=1.0/RATECM(IMRG,IGRC,1)
            DFACTJ=DFACT
            DXFACT=0.0D0
            DYFACT=0.0D0
            B2TOT=1.0D0
C----
C  COMPUTE DXFACT, DYFACT AND DFACTJ FOR CASE WHERE
C  B1 HETEREGENEOUS IS USED
C----
            IF(ILEAKS .EQ. 2 .AND. NL .GE. 2) THEN
              B2TOT=B2(4)
              IF(NWGTH .EQ. 1) THEN
                DFACTJ=(RATECM(IMRG,IGRC,11)
     >                 +RATECM(IMRG,IGRC,12)
     >                 +RATECM(IMRG,IGRC,13))*B2TOT
                IF(DFACTJ .NE. 0.0D0) DFACTJ=1.0D0/DFACTJ
              ENDIF
            ELSE IF(ILEAKS .EQ. 3 .AND. NL .GE. 2) THEN
              B2TOT=B2(1)+B2(2)+B2(3)
              IF(NWGTH .GT. 0) THEN
                DFACTJ=RATECM(IMRG,IGRC,11)*B2(1)+
     >                 RATECM(IMRG,IGRC,12)*B2(2)+
     >                 RATECM(IMRG,IGRC,13)*B2(3)
                IF(DFACTJ .NE. 0.0D0) DFACTJ=1.0D0/DFACTJ
                IF(NWGTH .GT. 1) THEN
                  DXFACT=1.0D0
                  DYFACT=DBLE(SPH(IMRG,IGRC))
                  DYFACT=DYFACT*DYFACT
                  DYFACT=(DYFACT-1.0D0)
     >                   *RATECM(IMRG,IGRC,1)*DFACTJ
     >                   *B2TOT/3.0D0
                ENDIF
              ENDIF
            ENDIF
            DO 131 IL=1,NL
              IF(IL .EQ. 2) THEN
                RATECM(IMRG,IGRC,ILSC+IL)=
     >           RATECM(IMRG,IGRC,ILSC+IL)*DFACTJ
     >          +(RATECM(IMRG,IGRC,2)*DLBDG(IGRC)+DYFACT)*DXFACT
                DO 132 IDIR=1,3
                  DIRC(IMRG,IGRC,IDIR)=
     >                DIRC(IMRG,IGRC,IDIR)
     >                +(RATECM(IMRG,IGRC,2)*DLBDG(IGRC)+DYFACT)
     >                 *DXFACT*RATECM(IMRG,IGRC,10+IDIR)
 132            CONTINUE
              ELSE
                RATECM(IMRG,IGRC,ILSC+IL)=RATECM(IMRG,IGRC,ILSC+IL)
     >                                   *DFACT
              ENDIF
 131        CONTINUE
            DO 133 JGRC=1,NGCOND
              DO 134 IL=1,NL
                IF(IL .EQ. 2 .AND. IGRC .EQ. JGRC) THEN
                  SCATTD(IMRG,JGRC,IGRC,IL)=
     >              SCATTD(IMRG,JGRC,IGRC,IL)*DFACTJ
     >            +(RATECM(IMRG,IGRC,2)*DLBDG(IGRC)+DYFACT)*DXFACT
                ELSEIF(IL .EQ. 2 .AND .IGRC .NE. JGRC) THEN
                  SCATTD(IMRG,JGRC,IGRC,IL)=
     >              SCATTD(IMRG,JGRC,IGRC,IL)*DFACTJ
                ELSE
                  SCATTD(IMRG,JGRC,IGRC,IL)=SCATTD(IMRG,JGRC,IGRC,IL)
     >                                     *DFACT
                ENDIF
 134          CONTINUE
 133        CONTINUE
 130      CONTINUE
 120    CONTINUE
C----
C  99-02-19
C  COMPUTE DIRECTIONAL CORRECTION FOR ANISOTROPIC SCATTERING
C----
        IF(NWGTH .EQ. 3) THEN
          IL=2
          DO 140 IGRC=1,NGCOND
            DO 142 IMRG=1,NMERGE
              DO 142 IDIR=1,3
                DFACT=RATECM(IMRG,IGRC,10+IDIR)
                IF(DFACT .NE. 0.0D0)
     >            DFACT=1.0/DFACT
                DO 143 JGRC=1,NGCOND
                  DIRC(IMRG,IGRC,IDIR)=DIRC(IMRG,IGRC,IDIR)
     >            -RATECM(IMRG,JGRC,10+IDIR)*SCATTD(IMRG,IGRC,JGRC,IL)
 143            CONTINUE
                DIRC(IMRG,IGRC,IDIR)=DIRC(IMRG,IGRC,IDIR)*DFACT
 142          CONTINUE
 141        CONTINUE
 140      CONTINUE
        ENDIF
        IF(ILEAKS .EQ. 2) THEN
          DO 150 IGRC=1,NGCOND
            ZNU=0.0
            DEN=0.0
            DO 151 IMRG=1,NMERGE
              DFACT=0.0D0
              IF(RATECM(IMRG,IGRC,1) .NE. 0.0D0)
     >          DFACT=1.0/RATECM(IMRG,IGRC,1)
              ZNU=ZNU+RATECM(IMRG,IGRC,6)
              DEN=DEN+RATECM(IMRG,IGRC,1)
              RATECM(IMRG,IGRC,6)=RATECM(IMRG,IGRC,6)*DFACT
 151        CONTINUE
            DIFF(IGRC)=ZNU/DEN
 150      CONTINUE
        ELSE IF(ILEAKS .EQ. 3) THEN
          DO 152 IGRC=1,NGCOND
            DO 153 IMRG=1,NMERGE
              DFACT=0.0D0
              IF(RATECM(IMRG,IGRC,1) .NE. 0.0D0)
     >          DFACT=1.0/RATECM(IMRG,IGRC,1)
              RATECM(IMRG,IGRC,6)=RATECM(IMRG,IGRC,6)*DFACT
              RATECM(IMRG,IGRC,11)=RATECM(IMRG,IGRC,11)*DFACT
              RATECM(IMRG,IGRC,12)=RATECM(IMRG,IGRC,12)*DFACT
              RATECM(IMRG,IGRC,13)=RATECM(IMRG,IGRC,13)*DFACT
 153        CONTINUE
 152      CONTINUE
        ENDIF
C----
C  COMPUTE ABSORPTION FROM TOTAL IN RATECM(IMRG,IGRC,3)
C  AND SCATTD(IMRG,JGRC,IGRC,1)
C----
        DO 156 IGRC=1,NGCOND
          DO 157 IMRG=1,NMERGE
            DFACT=0.0D0
            DO 158 JGRC=1,NGCOND
              DFACT=DFACT+SCATTD(IMRG,JGRC,IGRC,1)
 158        CONTINUE
            RATECM(IMRG,IGRC,7)=DFACT
            RATECM(IMRG,IGRC,3)=RATECM(IMRG,IGRC,3)-DFACT
 157      CONTINUE
 156    CONTINUE
        IF(NSAVES .EQ. 2) THEN
C----
C  SAVE MERGED/CONDENSED X-S ON LCM
C----
          CALL XDISET(IFGUPS,NMERGE*NL,NGCOND+1)
          CALL LCMSIX(IPEDIT,'MACROLIB',ILCMUP)
          CALL LCMPUT(IPEDIT,'TIMESTAMP',3,2,TIMEF)
          ISTATE(1)=NGCOND
          ISTATE(2)=NMERGE
          ISTATE(3)=NL
          ISTATE(4)=ABS(NFFI)
          ISTATE(5)=NEDMAC
          ISTATE(6)=ITRANC
          IF(NEDMAC .GT. 0) THEN
            CALL LCMPUT(IPEDIT,'ADDXSNAME',2*NEDMAC,3,NAMEAD)
          ENDIF
          IF(NFFI .NE. 0) THEN
            CALL LCMPUT(IPEDIT,'FISSIONNAMES',2*ABS(NFFI),3,NAMFI)
C----
C  COMPRESS FISSION NUMBER MATRIX
C----
            DO 160 IFIS=1,ABS(NFFI)
              JFIS=MIXFI(IFIS)
              DO 161 IMRG=1,NMERGE
                MIXFF(IMRG,IFIS)=MIXFF(IMRG,JFIS)
 161          CONTINUE
 160        CONTINUE
            IF(NFFI .LT. 0) THEN
              DO 162 IMRG=1,NMERGE
                XSFIS(IMRG,1)=EFISS(IMRG,0)
 162          CONTINUE
            ELSE
              DO 163 IFIS=1,NFFI
                JFIS=MIXFI(IFIS)
                DO 164 IMRG=1,NMERGE
                  MIXFF(IMRG,IFIS)=MIXFF(IMRG,JFIS)
                  XSFIS(IMRG,IFIS)=EFISS(IMRG,JFIS)
 164            CONTINUE
 163          CONTINUE
            ENDIF
            CALL LCMPUT(IPEDIT,'FISSIONNB',NMERGE*ABS(NFFI),1,MIXFF)
            CALL LCMPUT(IPEDIT,'EFISS',NMERGE*ABS(NFFI),2,XSFIS)
          ENDIF
          DO 170 IGRC=1,NGCOND
            WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGRC,NGCOND
            CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
            IF(NEDMAC .GT. 0) THEN
              DO 171 IED=1,NEDMAC
                CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,IED+ILED),1)
                CALL LCMPUT(IPEDIT,HVECT(IED),NMERGE,2,FACT)
 171          CONTINUE
            ENDIF
            IF(NTENER .GT. 0) THEN
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,ILOV),1)
              CALL LCMPUT(IPEDIT,'OVERV',NMERGE,2,FACT)
            ENDIF
            CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,2),1)
            CALL LCMPUT(IPEDIT,'TOTAL',NMERGE,2,FACT)
            CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,3),1)
            CALL LCMPUT(IPEDIT,'ABS',NMERGE,2,FACT)
            CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,5),1)
            CALL LCMPUT(IPEDIT,'PRODUCTION',NMERGE,2,FACT)
            IF(NFFI .LT. 0) THEN
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,4),1)
              CALL LCMPUT(IPEDIT,'NUSIGF',NMERGE,2,FACT)
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,9),1)
              CALL LCMPUT(IPEDIT,'CHI',NMERGE,2,FACT)
              DO 172 IMRG=1,NMERGE
                DFACT=0.0D0
                DO 173 IFIS=1,NIFISS
                  JRAT=ILFT+IFIS
                  DFACT=DFACT+RATECM(IMRG,IGRC,JRAT)
 173            CONTINUE
                FACT(IMRG)=DFACT
 172          CONTINUE
              CALL LCMPUT(IPEDIT,'NFTOT',NMERGE,2,FACT)
            ELSE IF(NFFI .GT. 0) THEN
              DO 174 IFIS=1,NFFI
                JRAT=ILFI+MIXFI(IFIS)
                DO 175 IMRG=1,NMERGE
                  XSFIS(IMRG,IFIS)=RATECM(IMRG,IGRC,JRAT)
 175            CONTINUE
 174          CONTINUE
              CALL LCMPUT(IPEDIT,'NUSIGF',NMERGE*NFFI,2,XSFIS)
              DO 176 IFIS=1,NFFI
                JRAT=ILCH+MIXFI(IFIS)
                DO 177 IMRG=1,NMERGE
                  XSFIS(IMRG,IFIS)=RATECM(IMRG,IGRC,JRAT)
 177            CONTINUE
 176          CONTINUE
              CALL LCMPUT(IPEDIT,'CHI',NMERGE*NFFI,2,XSFIS)
              IF(NNTOTF .EQ. 1) THEN
                DO 178 IFIS=1,NFFI
                  JRAT=ILFT+MIXFI(IFIS)
                  DO 179 IMRG=1,NMERGE
                    XSFIS(IMRG,IFIS)=RATECM(IMRG,IGRC,JRAT)
 179              CONTINUE
 178            CONTINUE
                CALL LCMPUT(IPEDIT,'NFTOT',NMERGE*NFFI,2,XSFIS)
              ENDIF
            ENDIF
            CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,10),1)
            CALL LCMPUT(IPEDIT,'TRANC',NMERGE,2,FACT)
            IF(ILEAKS .EQ. 2) THEN
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,6),1)
              CALL LCMPUT(IPEDIT,'DIFFHOM',NMERGE,2,FACT)
            ELSE IF(ILEAKS .EQ. 3) THEN
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,6),1)
              CALL LCMPUT(IPEDIT,'DIFFHOM',NMERGE,2,FACT)
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,11),1)
              CALL LCMPUT(IPEDIT,'DIFFX',NMERGE,2,FACT)
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,12),1)
              CALL LCMPUT(IPEDIT,'DIFFY',NMERGE,2,FACT)
              CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,13),1)
              CALL LCMPUT(IPEDIT,'DIFFZ',NMERGE,2,FACT)
            ENDIF
            CALL XDRSDB(NMERGE,FACT,RATECM(1,IGRC,1),1)
            CALL LCMPUT(IPEDIT,'FLUX-INTG',NMERGE,2,FACT)
            DO 180 IL=1,NL
              WRITE (CM,'(I2)') IL-1
              IPOSIT=0
              DO 181 IMRG=1,NMERGE
                J2=IGRC
                J1=IGRC
                DO 182 JGRC=1,NGCOND
                  IF(SCATTD(IMRG,IGRC,JGRC,IL) .NE. 0.0D0) THEN
                    J2=MAX(J2,JGRC)
                    J1=MIN(J1,JGRC)
                  ENDIF
 182            CONTINUE
                NJJ(IMRG)=J2-J1+1
                IJJ(IMRG)=J2
                IF(J2 .GT. IGRC) THEN
                  IFGUPS(IMRG,IL)=MIN(IFGUPS(IMRG,IL),IGRC)
                ENDIF
                IPOS(IMRG)=IPOSIT+1
                DO 183 JGRC=J2,J1,-1
                  IPOSIT=IPOSIT+1
                  SCATC(IPOSIT)=SCATTD(IMRG,IGRC,JGRC,IL)
 183            CONTINUE
 181          CONTINUE
              CALL XDRSDB(NMERGE,FACT,SCATTD(1,IGRC,IGRC,IL),1)
              CALL LCMPUT(IPEDIT,'SIGW'//CM,NMERGE,2,FACT)
              CALL LCMPUT(IPEDIT,'SCAD'//CM,IPOSIT,2,SCATC)
              CALL LCMPUT(IPEDIT,'NJJD'//CM,NMERGE,1,NJJ)
              CALL LCMPUT(IPEDIT,'IJJD'//CM,NMERGE,1,IJJ)
              CALL LCMPUT(IPEDIT,'IPOD'//CM,NMERGE,1,IPOS)
              IPOSIT=0
              DO 184 IMRG=1,NMERGE
                J2=IGRC
                J1=IGRC
                DO 185 JGRC=1,NGCOND
                  IF(SCATTD(IMRG,JGRC,IGRC,IL) .NE. 0.0D0) THEN
                    J2=MAX(J2,JGRC)
                    J1=MIN(J1,JGRC)
                  ENDIF
 185            CONTINUE
                NJJ(IMRG)=J2-J1+1
                IJJ(IMRG)=J2
                IPOS(IMRG)=IPOSIT+1
                DO 186 JGRC=J2,J1,-1
                  IPOSIT=IPOSIT+1
                  SCATC(IPOSIT)=SCATTD(IMRG,JGRC,IGRC,IL)
 186            CONTINUE
 184          CONTINUE
              CALL LCMPUT(IPEDIT,'SCAA'//CM,IPOSIT,2,SCATC)
              CALL LCMPUT(IPEDIT,'NJJA'//CM,NMERGE,1,NJJ)
              CALL LCMPUT(IPEDIT,'IJJA'//CM,NMERGE,1,IJJ)
              CALL LCMPUT(IPEDIT,'IPOA'//CM,NMERGE,1,IPOS)
C----
C  99-02-19
C  SAVE DIRECTIONAL CORRECTION FOR ANISOTROPIC SCATTERING
C----
              IF(NWGTH .EQ. 3 .AND. IL .EQ. 2) THEN
                DO 187 IDIR=1,3
                  WRITE(NDC,'(2HDC,I2)') IDIR
                  CALL XDRSDB(NMERGE,FACT,DIRC(1,IGRC,IDIR),1)
                  CALL LCMPUT(IPEDIT,NDC,NMERGE,2,FACT)
 187            CONTINUE
              ENDIF
 180        CONTINUE
            CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
 170      CONTINUE
          IF(ILEAKS .EQ. 2) THEN
            CALL LCMPUT(IPEDIT,'DIFFB1HOM',NGCOND,2,DIFF)
            CALL LCMPUT(IPEDIT,'B2  B1HOM',1,2,B2(4))
          ELSE IF(ILEAKS .EQ. 3) THEN
            CALL LCMPUT(IPEDIT,'B2  B1HOM',1,2,B2(4))
            CALL LCMPUT(IPEDIT,'B2  HETE',3,2,B2)
          ENDIF
          ISTATE(7)=0
          ISTATE(8)=0
          ISTATE(9)=ILEAKS
          CALL LCMPUT(IPEDIT,'FGWITHUPSCAT',NMERGE*NL,1,IFGUPS)
          CALL LCMPUT(IPEDIT,'STATE-VECTOR',NSTATE,1,ISTATE)
          HSIGN='L_MACROLIB'
          READ(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
          CALL LCMPUT(IPEDIT,'SIGNATURE',3,3,KCHAR)
          IF(NTENER .GT. 0) THEN
            CALL LCMPUT(IPEDIT,'ENERGY',NGCOND+1,2,ENERGY)
            CALL LCMPUT(IPEDIT,'DELTAU',NGCOND,2,ENERGY(NGCOND+2))
          ENDIF
          CALL XDRSDB(NMERGE,FACT,VOLMER,1)
          CALL LCMPUT(IPEDIT,'VOLUME',NMERGE,2,FACT)
          CALL LCMPUT(IPEDIT,'MATCOD',NMERGE,1,MATMC)
          CALL LCMPUT(IPEDIT,'KEYFLX',NMERGE,1,MATMC)
          IF((EIGENK .NE. 0.0) .AND. (NIFISS .GT. 0)) THEN
            CALL LCMPUT(IPEDIT,'K-EFFECTIVE',1,2,EIGENK)
          ENDIF
          CALL LCMPUT(IPEDIT,'FLUXDISAFACT',NGCOND,2,DISFCT)
          CALL LCMSIX(IPEDIT,'MACROLIB',ILCMDN)
        ENDIF
      ENDIF
C----
C  PRINT X-S
C----
      IF(IPRINT .GE. 5) THEN
        WRITE(IOUT,6000)
        DO 190 IGRC=1,NGCOND
          IF(ILEAKS .EQ. 2) THEN
            WRITE(IOUT,6020) IGRC
          ELSE
            WRITE(IOUT,6021) IGRC
          ENDIF
          DO 191 IMRG=1,NMERGE
            IF (RATECM(IMRG,IGRC,1) .NE. 0.0D0) THEN
              FLXAVG=RATECM(IMRG,IGRC,1)/VOLMER(IMRG)
              SCATTN=0.0D0
              DO 192 JGRC=1,NGCOND
                IF(JGRC .NE. IGRC)
     >           SCATTN=SCATTN+SCATTD(IMRG,JGRC,IGRC,1)
 192          CONTINUE
              IF(ILEAKS .EQ. 2) THEN
                WRITE(IOUT,6022) IMRG,FLXAVG,RATECM(IMRG,IGRC,2),
     >          RATECM(IMRG,IGRC,10),RATECM(IMRG,IGRC,6),
     >          RATECM(IMRG,IGRC,3),RATECM(IMRG,IGRC,4),
     >          RATECM(IMRG,IGRC,9),SCATTD(IMRG,IGRC,IGRC,1),SCATTN
              ELSE
                WRITE(IOUT,6022) IMRG,FLXAVG,RATECM(IMRG,IGRC,2),
     >          RATECM(IMRG,IGRC,10),RATECM(IMRG,IGRC,3),
     >          RATECM(IMRG,IGRC,4),RATECM(IMRG,IGRC,9),
     >          SCATTD(IMRG,IGRC,IGRC,1),SCATTN
              ENDIF
            ENDIF
 191      CONTINUE
          IF(ILEAKS .EQ. 3) THEN
            WRITE(IOUT,6024)
            DO 193 IMRG=1,NMERGE
              WRITE(IOUT,6025) IMRG,RATECM(IMRG,IGRC,11),
     >        RATECM(IMRG,IGRC,12),RATECM(IMRG,IGRC,13),
     >        RATECM(IMRG,IGRC,6)
 193        CONTINUE
            IF(NWGTH .EQ. 3) THEN
              WRITE(IOUT,6030)
              DO 194 IMRG=1,NMERGE
                WRITE(IOUT,6031) IMRG,DIRC(IMRG,IGRC,1),
     >          DIRC(IMRG,IGRC,2),DIRC(IMRG,IGRC,3)
 194          CONTINUE
            ENDIF
          ENDIF
          WRITE(IOUT,6026) DISFCT(IGRC)
 190    CONTINUE
      ENDIF
      IF(IPRINT .GE. 10) THEN
        DO 200 IL= 1,NL
          DO 201 IMRG=1,NMERGE
            WRITE(IOUT,6027) IL-1,IMRG,(JGRC,JGRC=1,NGCOND)
            DO 202 IGRC=1,NGCOND
              WRITE(IOUT,6028) IGRC,(SCATTD(IMRG,JGRC,IGRC,IL),
     >          JGRC=1,NGCOND)
 202        CONTINUE
 201      CONTINUE
 200    CONTINUE
        WRITE (IOUT,'(//)')
      ENDIF
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(/' F L U X E S   A N D   H O M O G E N I Z E D   X - S'/
     > 1X,51(1H-))
 6020 FORMAT(/' G R O U P   : ',I3/
     >' REGION     AVERAGE       TOTAL   TRANSPORT   DIFFUSION ',
     >' ABSORPTION      NUSIGF     FISSION      SCATTERING X-S    '/
     >'               FLUX         X-S  CORRECTION COEFFICIENT ',
     >'        X-S         X-S    SPECTRUM    IN GROUP  FROM GROUP')
 6021 FORMAT(/' G R O U P   : ',I3/
     >' REGION     AVERAGE       TOTAL   TRANSPORT  ABSORPTION  ',
     >'    NUSIGF     FISSION      SCATTERING X-S    '/
     >'               FLUX         X-S  CORRECTION         X-S  ',
     >'       X-S    SPECTRUM    IN GROUP  FROM GROUP')
 6022 FORMAT(1X,I6,1P,9E12.4)
 6024 FORMAT(/' REGION     X-LEAKAGE     Y-LEAKAGE     Z-LEAKAGE',
     >'   HOM-LEAKAGE'/'           COEFFICIENT   COEFFICIENT   ',
     >'COEFFICIENT   COEFFICIENT')
 6025 FORMAT(1X,I6,1X,1P,5E14.5)
 6026 FORMAT(/' FLUX DISADVANTAGE FACTOR =',1P,E14.5)
 6027 FORMAT(/' SCATTERING MATRIX'/
     > ' ORDER OF LEGENDRE: ',I2/
     > ' SCATTERING TRANSFER X-S (I TOWARD J) IN REGION',I5,1H:
     > //(11X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,
     > I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,2HJ=,I4,:,6X,
     > 2HJ=,I4))
 6028 FORMAT(3H I=,I4,2H: ,1P,10E12.4/(9X,10E12.4))
 6030 FORMAT(/' REGION     SCAT-1-CX     SCAT-1-CY     SCAT-1-CZ')
 6031 FORMAT(1X,I6,1X,1P,3E14.5)
      END
