*DECK EDITIS
      SUBROUTINE EDITIS(MAXISO,NBISO ,NBMICR,ISONAM,ISOCAR)
C
C-------------------------    EDITIS    -------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDITIS
C      USE      : TEST IF ISOTOPES FOR MICROSCOPIC XS PRESENT
C      MODIFIED : 97-05-26 (G.M.)
C      AUTHOR   : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT:
C      MAXISO   : MAXIMUM NUMBER OF ISOTOPES             I
C      NBISO    : NUMBER OF ISOTOPES                     I
C      NBMICR   : <-1: GENERATE FULL XS LIBRARY          I
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      (-NBMICR-1) SELECTED ISOTOPES
C                 >1:  PROCESS (NBMICR-1)
C                      SELECTED ISOTOPES
C      ISONAM   : NAMES OF THE LIBRARY ISOTOPES          I(3,MAXISO)
C    OUTPUT:
C      NBMICR   : <-1: GENERATE FULL XS LIBRARY          I
C                      INCLUDING DEPLETION CHAIN AND
C                      INDEPENDANT FISSION SPECTRUM FOR
C                      (-NBMICR-1) SELECTED ISOTOPES
C                 >1:  PROCESS (NBMICR-1)
C                      SELECTED ISOTOPES
C      ISOCAR   : NAMES OF THE ISOTOPES TO PROCESS       I(2,MAXISO)
C
C---------------------------   EDITIS  --------------------------------
C
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='EDITIS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          MAXISO,NBISO,NBMICR
      INTEGER          ISONAM(3,MAXISO),ISOCAR(2,MAXISO)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          NBSCAN,JSCAN,ISCAN,ISO,ITC
      NBSCAN=ABS(NBMICR)-1
      JSCAN=0
      DO 100 ISCAN=1,NBSCAN
        DO 110 ISO=1,NBISO
          IF(ISOCAR(1,ISCAN) .EQ. ISONAM(1,ISO).AND.
     >       ISOCAR(2,ISCAN) .EQ. ISONAM(2,ISO)) THEN
            JSCAN=JSCAN+1
            ISOCAR(1,JSCAN)=ISOCAR(1,ISCAN)
            ISOCAR(2,JSCAN)=ISOCAR(2,ISCAN)
            GO TO 115
          ENDIF
 110    CONTINUE
        WRITE(IOUT,9000) NAMSBR,(ISOCAR(ITC,ISCAN),ITC=1,2)
 115    CONTINUE
 100  CONTINUE
      IF(JSCAN .EQ. 0) THEN
        NBMICR=0
      ELSE IF(NBMICR .GT. 0) THEN
        NBMICR=JSCAN+1
      ELSE
        NBMICR=-JSCAN-1
      ENDIF
      RETURN
C----
C  WARNING FORMATS
C----
 9000 FORMAT(1X,A6,': ****** WARNING ******'/
     >       ' IMPOSSIBLE TO LOCATE ISOTOPE =  ',2A4/
     >       ' **************************')
      END
