*DECK FLUAQS
      SUBROUTINE FLUAQS(IPMACR,IPSYS ,NGROUP,NBMIX ,NREGIO,NUNKNO,
     >                  MATCOD,KEYFLX,FUNKNO,SUNKNO,
     >                  IJJ   ,NJJ   ,IPOS  ,XSCAT ,XSA   )
*
*---------------------------  FLUAQS  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*      NAME     : FLUAQS
*      USE      : ADD TO SOURCE $Q$ CONTRIBUTIONS FROM SCATTERING 
*      MODIFIED : 2003/03/12 (G. MARLEAU)
*
*   2- ROUTINE PARAMETERS:
*    INPUT:
*      IPMACR   : POINTER TO THE MACROLIB              I
*      IPSYS    : POINTER TO THE SYSTEM                I
*      NGROUP   : NUMBER OF GROUPS.                    I
*      NBMIX    : NUMBER OF MIXTURES.                  I
*      NREGIO   : NUMBER OF REGIONS.                   I
*      NUNKNO   : NUMBER OF UNKNOWN IN THE SYSTEM.     I
*      MATCOD   : MATERIAL CODE IN REGIONS.            I(NREGIO)
*      KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM.     I(NREGIO)
*      FUNKNO   : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
*    OUTPUT:
*      SUNKNO   : SOURCE FOR SYSTEM OF UNKNOWN.        R(NUNKNO,NGROUP)
*    WORK:
*      IJJ      : LAST SCATTERING GROUP                I(0:NBMIX)
*                 IJJ(0) = 0
*      NJJ      : NUMBER OF SCATTERING GROUP           I(0:NBMIX)
*                 NJJ(0) = -NGROUP
*      IPOS     : POSITION SELF SCATTERING IN XSCAT    I(0:NBMIX)
*                 IPOS(0)= NGROUP+1
*      XSCAT    : SCATTERING VECTOR                    R(0:NBMIX*NGROUP)
*                 XSCAT(0) = 0.0
*      XSA      : Transport corrected diagonal         R(0:NBMIX)
*                 scattering
*
*---------------------------   FLUAQS  --------------------------------
*
      IMPLICIT         NONE
      INTEGER          IOUT,ILCMUP,ILCMDN
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='FLUAQS')
*----
*  ROUTINE PARAMETERS
*----
      INTEGER          IPMACR,IPSYS,NGROUP,NBMIX,NREGIO,NUNKNO
      INTEGER          MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL             FUNKNO(NUNKNO,NGROUP)
      REAL             SUNKNO(NUNKNO,NGROUP)
      INTEGER          IJJ(0:NBMIX),NJJ(0:NBMIX),IPOS(0:NBMIX)
      REAL             XSCAT(0:NBMIX*NGROUP)
      REAL             XSA(0:NBMIX)
*----
*  LOCAL PARAMETERS
*---
      CHARACTER        CGRPNM*12
      INTEGER          IGR,JGR,IGSCAT,IPSCAT,IREG,IMIX,IRLOC
      INTEGER          ILCMLN,ILCMTY
*----
*  LOOP OVER FINAL GROUPS
*----
      NJJ(0)=0 
      IJJ(0)=0 
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
        CALL LCMGET(IPSYS,'DRAGON-S0XSC',XSA(0))
        CALL LCMLEN(IPMACR,'NJJD 0',ILCMLN,ILCMTY)
        IF(ILCMLN .EQ. NBMIX) THEN
          CALL LCMGET(IPMACR,'NJJD 0',NJJ(1))
          CALL LCMGET(IPMACR,'IJJD 0',IJJ(1))
          CALL LCMGET(IPMACR,'IPOD 0',IPOS(1))
          CALL LCMGET(IPMACR,'SCAD 0',XSCAT(1))
        ELSE 
          CALL LCMLIB(IPMACR)
          CALL XABORT(NAMSBR//': FLUX CALCULATION ERROR, '//
     >    'SCATTERING MATRIX SCAD 0 NOT ON LCM')
        ENDIF
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMDN)
*----
*  LOOP OVER REGIONS
*  VOIDED REGIONS (IMIX=0) ARE NOT CONSIDERED
*----
        DO 110 IREG=1,NREGIO
          IMIX=MATCOD(IREG)
          IRLOC=KEYFLX(IREG)
          IGSCAT=IJJ(IMIX)
          IPSCAT=IPOS(IMIX)
*----
*  LOOP OVER INITIAL GROUPS
*----
          DO 120 JGR=1,NJJ(IMIX)
            IF(IGSCAT .NE. IGR) THEN
              SUNKNO(IRLOC,IGR)=SUNKNO(IRLOC,IGR)
     >          +XSCAT(IPSCAT)*FUNKNO(IRLOC,IGSCAT)
            ELSE
              SUNKNO(IRLOC,IGR)=SUNKNO(IRLOC,IGR)
     >          +XSA(IMIX)*FUNKNO(IRLOC,IGSCAT)
            ENDIF
            IGSCAT=IGSCAT-1
            IPSCAT=IPSCAT+1
 120      CONTINUE
 110    CONTINUE
 100  CONTINUE
      RETURN
      END
