*DECK FLUQFB
      SUBROUTINE FLUQFB(IPSYS,IPRINT,NGROUP,NREGIO,NUNKNO,B2,FUNKNO,
     >                  SUNKNO,PPP)
C
C---------------------------  FLUQFB  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUQFB
C       USE      : ADD B2 SOURCES TO SUNKNO
C       MODIFIED : 94-07-21  (I. PETROVIC, G. MARLEAU)
C       AUTHOR   : I. PETROVIC
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      IPSYS   : POINTER TO THE PIJ                   I
C      IPRINT  : PRINT SELECTION FOR FLUX MODULES:    I
C                >= 100 PRINT FISSION SOURCES
C      NGROUP  : NUMBER OF GROUPS.                    I
C      NREGIO  : NUMBER OF REGIONS.                   I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.     I
C      B2      :  X, Y, Z, HOMO BUCKLINGS             R(4)
C      FUNKNO  : UNKNOWNS                             R(NUNKNO,NGROUP)
C    OUTPUT
C      SUNKNO  : SOURCE FOR SYSTEM OF UNKNOWN.        R(NUNKNO,NGROUP)
C    SCRATCH STORAGE:
C      PPP     : DIRECTIONAL PIJK""=(PIJ**(-1))*PIJK" R(NREGIO,NREGIO,3)
C
C   3- INTERNAL PARAMETERS:
C      CGRPNM  : CHARACTER GROUP NAME                 C*12
C      IUNOUT  : OUTPUT UNIT                          P
C
C---------------------------   FLUQFB  --------------------------------
C
      PARAMETER  (IUNOUT=6)
      CHARACTER  CGRPNM*12
      INTEGER    IPRINT,NGROUP,NREGIO,NUNKNO
      REAL       B2(4),PPP(NREGIO,NREGIO,3),
     >           FUNKNO(NUNKNO,NGROUP),SUNKNO(NUNKNO,NGROUP)
C-----
C     ADD B2 SOURCES TO SUNKNO
C-----
      NRG=NREGIO*NREGIO
      NRGI=3*NRG
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)')IGR,NGROUP
        CALL LCMSIX(IPSYS,CGRPNM,1)
        CALL LCMLEN(IPSYS,'DRAGON1P*SCT',ILEN,ITYP)
        IF(ILEN.EQ.NRG.AND.ITYP.EQ.2) THEN
          CALL LCMGET(IPSYS,'DRAGON1P*SCT',PPP(1,1,1))
          CALL LCMGET(IPSYS,'DRAGON2P*SCT',PPP(1,1,2))
          CALL LCMGET(IPSYS,'DRAGON3P*SCT',PPP(1,1,3))
C-----
C     FLUX SOURCES
C-----
          DO 120 IREG=1,NREGIO
            SX=0.
            SY=0.
            SZ=0.
            DO 140 JREG=1,NREGIO
              SX=SX+FUNKNO(JREG+NREGIO,IGR)*PPP(IREG,JREG,1)
              SY=SY+FUNKNO(JREG+2*NREGIO,IGR)*PPP(IREG,JREG,2)
              SZ=SZ+FUNKNO(JREG+3*NREGIO,IGR)*PPP(IREG,JREG,3)
 140        CONTINUE
            SB=-SX*B2(1)-SY*B2(2)-SZ*B2(3)
            SUNKNO(IREG,IGR)=SUNKNO(IREG,IGR)+SB
 120      CONTINUE
          IF(IPRINT.GE.100) THEN
            WRITE(IUNOUT,6000) IGR
            WRITE(IUNOUT,6001) (IREG, SUNKNO(IREG,IGR),IREG=1,NREGIO)
          ENDIF
        ELSE
          CALL LCMLIB(IPSYS)
          CALL XABORT('FLUQFB: TYPE -- K OR B -- CALCULATION '//
     >                'LCM READ ERROR : PIJK* ABSENT ')
        ENDIF
        CALL LCMSIX(IPSYS,' ',2)
 100  CONTINUE
      RETURN
C-----
C     FORMATS
C-----
 6000 FORMAT(' REGIONAL FLUX SOURCES IN GROUP = ',I5)
 6001 FORMAT(1P,5(3X,I5,2X,E15.7))
      END
