*DECK FLUQFS
      SUBROUTINE FLUQFS(IPMACR,IPRINT,NGROUP,NBMIX ,NREGIO,NUNKNO,
     >                  NIFISS,MATCOD,KEYFLX,CCHI  ,FACTNO,QTOTL ,
     >                  SUNKNO,XSCHI )
C
C---------------------------  FLUQFS  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLUQFS
C       USE      : ADD FISSION SOURCES TO SUNKNO
C       MODIFIED : DEAL WITH ADJOINT SOURCE (ITYPEC<0)
C                  00-01-18  (T. COURAU)
C                  94-06-23
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      IPMACR  : POINTER TO THE MACROLIB              I
C      IPRINT  : PRINT SELECTION FOR FLUX MODULES     I
C                = 0/1/2/3 NO PRINT/SHORT PRINT/LONG
C      NGROUP  : NUMBER OF GROUPS                     I
C      NBMIX   : NUMBER OF MIXTURES                   I
C      NREGIO  : NUMBER OF REGIONS                    I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM      I
C      NIFISS  : NUMBER OF FISSILE ISOTOPES           I
C      MATCOD  : MATERIAL CODE IN REGIONS.            I(NREGIO)
C      KEYFLX  : FLUX ELEMENTS IN UNKNOWN SYSTEM      I(NREGIO)
C      FACTNO  : SOURCE NORMALIZATION FACTOR          D
C      CCHI    : FISSION SPECTRUM RECORD NAME         C*12
C      QTOTL   : TOTAL FISSION SOURCE PER ISOTOPE     D(NREGIO,NIFISS)
C    OUTPUT
C      SUNKNO  : SOURCE FOR SYSTEM OF UNKNOWN         R(NUNKNO,NGROUP)
C    SCRATCH STORAGE:
C      XSCHI   : CHI  VECTOR                         R(NBMIX,NIFISS)
C
C   3- INTERNAL PARAMETERS:
C      CGRPNM  : CHARACTER GROUP NAME                 C*12
C      IOUT  : OUTPUT UNIT                          P
C
C---------------------------   FLUQFS  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='FLUQFS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,IPRINT,NGROUP,NBMIX,NREGIO,
     >            NUNKNO,NIFISS
      CHARACTER   CCHI*12
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL        SUNKNO(NUNKNO,NGROUP),XSCHI(NBMIX,NIFISS)
      DOUBLE PRECISION FACTNO,QTOTL(NREGIO,NIFISS)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12
      INTEGER     IGR,IREG,IFLXL,IBM,IFIS
C----
C  ADD FISSION SOURCES TO SUNKNO AT REGION LOCATION
C----
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,1)
        CALL LCMGET(IPMACR,CCHI,XSCHI)
        DO 110 IREG=1,NREGIO
          IFLXL=KEYFLX(IREG)
          IBM=MATCOD(IREG)
          IF(IBM .GT. 0) THEN
            DO 120 IFIS=1,NIFISS
              SUNKNO(IFLXL,IGR)=SUNKNO(IFLXL,IGR)+
     >        QTOTL(IREG,IFIS)*XSCHI(IBM,IFIS)*FACTNO
 120        CONTINUE
            IF(IPRINT .GE. 100) THEN
              WRITE(IOUT,6000) IGR,IREG
              WRITE(IOUT,6001) (IFIS,QTOTL(IREG,IFIS)*
     >          XSCHI(IBM,IFIS)*FACTNO,IFIS=1,NIFISS)
            ENDIF
          ENDIF
 110    CONTINUE
        CALL LCMSIX(IPMACR,' ',2)
 100  CONTINUE
      RETURN
C----
C FORMATS
C----
 6000 FORMAT(' REGIONAL FISSION SOURCES IN GROUP = ',I5,
     >       ' REGION NUMBER = ',I5)
 6001 FORMAT(1P,5(3X,I5,2X,E15.7))
      END
