*DECK JPMF
      SUBROUTINE JPMF (IPSYS,IPTRK,IFTRAK,IMPX,IDIR,NMERGE,NUNKNO,MAT,
     1 VOL,KEYFLX,FUNKNO,SUNKNO,TITR)
*
*-----------------------------------------------------------------------
*
* SOLVE ONE GROUP TRANSPORT EQUATION FOR FLUXES USING THE JPM FAST FLUX
* SOLVER.
*
* GENERAL PARAMETERS:
*   IPSYS  : POINTER TO THE PIJ (L_PIJ SIGNATURE).
*   IPTRK  : POINTER TO THE TRACKING (L_TRACK SIGNATURE).
*   IFTRAK : NOT USED.
*   IMPX   : PRINT FLAG. EQUAL TO ZERO FOR NO PRINT.
*   IDIR   : =0 ONLY FOR JPM
*   NMERGE : TOTAL NUMBER OF MERGED BLOCKS FOR WHICH SPECIFIC VALUES
*            OF THE NEUTRON FLUX AND REACTIONS RATES ARE REQUIRED.
*   NUNKNO : TOTAL NUMBER OF UNKNOWNS IN VECTORS SUNKNO AND FUNKNO.
*   MAT    : INDEX-NUMBER OF THE MIXTURE TYPE ASSIGNED TO EACH VOL.
*            DIMENSION MAT(NMERGE)
*   VOL    : VOLUMES. DIMENSION VOL(NMERGE)
*   KEYFLX : POSITION OF FLUX ELEMENTS IN FUNKNO VECTOR.
*            DIMENSION KEYFLX(NMERGE)
*   FUNKNO : UNKNOWN VECTOR. DIMENSION FUNKNO(NUNKNO)
*   SUNKNO : INPUT SOURCE VECTOR. DIMENSION SUNKNO(NUNKNO)
*   TITR   : TITLE.
*
*---------------------------------------------- A. HEBERT 22/09/89 -----
*
      PARAMETER  (IUNOUT=6,NSTATE=40)
      CHARACTER   TITR*72,NAMT*12,NAMLCM*12,NAMMY*12
      INTEGER     IMPX,IDIR,NMERGE,NUNKNO,MAT(*),KEYFLX(*),
     1            ISTATE(NSTATE),IBASE(1)
      LOGICAL     LCM
      REAL        VOL(*),FUNKNO(*),SUNKNO(*)
      COMMON      BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
*
* RECOVER JPM SPECIFIC PARAMETERS.
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      NPIS=ISTATE(5)
      NMBLK=ISTATE(11)
      NGEN=ISTATE(12)
      IJAT=ISTATE(13)
      NPSS=ISTATE(16)
      NICM=ISTATE(17)
      IIFR=LCMIOF(IPTRK,'IFR')
      IALB=LCMIOF(IPTRK,'ALB')
      IINU=LCMIOF(IPTRK,'INUM')
      IMIX=LCMIOF(IPTRK,'MIX')
      IDVX=LCMIOF(IPTRK,'DVX')
      IIGE=LCMIOF(IPTRK,'IGEN')
      IISU=LCMIOF(IPTRK,'ISURF')
      ICHO=LCMIOF(IPTRK,'CHORD')
      IMU1=LCMIOF(IPTRK,'MU1')
      IIMA=LCMIOF(IPTRK,'IMA')
*
      NAMT=' '
      CALL LCMNXT(IPSYS,NAMT,NAMLCM,NAMMY,LCM)
      IF(IDIR.NE.0) CALL XABORT('JMPF: PIJK FORBIDDEN HERE')
*
      IF(IMPX.GT.2) THEN
        WRITE(IUNOUT,'(//33H N E U T R O N    S O U R C E S :)')
        WRITE(IUNOUT,'(1P,6(5X,E15.7))') (SUNKNO(KEYFLX(I)),I=1,NMERGE)
      ENDIF
      CALL SETARA(BASE,NGEN,IPII)
      CALL SETARA(BASE,NPIS,IPIS)
      CALL SETARA(BASE,NGEN,ISIGS)
      CALL LCMLEN(IPSYS,'DRAGONJPMPII',LENGTH,ITYLCM)
      IF (LENGTH.NE.NGEN) THEN
         CALL XABORT('JPMF: BLOCKWISE COLLISION PROBABILITIES ARE ABSE'
     1   //'NT FROM LCM.')
      ENDIF
      CALL LCMGET(IPSYS,'DRAGONJPMPII',BASE(IPII))
      CALL LCMGET(IPSYS,'DRAGONJPMPIS',BASE(IPIS))
      CALL LCMGET(IPSYS,'DRAGONJPMSXS',BASE(ISIGS))
*
* CALCULATION OF THE NEUTRON FLUX.
      IF(LCM) THEN
         IWSSB=LCMIOF(IPSYS,'DRAGONJPMICM')
      ELSE
         CALL SETARA(BASE,NICM,IWSSB)
         CALL LCMGET(IPSYS,'DRAGONJPMICM',BASE(IWSSB))
      ENDIF
      CALL SETARA(BASE,NMERGE,IIGAT)
      CALL SETARA(BASE,NGEN,IIGAU)
      CALL SETARA(BASE,IJAT,IGAR)
      CALL JPMFLX(NMBLK,IBASE(IIFR),BASE(IALB),NMERGE,IJAT,IBASE(IINU),
     1 IBASE(IMIX),BASE(IDVX),IBASE(IMU1),IBASE(IIMA),BASE(IWSSB),NGEN,
     2 IBASE(IIGE),IBASE(IISU),BASE(ICHO),BASE(ISIGS),BASE(IPII),
     3 BASE(IPIS),FUNKNO,SUNKNO,BASE(IIGAT),BASE(IIGAU),BASE(IGAR))
      CALL RLSARA(BASE(IGAR))
      CALL RLSARA(BASE(IIGAU))
      CALL RLSARA(BASE(IIGAT))
      IF(.NOT.LCM) CALL RLSARA(BASE(IWSSB))
*
      CALL RLSARA(BASE(IPIS))
      CALL RLSARA(BASE(IPII))
      CALL RLSARA(BASE(ISIGS))
      IF(IMPX.GT.2) THEN
        WRITE(IUNOUT,'(//33H N E U T R O N    F L U X E S   :)')
        WRITE(IUNOUT,'(1P,6(5X,E15.7))') (FUNKNO(KEYFLX(I)),I=1,NMERGE)
      ENDIF
      RETURN
      END
