*DECK JPMT
      SUBROUTINE JPMT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* JPM TYPE (J+-) TRACKING MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TRACK).
*  HENTRY(2) : OPTIONAL SEQUENTIAL BINARY TRACKING FILE.
*  HENTRY(3) : READ-ONLY TYPE(L_GEOM)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 29/09/94 ---
*
      INTEGER   IOUT,NSTATE
      PARAMETER(IOUT=6,NSTATE=40)
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12,
     1 CFTRAK*12
      DOUBLE PRECISION DFLOTT
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),ITITL(18),IGP(NSTATE),
     1 ISTATE(NSTATE),KCHAR(3),JQUA2(2),IPARAM(15)
      COMMON BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1) CALL XABORT('JPMT: TWO PARAMETERS EXPECTED.')
      IF(IENTRY(1).NE.1) CALL XABORT('JPMT: LINKED LIST EXPECTED AT L'
     1 //'HS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('JPMT: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      HSIGN='L_TRACK'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'SIGNATURE',3,3,KCHAR)
      HSIGN='JPM'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(KENTRY(1),'TRACK-TYPE',3,3,KCHAR)
*
* RECOVER GEOMETRY.
      DO 10 I=2,NENTRY
      IF((IENTRY(I).LE.2).AND.(JENTRY(I).EQ.2)) THEN
         CALL LCMGET(KENTRY(I),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(J),J=1,3)
         IF(HSIGN.NE.'L_GEOM') THEN
            TEXT12=HENTRY(I)
            CALL XABORT('JPMT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_GEOM EXPECTED.')
         ENDIF
         IPGEOM=KENTRY(I)
         CALL XDISET(ISTATE,NSTATE,0)
         CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
         GO TO 20
      ENDIF
   10 CONTINUE
      CALL XABORT('JPMT: UNABLE TO FIND A L_GEOM SPECIFICATION.')
*
* RECOVER SEQUENTIAL BINARY TRACKING FILE CHARACTERISTICS.
   20 CFTRAK=' '
      IFTRAK=0
      ITRAK=99
      DO 30 I=2,NENTRY
      IF(IENTRY(I).EQ.3) THEN
         CFTRAK=HENTRY(I)
         IF(JENTRY(I).EQ.0) ITRAK=1
         IF(JENTRY(I).EQ.1) ITRAK=-1
         IF(JENTRY(I).EQ.2) ITRAK=0
         IFTRAK=KENTRY(I)
         GO TO 35
      ENDIF
   30 CONTINUE
*
   35 IMPX=1
      IF(JENTRY(1).EQ.0) THEN
         TITLE=' '
         MAXPTS=ISTATE(6)
         MAXZ=10000
         MAXJ=MAX(50,6*MAXPTS)
         IUOLD=0
         IAPP=2
         IF((ISTATE(1).EQ.3).OR.(ISTATE(1).EQ.4)) IAPP=3
         IF(ISTATE(1).EQ.6) IAPP=1
         MULTC=3
         IWIGN=3
         INORM=0
         IQW=0
         JQUA1=5
         JQUA2(1)=6
         JQUA2(2)=3
         IROT=2
         IBPP=2
         JQUAB=5
      ELSE IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(KENTRY(1),'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'L_TRACK') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('JPMT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_TRACK EXPECTED.')
         ENDIF
         CALL LCMGET(KENTRY(1),'TRACK-TYPE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'JPM') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('JPMT: TRACK-TYPE OF '//TEXT12//' IS '//HSIGN
     1      //'. JPM EXPECTED.')
         ENDIF
         CALL XDISET(IGP,NSTATE,0)
         CALL LCMGET(KENTRY(1),'STATE-VECTOR',IGP)
         MAXPTS=IGP(1)
         ITG=IGP(7)
         MAXZ=IGP(8)
         MAXJ=IGP(9)
         IUOLD=IGP(10)
   40    IF(ITG.EQ.2) THEN
            CALL LCMSIX(KENTRY(1),'PURE-GEOM',1)
            CALL LCMGET(KENTRY(1),'PARAM',IPARAM)
            CALL LCMSIX(KENTRY(1),' ',2)
            IAPP=IPARAM(3)
            JQUA1=IPARAM(4)
         ELSE IF(ITG.EQ.3) THEN
            CALL LCMSIX(KENTRY(1),'DOITYOURSELF',1)
            CALL LCMGET(KENTRY(1),'PARAM',IPARAM)
            CALL LCMSIX(KENTRY(1),' ',2)
            IAPP=IPARAM(2)
            JQUA1=IPARAM(3)
         ELSE IF(ITG.EQ.4) THEN
            CALL LCMSIX(KENTRY(1),'EURYDICE',1)
            CALL LCMGET(KENTRY(1),'PARAM',IPARAM)
            CALL LCMSIX(KENTRY(1),' ',2)
            MULTC=IPARAM(1)
            IWIGN=IPARAM(2)
            INORM=IPARAM(8)
            IQW=IPARAM(9)
            IAPP=IPARAM(3)
            JQUA1=IPARAM(6)
            JQUA2(1)=IPARAM(4)
            JQUA2(2)=IPARAM(5)
         ELSE IF(ITG.EQ.5) THEN
            CALL LCMSIX(KENTRY(1),'CLUSTER',1)
            CALL LCMGET(KENTRY(1),'PARAM',IPARAM)
            CALL LCMSIX(KENTRY(1),' ',2)
            IROT=IPARAM(2)
            IAPP=IPARAM(1)
            JQUA1=IPARAM(5)
            JQUA2(1)=IPARAM(3)
            JQUA2(2)=IPARAM(4)
            CALL LCMGET(KENTRY(1),'LINK.FTRACK',KCHAR)
            WRITE(TEXT12,'(3A4)') (KCHAR(I),I=1,3)
            IF(TEXT12.NE.'CFTRAK') THEN
               CALL XABORT('JPMT: INCONSISTENT DEPENDENCY FOR THE SEQUE'
     1         //'NTIAL BINARY TRACKING FILE. '//TEXT12//' VS '//CFTRAK)
            ENDIF
         ELSE IF(ITG.EQ.10) THEN
            CALL LCMSIX(KENTRY(1),'BIHET',1)
            CALL LCMGET(KENTRY(1),'PARAM',IPARAM)
            CALL LCMSIX(KENTRY(1),' ',2)
            ITG=IPARAM(5)
            JQUAB=IPARAM(7)
            IBPP=IPARAM(8)
            GO TO 40
         ENDIF
      ENDIF
*
* READ MODULE SPECIFIC DATA.
      IRECT=0
      IHALT=0
      ILIGN=0
   50 CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DFLOTT)
      IF(INDIC.EQ.10) GO TO 60
      IF(INDIC.NE.3) CALL XABORT('JPMT: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED(2).')
         MAXJ=MAX(MAXJ,6*MAXPTS)
      ELSE IF(TEXT4.EQ.'MAXJ') THEN
*        ALLOCATED STORAGE FOR STORING THE INTERFACE CURRENTS.
         CALL REDGET(INDIC,MAXJ,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'MAXZ') THEN
*        ALLOCATED STORAGE FOR STORING THE TRACKING INFORMATION.
         CALL REDGET(INDIC,MAXZ,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,FLOTT,TITLE,DFLOTT)
         IF(INDIC.NE.3) CALL XABORT('JPMT: TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'OLD') THEN
*        TRY TO SAVE CPU TIME BY USING PREVIOUSLY CALCULATED COLLISION
*        PROBABILITIES.
         IUOLD=1
      ELSE IF(TEXT4.EQ.'IP00') THEN
*        DP-0 APPROXIMATION.
         IAPP=1
      ELSE IF(TEXT4.EQ.'SP01') THEN
*        DP-1 APPROXIMATION WITH SPECULAR BOUNDARY CONDITION.
         IAPP=2
      ELSE IF(TEXT4.EQ.'IP01') THEN
*        DP-1 APPROXIMATION WITH ISOTROPIC BOUNDARY CONDITION.
         IAPP=3
      ELSE IF(TEXT4.EQ.'ROTH') THEN
         MULTC=1
      ELSE IF(TEXT4.EQ.'ROT+') THEN
         MULTC=2
      ELSE IF(TEXT4.EQ.'DP00') THEN
         MULTC=3
      ELSE IF(TEXT4.EQ.'DP01') THEN
         MULTC=4
      ELSE IF(TEXT4.EQ.'ASKE') THEN
*        USE ASKEW CYLINDERIZATION IN EURYDICE.
         IWIGN=1
      ELSE IF(TEXT4.EQ.'WIGN') THEN
*        USE ASKEW CYLINDERIZATION IN EURYDICE.
         IWIGN=2
      ELSE IF(TEXT4.EQ.'SANC') THEN
*        USE SANCHEZ CYLINDERIZATION IN EURYDICE.
         IWIGN=3
      ELSE IF(TEXT4.EQ.'HALT') THEN
*        STOP AT THE END OF TRACKING.
         IHALT=1
      ELSE IF(TEXT4.EQ.'LIGN') THEN
*        PRINT THE TRACKING INFORMATION.
         ILIGN=1
      ELSE IF(TEXT4.EQ.'RENO') THEN
*        NORMALIZE TRACKS.
         INORM=0
      ELSE IF(TEXT4.EQ.'NORE') THEN
*        DO NOT NORMALIZE TRACKS.
         INORM=1
      ELSE IF(TEXT4.EQ.'RECT') THEN
*        DO NOT CONSIDER THE SYMMETRIES OF SQUARE CELLS IN EURYDICE.
         IRECT=1
      ELSE IF(TEXT4.EQ.'GAUS') THEN
*        USE GAUSS QUADRATURES IN ANGLE AND SPACE.
         IQW=0
      ELSE IF(TEXT4.EQ.'EQW') THEN
*        USE EQUAL WEIGHT QUADRATURES IN ANGLE AND SPACE.
         IQW=1
      ELSE IF(TEXT4.EQ.'QUA1') THEN
*        1-D QUADRATURE PARAMETER.
         CALL REDGET(INDIC,JQUA1,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'QUA2') THEN
*        2-D QUADRATURE PARAMETERS (ANGLE AND SPACE).
         CALL REDGET(INDIC,JQUA2(1),FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
         CALL REDGET(INDIC,JQUA2(2),FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'RECD') THEN
*        USE DIRECT CLUSTER RECONSTRUCTION.
         IROT=1
      ELSE IF(TEXT4.EQ.'RECR') THEN
*        USE SURFACE SPLITTING CLUSTER RECONSTRUCTION.
         IROT=2
      ELSE IF(TEXT4.EQ.'BP00') THEN
*        DP-0 APPROXIMATION FOR THE BIHET OPTION.
         IBPP=1
      ELSE IF(TEXT4.EQ.'BP01') THEN
*        DP-1 APPROXIMATION FOR THE BIHET OPTION.
         IBPP=2
      ELSE IF(TEXT4.EQ.'QUAB') THEN
*        1-D QUADRATURE PARAMETER FOR THE BIHET OPTION.
         CALL REDGET(INDIC,JQUAB,FLOTT,TEXT4,DFLOTT)
         IF(INDIC.NE.1) CALL XABORT('JPMT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 60
      ELSE
         CALL XABORT('JPMT: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 50
*
   60 IF(TITLE.NE.' ') THEN
         READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
         CALL LCMPUT(KENTRY(1),'TITLE',18,3,ITITL)
      ENDIF
*
      IF(MAXPTS.EQ.0) CALL XABORT('JPMT: MAXPTS NOT DEFINED.')
      CALL SETARA(BASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS,IVOL)
      CALL SETARA(BASE,MAXPTS,IIDL)
      CALL JPMTRK (KENTRY(1),IPGEOM,IMPX,MAXPTS,MAXJ,MAXZ,TITLE,
     1 IUOLD,IAPP,MULTC,IWIGN,IHALT,ILIGN,INORM,IRECT,IQW,JQUA1,JQUA2,
     2 CFTRAK,IFTRAK,ITRAK,IROT,IBPP,JQUAB,BASE(IMAT),BASE(IVOL),
     3 BASE(IIDL))
      CALL RLSARA(BASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(BASE(IMAT))
*
      IF(IMPX.GT.1) THEN
         CALL XDISET(IGP,NSTATE,0)
         CALL LCMGET(KENTRY(1),'STATE-VECTOR',IGP)
         WRITE(IOUT,110) (IGP(I),I=1,17)
      ENDIF
      RETURN
  110 FORMAT(/14H STATE VECTOR:/
     1 7H NREG  ,I6,' (NUMBER OF REGIONS)'/
     2 7H NUN   ,I6,' (NUMBER OF UNKNOWNS)'/
     3 7H ILK   ,I6,' (0=LEAKAGE PRESENT/1=LEAKAGE ABSENT)'/
     4 7H NBMIX ,I6,' (MAXIMUM NUMBER OF MIXTURES USED)'/
     5 7H NSURF ,I6,' (NUMBER OF OUTER SURFACES)'/
     6 7H NANI  ,I6,' (FLUX ANISOTROPY ORDER)'/
     6 7H ITG   ,I6,' (TYPE OF GEOMETRY)'/
     7 7H MAXZ  ,I6,' (TRACKING LENGTH)'/
     8 7H MAXJ  ,I6,' (INTERNAL STORAGE LENGTH FOR CURRENTS)'/
     9 7H IUOLD ,I6,' (0=DO NOT/=1 DO RECOMPUTE IDENTICAL BLOCK PIJS)'/
     2 7H NMBLK ,I6,' (TOTAL NUMBER OF BLOCKS IN THE DOMAIN)'/
     3 7H NGEN  ,I6,' (TOTAL NUMBER OF GENERATING BLOCKS)'/
     4 7H IJAT  ,I6,' (TOTAL NUMBER OF DISTINCT OUTCOMING CURRENTS)'/
     5 7H IJAS  ,I6,' (TOTAL NUMBER OF DISTINCT INCOMING CURRENTS)'/
     6 7H IJAR  ,I6,' (TOTAL NUMBER OF OUTCOMING CURRENTS)'/
     8 7H NPSS  ,I6,' (DIMENSION OF PSS VECTOR)' /
     9 7H NICM  ,I6,' (DIMENSION OF ICM VECTOR)' )
      END
