*DECK LIBMFE
      SUBROUTINE LIBMFE(NDEPL ,MAXR  ,NBISO ,NBMIX ,NNFI  ,ISONAM,
     >                  ISONRF,ISOMIX,
     >                  INAM  ,IDR   ,RER   ,ISONFI,NIFIS ,EMEV  )
C
C---------------------------  LIBMFE  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : LIBMFE
C       USE      : GET ENERGY PER FISSION (MEV)
C       MODIFIED : 2000/02/23  (G. MARLEAU)
C
C   2- ROUTINE PARAMETERS:
C       NDEPL   : NUMBER OF DEPLETING ISOTOPES   I
C       MAXR    : NUMBER OF DEPLETING REACTIONS  I
C       NBISO   : NUMBER OF ISOTOPES PRESENT     I
C       NBMIX   : NUMBER OF MIXTURES             I
C       NNFI    : NUMBER OF FISSILE ISOTOPES     I
C       ISONAM  : NAME OF ISOTOPES               I(NTC,NBISO)
C       ISONRF  : REFERENCE NAME OF ISOTOPES     I(NTC,NBISO)
C       ISOMIX  : MIX NUMBER OF EACH ISOTOPE.    I(NBISO)
C       INAM    : DEPLETION ISOTOPE NAMES        I(NTC-1,NDEPL)
C       IDR     : DEPLETION REACTIOR             I(MAXR,NDEPL)
C       RER     : DEPLETION RATES                R(MAXR,NDEPL)
C       ISONFI  : FISSILE ISOTOPE NAMES          I((NTC-1)*NNFI)
C       NIFIS   : FISSION NUMBER                 I(NBMIX,NNFI)
C       EMEV    : FISSION ENERGY (MEV)           R(NBMIX,NNFI)
C
C---------------------------   LIBMFE  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NTC,KFISSI
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NTC=3,KFISSI=6,NAMSBR='LIBMFE')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     NDEPL,MAXR,NBISO,NBMIX,NNFI
      INTEGER     ISONAM(NTC,NBISO),ISONRF(NTC,NBISO),
     >            ISOMIX(NBISO),INAM(NTC-1,NDEPL),
     >            IDR(MAXR,NDEPL),ISONFI(NTC-1,NNFI),
     >            NIFIS(NBMIX,NNFI)
      REAL        RER(MAXR,NDEPL),EMEV(NBMIX,NNFI)
C----
C  LOCAL PARAMETERS
C----
      INTEGER     ISO,IMIX,IFOUND,IFI,IDP,ITR
C----
C  FIND THE NUMBER OF DEPLETING MIXTURES
C  MARK ISOTOPES WITH DEPLETION PROPERTIES
C----
      DO 100 ISO=1,NBISO
        IMIX=ISOMIX(ISO)
        IFOUND=0
        DO 110 IFI=1,NNFI
          IF(ISONAM(1,ISO) .EQ. ISONFI(1,IFI) .AND.
     >       ISONAM(2,ISO) .EQ. ISONFI(2,IFI) ) THEN
            IF(NIFIS(IMIX,IFI) .GT. 0) THEN
              IFOUND=IFI
              GO TO 115
            ENDIF
          ENDIF
 110    CONTINUE
 115    CONTINUE
        IF(IFOUND .GT. 0) THEN
          DO 120 IDP=1,NDEPL
            IF(ISONRF(1,ISO) .EQ. INAM(1,IDP).AND.
     >         ISONRF(2,ISO) .EQ. INAM(2,IDP)) THEN
              ITR=MOD(IDR(5,IDP),10)
              IF(ITR .EQ. KFISSI ) THEN
                EMEV(IMIX,IFOUND)=RER(5,IDP)
                GO TO 125
              ENDIF
            ENDIF
 120      CONTINUE
 125      CONTINUE
        ENDIF
 100  CONTINUE
      RETURN
      END
