*DECK MACEFI
      SUBROUTINE MACEFI(IPMACR,IPRINT,IEN   ,NTOTMX,NBMIXF,NIFISF,
     >                  IMLOC ,IEFPRO,
     >                  NUMFN ,XSGEN ,XSTMP )
C
C---------------------------  MACEFI  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACEFI
C       USE      : READ EFISS INFORMATION AND TRANSFER IN MEMORY
C       MODIFIED : 2000/02/18
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO STRUCTURES               I
C       IPRINT   : PRINT LEVEL                         I
C       IEN      : MARCOLIB NUMBER TO PROCESS          I
C       NTOTMX   : MAXIMUM NUMBER OF MIXTURES          I
C       NBMIXF   : FINAL NUMBER OF MIXTURES            I
C       NIFISF   : FINAL NUMBER FISSILE ISOTOPES       I
C       IMLOC    : MIXTURE LOCATION                    I(2,NTOTMX)
C       NUMFN    : FINAL FISSILE NUMBER                I(NBMIXF,
C                                                        NIFISF)
C       IEFPRO   : FLAG FOR EFISS PROCESSING           I
C       XSGEN    : GENERAL XS VECTOR                   R(NBMIXF,
C                                                        NIFISF)
C       XSTMP    : TEMPORARY XS VECTOR                 R(NTOTMX*
C                                                      (NIFISF+1))
C
C---------------------------   MACEFI  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NAMSBR='MACEFI')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPMACR,IPRINT,IEN,NTOTMX,NBMIXF,NIFISF,IEFPRO
      INTEGER      IMLOC(2,NTOTMX),NUMFN(NBMIXF,NIFISF)
      REAL         XSGEN(NBMIXF,NIFISF),XSTMP(NTOTMX*(NIFISF+1))
C----
C  LOCAL PARAMETERS
C----
      INTEGER      ILCMLN,ILCMTY,IMIX,IFIS,IOMIX
C----
C  PRINT HEADER IF REQUIRED
C----
      IF(IPRINT .GE. 10) THEN
        WRITE(IOUT,6000) NAMSBR
      ENDIF
      IF(NIFISF .GT. 0) THEN
C----
C  EFISS
C----
        CALL LCMLEN(IPMACR,'EFISS       ',ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'EFISS        '
          ENDIF
          CALL LCMGET(IPMACR,'EFISS       ',XSTMP)
          IEFPRO=1
          DO 120 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              DO 121 IFIS=1,NIFISF
                IOMIX=NUMFN(IMIX,IFIS)
                IF(IOMIX .NE. 0 ) THEN
                  XSGEN(IMIX,IFIS)=XSTMP(IOMIX)
                ENDIF
 121          CONTINUE
            ENDIF
 120      CONTINUE
        ENDIF
      ENDIF
      RETURN
C----
C  EDIT FORMATS
C----
 6000 FORMAT(1X,A6,' - READING  EFISS         '/)
 6010 FORMAT(7X,   '   READING RECORD         : ',A12)
      END
