*DECK MACNXS
      SUBROUTINE MACNXS(IPMACR,NBMIX ,NGROUP,NANISO,NIFISS,MAXFIS,
     >                  NBWRK ,
     >                  INGSCT,IFGSCT,XSWORK,SCWORK,CHWORK)
C
C---------------------------  MACNXS  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACNXS
C       USE      : NORMALIZATION OF MACROSCOPIC X-S INFORMATION
C       MODIFIED : 91-01-24
C       AUTHOR   : A.HEBERT
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO THE MACROLIB            I
C       NBMIX    : NUMBER OF MIXTURES                 I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NANISO   : MAXIMUM LEGENDRE ORDER             I
C                  = 1 ISOTROPIC COLLISION
C                  = 2 LINEARLY ANISOTROPIC COLLISION
C       NIFISS   : NUMBER OF FISSILE ISOTOPES         I
C       MAXFIS   : MAX(1,NIFISS)                      I
C       NBWRK    : DIMENSION OF WORK VECTOR           I
C       INGSCT   : NB OF SCATTERING GROUP FOR  XS     I(NBMIX)
C       IFGSCT   : FIRST SCATTERING GROUP FOR  XS     I(NBMIX)
C    WORK VECTORS
C       XSWORK   : WORK CROSS-SECTION VECTOR          R(NBWRK)
C       SCWORK   : SCRATCH STORAGE                    DB(NBMIX,
C                                                NANISO,NGROUP)
C       CHWORK   : SCRATCH STORAGE                    R(NBMIX,MAXFIS)
C
C---------------------------   MACNXS  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,ILCMUP,ILCMDN
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='MACNXS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPMACR,NBMIX,NGROUP,NANISO,NIFISS,MAXFIS,NBWRK
      INTEGER     INGSCT(NBMIX),IFGSCT(NBMIX)
      REAL        XSWORK(NBWRK),CHWORK(NBMIX,MAXFIS)
      DOUBLE PRECISION SCWORK(NBMIX,NANISO,NGROUP)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12
      INTEGER     ILCMLN,ILCMTY,IMIX,IGR,IFIS,IMAT
C----
C  INITIALIZE WORK VECTORS
C----
      DO 100 IMIX=1,NBMIX
        DO 101 IFIS=1,NIFISS
          CHWORK(IMIX,IFIS)=0.0
 101    CONTINUE
 100  CONTINUE
      DO 110 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
C----
C  COMPUTE SUM OF FISSION SPECTRUM.
C----
        CALL LCMLEN(IPMACR,'CHI',ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          CALL LCMGET(IPMACR,'CHI',XSWORK)
          IMAT=0
          DO 120 IFIS=1,NIFISS
            DO 121 IMIX=1,NBMIX
              IMAT=IMAT+1
              CHWORK(IMIX,IFIS)=CHWORK(IMIX,IFIS)+XSWORK(IMAT)
 121        CONTINUE
 120      CONTINUE
        ENDIF
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 110  CONTINUE
C----
C  WRITE NORMALIZED X-S ON THE MACROLIB.
C----
      DO 130 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMLEN(IPMACR,'CHI',ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          CALL LCMGET(IPMACR,'CHI',XSWORK)
          IMAT=0
          DO 140 IFIS=1,NIFISS
            DO 141 IMIX=1,NBMIX
              IMAT=IMAT+1
              IF(CHWORK(IMIX,IFIS) .GT. 0.5) THEN
                XSWORK(IMAT)=XSWORK(IMAT)/CHWORK(IMIX,IFIS)
              ENDIF
 141        CONTINUE
 140      CONTINUE
          CALL LCMPUT(IPMACR,'CHI',NBMIX*NIFISS,2,XSWORK)
        ENDIF
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 130  CONTINUE
      RETURN
      END
