*DECK MOC2KF
      SUBROUTINE MOC2KF(NGRP,LEAKSW,OLDBIL,PHI,XCABS,XCNUF,XCCHI,DB2,
     >                  AKEFF,AFLNOR,IPRT)
*---------------------------  MOC2KF  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*       NAME     :  MOC2KF
*       USE      :  EIGENVALUE CALCULATION
*       AUTHOR   :  R. ROY (01/01/98)
*       MODIFIED :  MONCHAI A. (01/01/05)
*
*   2- ROUTINE PARAMETERS:
*    INPUT
*       NGRP     : NUMBER OF ENERGY GROUPS            I
*       LEAKSW   : FLAG INDICATING PRESENCE (.TRUE.)  L
*                  OR ABSENCE (.FALSE.) OF LEAKAGE.   
*       PHI      : DOMAIN-INTEGRATED GROUP FLUXES     D(NGRP)
*       XCABS    : HOMOGENIZED ABSORPTION             D(NGRP)
*                  CROSS SECTION
*       XCCHI    : HOMOGENIZED CHI                    D(NGRP)
*       XCNUF    : HOMOGENIZED NUSIGMA-F              D(NGRP)
*                  CROSS SECTION
*
*    WORKING
*
*    OUTPUT
*       AKEFF    : KEFFECTIVE                         D
*
*---------------------------   MOC2KF  --------------------------------
*
      IMPLICIT NONE
      LOGICAL LEAKSW
      INTEGER NGRP,IPRT,IGRP,IOUT
      DOUBLE PRECISION PHI(NGRP),DB2(NGRP),
     >        XCABS(NGRP),XCNUF(NGRP),XCCHI(NGRP)
      DOUBLE PRECISION PROD,LOSS,SUMCHI,FISOUR,
     >                 OLDBIL,AKEFF,AFLNOR,DZERO,DONE
      PARAMETER (IOUT=6,DZERO=0.0D0, DONE=1.0D0 )
      FISOUR= DZERO
      SUMCHI= DZERO
      LOSS= DZERO
      DO 10 IGRP=1,NGRP
         FISOUR=FISOUR+XCNUF(IGRP)*PHI(IGRP)
         SUMCHI=SUMCHI+XCCHI(IGRP)
         LOSS=LOSS+XCABS(IGRP)*PHI(IGRP)
         LOSS=LOSS+DB2(IGRP)*PHI(IGRP)
   10 CONTINUE
      PROD= SUMCHI*FISOUR
      IF( PROD.GT.DZERO )THEN
         AFLNOR= DONE/PROD
      ELSE
         AFLNOR= DONE
      ENDIF
      IF( LEAKSW )THEN
         IF( OLDBIL.GT.DZERO )THEN
            AKEFF= PROD/OLDBIL
            AFLNOR= DONE/AKEFF
         ELSE
            AKEFF= PROD
            AFLNOR= DONE/AKEFF
         ENDIF
      ELSE
         IF( LOSS.GT.DZERO )THEN
            AKEFF=  PROD/LOSS
*            AFLNOR= AFLNOR*LOSS
         ELSE
            AKEFF=  PROD
         ENDIF
      ENDIF
      OLDBIL=  AFLNOR
      IF( IPRT.GT.2 )THEN
         WRITE(IOUT,6000) OLDBIL,PROD,LOSS,AFLNOR,AKEFF
      ENDIF
      RETURN
 6000 FORMAT(/' ************ OLDBIL=',1P,D20.14
     >       /' ************ PROD  =',D20.14
     >       /' ************ LOSS  =',D20.14
     >       /' ************ AFLNOR=',D20.14
     >       /' ************ AKEFF =',D20.14/)
      END
