*DECK MOCGET
      SUBROUTINE MOCGET(LCACA ,LCACT ,NMU   ,ISYMM ,NGSS ,NANGL ,KTOPT ,
     >                  LFLD,LDAJCB,LMODE ,LEAKSW,ILK  ,LEXIN ,REFKEF,
     >                  ITYPEC,AIEPS ,AEEPS ,NEXTMX,NINTMX,IPRT ,NL    ,
     >                  NANIS ,ITRB  ,IFRITR,ILEAK ,IACITR,ISADJ,ITRANC,
     >                  NBN )

*
*---------------------------  MOCGET  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*       NAME     : MOCGET
*       USE      : READ DATA FOR MOC MODULE
*       AUTHOR   : 
*       REMARK   : 
*
*   2- ROUTINE PARAMETERS: 
*    INPUT
*      IPFLUX  : POINTER TO THE SOLUTION                  I
*      LEAKSW  : LEAKAGE SWITCH                           L
*
*    INPUT/OUTPUT
*     IACITR   : NUMBER OF ACCELERATED ITERATIONS         I
*     ITRANC   : THE TYPE OF TRANSPORT CORRECTION         I
*     ITYPEC   : TYPE OF FLUX CALCULATION                 I
*        ITYPEC= 0 TO SKIP THE FLUX CALCULATION; 
*        ITYPEC= 1 TO COMPUTE THE DIRECT PROBLEM 
*                  SOLUTION WITH FISSION SOURCES 
*                  AND KEFF CONVERGENCE
*        ITYPEC= 2 TO COMPUTE THE DIRECT PROBLEM 
*                  SOLUTION WITH FISSION SOURCES,
*                  KEFF CONVERGENCE AND IMPOSED 
*                  LEAKAGE
*        ITYPEC= 3 TO COMPUTE THE DIRECT PROBLEM 
*                  SOLUTION WITH FISSION SOURCES,
*                  KEFF CONVERGENCE AND IMPOSED 
*                  BUCKLING
*        ITYPEC= 4 TO COMPUTE THE DIRECT PROBLEM 
*                  SOLUTION WITH FISSION SOURCES,
*                  IMPOSED KEFF AND CONVERGENCE 
*                  ON BUCKLING
*        ITYPEC= 5 DIRECT PROBLEM WITH LEAKAGE 
*                  SOURCES AND CONVERGENCE ON 
*                  BUCKLING
*        ITYPEC= 6 DIRECT PROBLEM FIXED SOURCES.
*      IPRT     : PRINT OPTION FOR CHARACTERISTIC SOLVER   I
*      ISADJ    : FLAG FOR TYPE OF ADJOINT CALCULATION     I
*        ISADJ = 1 ADJOINT FLUX CALCULATION WITHOUT-- 
*                  EXTERNAL SOURCE FOR ADJOINT KEFF PROBLEM
*        ISADJ = 2 ADJOINT FLUX CALCULATION WITH--
*                  EXTERNAL SOURCE FOR ADJOINT FIXED SOURCE
*                  PROBLEM
*        ISADJ = 3 GENERALIZED ADJOINT FLUX CALCULATION W/
*                  EXTERNAL GENERALIZED ADJOINT SOURCE 
*      IGDEB    : MULTIGROUP REDUCTION IN FORWARD          I
*                 DIRECTION
*      ILEAK    : THE LEAKAGE MODEL                        I
*      JGDEB    : MULTIGROUP REDUCTION IN BACKWARD         I
*                 DIRECTION
*      LDAJCB   : FLAG TO TURN ON DIRECT AND ADJOINT FLUX  L
*                 CALCULATIONS
*      LEAKSW   : LEAKAGE SWITCH                           L
*      LFLD     : FLAG TO TURN ON DIRECT FLUX CALCULATION  L
*      LDAJCB   : FLAG TO TURN ON DIRECT AND ADJOINT FLUX  L
*                 CALCULATIONS
*      LMODE    : CONTROL FLAG FOR CALCULATION MODE        L(20)
*      LSPLIT   : CONTROL FLAG FOR ITERATION WITH GROUP    L
*                 SPLITTING
*      NBN      : NUMBER OF LEGENDRE ORDER FOR LEAKAGE     I
*      NEXTMX   : MAXIMUM NUMBER OF OUTER ITERATIONS       I
*      NINTMX   : MAXIMUM NUMBER OF INNER ITERATIONS       I
*      NL       : NUMBER OF LEGENDRE ORDER FOR THE FLUX    I
*      NANIS    : NUMBER OF ANISOTROPY IN                  I
*                 SCATTERING CROSS SECTIONS
*      REFKEF   : KEFF VALUE FOR B2 SEARCH                 D
*
*---------------------------   MOCGET  --------------------------------
      IMPLICIT    NONE
C----
C  ROUTINE PARAMETERS
C----
      REAL      AIEPS,AEEPS
      INTEGER   LCACA,LCACT,NMU,ISYMM,NGSS,NANGL,KTOPT,ISADJ,NEXTMX,
     >          NINTMX,IPRT,ITYPEC,NL,NANIS,ITRANC,NBN,ITRB,ILEAK,
     >          IFRITR,IACITR,IOUT
      LOGICAL   LFLD,LDAJCB,LMODE(20),LEAKSW,ILK,LEXIN 
      DOUBLE PRECISION REFKEF
      PARAMETER (IOUT=6)
C----
C  LOCAL PARAMETERS
C----
      INTEGER     INDLEC,IDATA
      REAL        ADATA
      CHARACTER*8 CDATA
      DOUBLE PRECISION DDATA
      CHARACTER*8 CS,    CK,    CB,    CSIGS, CTYPE,
     >            CNOBA, CACCE, CPNL,  CEXEC, CEDIT,
     >            CNBPN, CTHER, CEXTE, CB0,   CB0TR, CB1,  CP1,
     >            CCACA, CCACB, CGAUS, CLMCD, CEXAC, CKEFF,
     >            CADJ, CSAJ0 ,CSAJ1,CAJCB , CNSPT, CBETS,    
     >            CDFLX,CON,COFF,CANGL    
      DATA CS,    CK,    CB,    CSIGS, CTYPE,
     >     CNOBA, CACCE, CPNL,  CEXEC, CEDIT,
     >     CNBPN, CTHER, CEXTE,
     >     CB0,   CB0TR, CB1,   CP1,   CKEFF,
     >     CCACA, CCACB, CGAUS, CLMCD, CEXAC
     >    /'S   ','K   ','B   ','SIGS','TYPE',
     >     'NOBA','ACCE','PNL ',';   ','EDIT',
     >     'NBPN','THER','EXTE',
     >     'B0  ','B0TR','B1  ','P1  ','KEFF',
     >     'CACA','CACB','GAUS','LMCD','EXAC'/

      DATA   CDFLX    , CON   ,COFF,  CAJCB, CNSPT, CBETS  
     >      /'DFLX'   , 'ON  ','OFF ','AJCB','NSPT','BETS'/
      DATA CADJ  , CSAJ0 ,CSAJ1 ,CANGL   
     >    /'ADJ ', 'SAJ0','SAJ1','ANGL'/
C----
C  INITIALIZE LOCAL OPTIONS
C----
         LCACA  =-1
         LEXIN  =.FALSE.
         NINTMX = 50
         NEXTMX = 50
         ISADJ  = 0
         LFLD = .TRUE. 
         LDAJCB = .FALSE. 
         LMODE(1) = .TRUE.
         LMODE(2) = .FALSE.
         LMODE(3) = .FALSE.
         LMODE(4) = .FALSE.
         LMODE(5) = .FALSE.
         LMODE(6) = .FALSE.
         LMODE(7) = .FALSE.
         LMODE(8) = .FALSE.
         LMODE(9) = .FALSE.
         LMODE(10)= .FALSE.
         LMODE(11)= .FALSE.
         LMODE(12)= .FALSE.
         LMODE(13)= .FALSE.
         LMODE(14)= .FALSE.
         LMODE(15)= .FALSE.
         LMODE(16)= .FALSE.
         LMODE(17)= .FALSE.
         LMODE(18)= .FALSE.
         LMODE(19)= .FALSE.
         LMODE(20)= .FALSE.
 1000 CONTINUE
      CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
 1001 CONTINUE
      IF(CDATA(1:4) .EQ. CEXEC(1:4)) THEN
        GO TO 2000
      ELSE IF( CDATA(1:4).EQ.CEDIT(1:4) )THEN
         CALL REDGET ( INDLEC, IPRT, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOCGET: IPRT HAS TO BE READ')

      ELSE IF( CDATA(1:4).EQ.CEXAC(1:4) )THEN
         LEXIN=.TRUE.
      ELSE IF( CDATA(1:4).EQ.CGAUS(1:4) )THEN
         LCACA= 0
      ELSE IF( CDATA(1:4).EQ.CCACA(1:4) )THEN
         LCACA= 1
      ELSE IF( CDATA(1:4).EQ.CCACB(1:4) )THEN
         LCACA= 2
      ELSE IF( CDATA(1:4).EQ.CLMCD(1:4) )THEN
         LCACA= 3
      ELSE IF( CDATA(1:4).EQ.CTYPE(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( CDATA(1:4).EQ.CS(1:4) )THEN
            ITYPEC= 6
         ELSEIF( CDATA(1:4).EQ.CK(1:4) )THEN
            ITYPEC= 1
         ELSEIF( CDATA(1:4).EQ.CB(1:4) )THEN
            ITYPEC= 4
         ELSE
            CALL XABORT( 'MOCGET: TYPE *S*, *K* OR *B* HAS TO BE READ')
         ENDIF

         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA) 
         IF(ITYPEC .EQ. 6 .OR. ITYPEC .EQ. 1) THEN
            NL= 0
            IF( CDATA(1:4).EQ.CP1(1:4) )THEN
               NL= 1
               IF( NL.GT.NANIS )THEN
                  CALL XABORT('MOCGET: ILLEGAL OPTION = *P1* '//
     >             ' WITHOUT P1 SCATTERING CROSS SECTIONS')
               ENDIF
            ELSE
               GO TO 1001
            ENDIF

         ELSEIF(ITYPEC .EQ. 4)THEN
            IF( CDATA(1:4).EQ.CB0(1:4) )THEN
              IF( ITRANC.NE.0 )THEN
                 CALL XABORT('MOCGET: ILLEGAL OPTION = *B0* '//
     >            ' WITH TRANSPORT CORRECTED CROSS SECTIONS')
              ENDIF
              NBN= 0
              NL= 0
              CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ELSEIF( CDATA(1:4).EQ.CB0TR(1:4) )THEN
              IF( ITRANC.EQ.0 )THEN
                 CALL XABORT('MOCGET: ILLEGAL OPTION = *B0TR* '//
     >            ' WITHOUT TRANSPORT CORRECTED CROSS SECTIONS')
              ENDIF
              NBN= 0
              NL= 0
              ITRB= 1
              CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ELSEIF( CDATA(1:4).EQ.CB1(1:4) )THEN
              NBN= 1
              NL= 0
              IF( NL.GT.NANIS )THEN
                 CALL XABORT('MOCGET: ILLEGAL OPTION = *B1* '//
     >            ' WITHOUT P1 SCATTERING CROSS SECTIONS')
              ENDIF
              CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ENDIF
            ILEAK= 2
            IF( CDATA(1:4).EQ.CSIGS(1:4) )THEN
               CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
               ILEAK= 3
            ELSEIF( CDATA(1:4).EQ.CPNL(1:4) )THEN
               CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
               ILEAK= 2
            ENDIF
            IF( CDATA(1:4).EQ.CKEFF(1:4) )THEN
             CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
             IF( INDLEC.NE.2 ) CALL XABORT('MOCGET: KEFF MUST BE REAL')
             REFKEF= DBLE(ADATA)
            ELSE
               GO TO 1001
            ENDIF
         ENDIF
      ELSE IF( CDATA(1:4).EQ.CNBPN(1:4) )THEN
         CALL REDGET ( INDLEC, NL, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOCGET: NBPN  HAS TO BE READ')
         IF( NL.GT.NANIS )THEN
           CALL XABORT('MOCGET: ANISOTROPY ORDER GREATER THAN MIXTURES')
         ELSEIF( NL.LT.0 )THEN
           CALL XABORT('MOCGET: ANISOTROPY ORDER LESS THAN 0')
         ENDIF
      ELSE IF( CDATA(1:4).EQ.CNOBA(1:4) )THEN
         ILK= .FALSE.
      ELSE IF( CDATA(1:4).EQ.CNSPT(1:4) )THEN
         LMODE(1)= .FALSE.
      ELSE IF( CDATA(1:4).EQ.CBETS(1:4) )THEN
         LMODE(3)= .TRUE.
      ELSE IF( CDATA(1:4).EQ.CANGL(1:4) )THEN
         LMODE(6)= .TRUE.
      ELSE IF( CDATA(1:4).EQ.CACCE(1:4) )THEN
         CALL REDGET ( INDLEC, IFRITR, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOCGET: NLIBRE  HAS TO BE READ')
         CALL REDGET ( INDLEC, IACITR, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOCGET: NACCEL  HAS TO BE READ')
       ELSE IF( CDATA(1:4).EQ.CTHER(1:4) )THEN
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOCGET: NINT OR EPS INTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOCGET: NINT OR EPS INTERNAL HAS TO BE READ')
      ELSE IF( CDATA(1:4).EQ.CEXTE(1:4) )THEN
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOCGET: NEXT OR EPS EXTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOCGET: NEXT OR EPS EXTERNAL HAS TO BE READ')
      ELSE IF( CDATA(1:4).EQ.CADJ(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.3)
     >      CALL XABORT( 'MOCGET: SAJ0 OR SAJ1 HAVE TO BE READ')
         IF(CDATA(1:4).EQ.CEXEC(1:4)) 
     >      CALL XABORT( 'MOCGET: SAJ0 OR SAJ1 HAVE TO BE READ')
         IF((CDATA(1:4).NE.CSAJ0(1:4)).AND.(CDATA(1:4).NE.CSAJ1(1:4)))
     >      CALL XABORT( 'MOCGET: SAJ0 OR SAJ1 HAVE TO BE READ')
         IF(CDATA(1:4).EQ.CSAJ0(1:4))   ISADJ=1
         IF(CDATA(1:4).EQ.CSAJ1(1:4))   ISADJ=2
      ELSE IF( CDATA(1:4).EQ.CDFLX(1:4) )THEN
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
           IF( INDLEC.NE.3)
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF(CDATA(1:4).EQ.CEXEC(1:4)) 
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF((CDATA(1:4).NE.CON(1:4)).AND.(CDATA(1:4).NE.COFF(1:4)))
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF(CDATA(1:4).EQ.CON(1:4))   LFLD = .TRUE.
           IF(CDATA(1:4).EQ.COFF(1:4))  LFLD = .FALSE.
      ELSE IF( CDATA(1:4).EQ.CAJCB(1:4) )THEN
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
           IF( INDLEC.NE.3)
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF(CDATA(1:4).EQ.CEXEC(1:4)) 
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF((CDATA(1:4).NE.CON(1:4)).AND.(CDATA(1:4).NE.COFF(1:4)))
     >      CALL XABORT( 'MOCGET: ON OR OFF HAVE TO BE READ')
           IF(CDATA(1:4).EQ.CON(1:4))   LDAJCB = .TRUE.
           IF(CDATA(1:4).EQ.COFF(1:4))  LDAJCB = .FALSE.
      ELSE
        CALL XABORT('MOCGET: READ ERROR-ILLEGAL KEYWORD '//CDATA(1:4))
      ENDIF
      GOTO 1000 
 2000 CONTINUE
      IF(NL.EQ.-1) NL= NANIS
      IF(NL.NE.0) CALL XABORT('MOCGET: ANISOTROPY *N/A* YET')
      RETURN
      END