*DECK MOCSOT
      SUBROUTINE MOCSOT(IPRT,NREG,NGRP,NFUNL,FLUXO,ADJSOU,VOL)
* 
* ---------------------------  MOCSOT  ---------------------------------
* 
*  1- PROGRAMME STATISTICS:
* 
*      NAME     :  MOCSOT
*      USE      :  VERIFY <S*,PHI>
*      BY       :  MONCHAI A. (24/02/05)  
*
*  2- ROUTINE PARAMETERS:
*    INPUT 
*      FLUXO    : FORWARD FLUX                           R(NUN,
*                                                          NFUNL,
*                                                          NGRP)
*      ADJSOU   : EXTERNAL GENERALIZED ADJOINT SOURCE    R(NREG,NGRP)
*      VOL      : REGIONAL VOLUME                        R(NREG)
*      NGRP     : NUMBER OF GROUPS TREATED               I
*      NFUNL    : NUMBER OF LEGENDRE ORDER FOR FLUX      I
*
*   WORK VECTOR
*
*--------------------------   MOCSOT    ------------------------------
*
      IMPLICIT NONE
      INTEGER      NREG ,NGRP,NFUNL,IPRT
      INTEGER      IG,IR,IS,IOUT
      REAL         FLUXO( NREG,NFUNL,NGRP),ADJSOU(NREG,NGRP),
     >             PROD,VOL(NREG)
      IOUT=6
      PROD = 0.0E0
      DO 100 IR= 1,NREG
       DO 200 IG= 1,NGRP
        PROD = PROD+ VOL(IR)*ADJSOU(IR,IG)*FLUXO(IR,1,IG)
200    CONTINUE
100   CONTINUE
      IF (IPRT .GE. 10 ) THEN
       WRITE(IOUT,'(1X,A9,2X,E14.6)') '<S*,PHI>=', PROD
      ENDIF
      RETURN
      END