*DECK PER
      SUBROUTINE PER(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*----------------------------PER----------------------------------------
*
* 1- PROGRAMME STAT STICS:
*       NAME     : PER
*       USE      : PERTURBATION MODULE
*       AUTHOR   : T. Courau 2000/08/01
*                  M. Assawaroongruengchot 2007/01/01
*
* 2- ROUTINE PARAMETERS:
*     INPUT/OUTPUT PARAMETERS:
*      NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*      HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*      IENTRY : 1 LINKED LIST; 2 XSM FILE;
*               3 SEQUENTIAL BINARY FILE; 4 SEQUENTIAL ASCII FILE.
*      JENTRY : 0 LINKED LIST OR FILE CREATED.
*               1 LINKED LIST OR FILE OPENED FOR MODIFICATIONS;
*               2 LINKED LIST OR FILE OPENED IN READ-ONLY MODE.
*      KENTRY : FILE UNIT NUMBER OR LINKED LIST ADDRESS
*               DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),
*               JENTRY(NENTRY),KENTRY(NENTRY)
* 3- LINKED LIST / XSM FILE:  (ORDER IS ARBITRARY FOR 3,4,5)
*     HENTRY(1) : CREATE OR MODIFICATION TYPE(L_EDIT).
*     HENTRY(2) : READ-ONLY TYPE(L_MACROLIB OR L_LIBRARY).
*     HENTRY(3) : READ-ONLY TYPE(L_TRACK).
*     HENTRY(4) : READ-ONLY TYPE(L_FLUX).
*     HENTRY(5) : READ-ONLY TYPE(L_SADJ).
*     HENTRY(6) : READ-ONLY TYPE(L_MACROLIB OR L_LIBRARY).
*     HENTRY(7) : READ-ONLY TYPE(L_FLUX).
*
*----------------------------PER----------------------------------------
*
      IMPLICIT     NONE
      INTEGER      IOUT,NSTATE,ILCMUP,ILCMDN,NNAM,NBXS,MAXED
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NSTATE=40,NAMSBR='PER   ',
     >             ILCMUP=1,ILCMDN=2,NNAM=6,NBXS=10,MAXED=50)
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      NENTRY
      CHARACTER    HENTRY(NENTRY)*12,HVECT(MAXED)*6
      INTEGER      IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IMAT,IVOL,IKFLX,
     >            JSCATR,JEFISR,JFISSR,JTRANR,JTOTLR,JABSR,JFIXER,
     >            JSCATP,JEFISP,JFISSP,JTRANP,JTOTLP,JABSP,JFIXEP,
     >            JFUNKN,JFUNKA,JDELTA,DQFDIR,JVARFL,JCORMA,JVACOR,
     >            JGAMMA,IDFINT,IDRINT,ITAUXT,ISCATD,INAMEA,
     >            IVOLME,IFLINT,IDISFC,MATMC,JFLUXE,
     >            IFFUEL,IFFNFT,IFUELR,INFI,IMFI,IMFF,ISAD
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IKLIBR,IKTRAK,IKFLUR,IKLIBP,IKFLUP,IPLIBR,
     >            IPTRAK,IPFLUR,IPEDIT,IPLIBP,IPFLUP,
     >            ISTATE(NSTATE),KCHAR(18),
     >            NREG,IPRINT,NGROUP,ILEAK,ITYPEC,ISADJ,
     >            NUNKNO,ITRANC,NIFISS,MXNL,NBMIX,
     >            ITC,IEN,ILCMTY,ILCMLN,NEDMAC,MAXFIS,MNIFIS,
     >            NMERGE,NGCOND,IGCOND, IMERGE,IXSFL(NNAM+1),
     >            ITYPER,INAM,NTAUXT,NELEMT,NELEMD,INDICE(NNAM),IPTMP,
     >            NTENER
      REAL        KEFFP,EIGENK
      CHARACTER   TEXT12*12,TITLE*72,CMODUL*12,HSIGN*12,NAMSAV*12,
     >            NAMREF*12,NAME(NNAM)*6,CGRPNM*12
      LOGICAL     LEAKSW,LOLDXS(NBXS),LSCE,LCOR,LLIN
      INTEGER     NALBP
*----
*  Update for MOCC
*----
      LOGICAL     LMOC
      REAL        REFKEF,DNUM
      INTEGER     IGR,IREACT
      CHARACTER   CNAMT*12
C----
C  PARAMETER VALIDATION
C----
      IF(NENTRY .LT. 5) CALL XABORT(NAMSBR//
     >  ': AT LEAST FIVE DATA STRUCTURES REQUIRED')
      IF(IENTRY(1) .NE. 1 .AND. IENTRY(1) .NE. 2) CALL XABORT(NAMSBR//
     >  ': FIRST DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      IPEDIT=KENTRY(1)
      IF(JENTRY(1) .EQ. 0) THEN
        HSIGN='L_EDIT'
        READ(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
        CALL LCMPUT(IPEDIT,'SIGNATURE',3,3,KCHAR)
      ELSE IF(JENTRY(1) .EQ. 1) THEN
        CALL LCMGET(IPEDIT,'SIGNATURE',KCHAR)
        WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
        IF(HSIGN .NE. 'L_EDIT') THEN
          CALL XABORT(NAMSBR//
     >      ': SIGNATURE OF '//HENTRY(1)//' IS '//HSIGN//
     >      '. L_EDIT EXPECTED.')
        ENDIF
      ELSE
        CALL XABORT(NAMSBR//
     >    ': FIRST EDIT STRUCTURE IN READ-ONLY MODE FORBIDDEN')
      ENDIF
C----
C  SCAN READ-ONLY MODE DATA STRUCTURE
C  FOR LIB/MAC_REF TRACK FLU_REF AND ADJOINT  LIB/MAC_PER AND FLU_PER
C----
      IKLIBR=0
      IKTRAK=0
      IKFLUR=0
      IKLIBP=0
      IKFLUP=0
      IPLIBR=0
      IPTRAK=0
      IPFLUR=0
      IPLIBP=0
      IPFLUP=0
      DO 100 IEN=2,NENTRY
        TEXT12=HENTRY(IEN)
        IF(JENTRY(IEN) .NE. 2) CALL XABORT(NAMSBR//
     >    ': DATA STRUCTURE '//TEXT12//' NOT IN READ-ONLY MODE')
        IF(IENTRY(IEN) .EQ. 1 .OR. IENTRY(IEN) .EQ. 2) THEN
          CALL LCMGET(KENTRY(IEN),'SIGNATURE',KCHAR)
          WRITE(HSIGN,'(3A4)') (KCHAR(ITC),ITC=1,3)
          IF(HSIGN .EQ. 'L_LIBRARY' .AND. IKLIBR .EQ. 0) THEN
            IPLIBR=KENTRY(IEN)
            IKLIBR=IEN
          ELSE IF(HSIGN .EQ. 'L_LIBRARY' .AND. IKLIBR .NE. 0 .AND.
     >                                         IKLIBP .EQ. 0 ) THEN
            IPLIBP=KENTRY(IEN)
            IKLIBP=IEN
          ELSE IF(HSIGN .EQ. 'L_MACROLIB' .AND. IKLIBR .EQ. 0) THEN
            IPLIBR=KENTRY(IEN)
            IKLIBR=-IEN
          ELSE IF(HSIGN .EQ. 'L_MACROLIB' .AND. IKLIBR .NE. 0 .AND.
     >                                          IKLIBP .EQ. 0 ) THEN
            IPLIBP=KENTRY(IEN)
            IKLIBP=-IEN
          ELSE IF(HSIGN .EQ. 'L_TRACK' .AND. IKTRAK .EQ. 0) THEN
            IPTRAK=KENTRY(IEN)
            IKTRAK=IEN
          ELSE IF(HSIGN .EQ. 'L_FLUX' .AND. IKFLUR .EQ. 0 ) THEN
            IPFLUR=KENTRY(IEN)
            IKFLUR=IEN
          ELSE IF(HSIGN .EQ. 'L_FLUX' .AND. IKFLUR .NE. 0 .AND.
     >                                      IKFLUP .EQ. 0 ) THEN
            IPFLUP=KENTRY(IEN)
            IKFLUP=IEN
          ENDIF
        ENDIF
 100  CONTINUE
C----
C  TEST FOR MISSING STRUCTURE (STRUCTURE ABSOLUTELY REQUIRED)
C----
      IF(IKFLUR .EQ. 0) CALL XABORT(NAMSBR//
     >  ': NO DATA STRUCTURE WITH SIGNATURE L_FLUX FOUND.')
      IF(IKTRAK .EQ. 0) CALL XABORT(NAMSBR//
     >  ': NO DATA STRUCTURE WITH SIGNATURE L_TRACK FOUND.')
      IF(IKLIBR .EQ. 0 .OR. IKLIBP .EQ. 0 ) CALL XABORT(NAMSBR//
     >  ': TWO DATA STRUCTURES WITH SIGNATURE '//
     >   'L_LIBRARY OR L_MACROLIB REQUIRED.')
C----
C  RECOVER IPTRAK INFORMATION
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRAK,'STATE-VECTOR',ISTATE)
      CALL LCMGET(IPTRAK,'TRACK-TYPE  ',KCHAR)
      WRITE(CMODUL,'(3A4)') (KCHAR(ITC),ITC=1,3)
      NREG=ISTATE(1)
      IF(NREG .EQ. 0) CALL XABORT(NAMSBR//': NREG = 0')
      NUNKNO=ISTATE(2)
      LEAKSW=ISTATE(3).EQ.0
      CALL SETARA(IBASE,NREG,IMAT)
      CALL SETARA(RBASE,NREG,IVOL)
      CALL SETARA(IBASE,NREG,IKFLX)
      CALL LCMGET(IPTRAK,'MATCOD      ',IBASE(IMAT))
      CALL LCMGET(IPTRAK,'VOLUME      ',RBASE(IVOL))
      CALL LCMGET(IPTRAK,'KEYFLX      ',IBASE(IKFLX))
      CALL LCMLEN(IPTRAK,'TITLE       ',ILCMLN,ILCMTY)
      IF(ILCMLN .GT. 0) THEN
        CALL LCMGET(IPTRAK,'TITLE',KCHAR)
        WRITE(TITLE,'(18A4)') (KCHAR(ITC),ITC=1,18)
      ELSE
        TITLE='*** NO TITLE PROVIDED ***'
      ENDIF
C----
C  RECOVER MACROLIB INFORMATION
C----
      IF(IKLIBR .GT. 0) CALL LCMSIX(IPLIBR,'MACROLIB',ILCMUP)
      IF(IKLIBP .GT. 0) CALL LCMSIX(IPLIBP,'MACROLIB',ILCMUP)
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPLIBR,'STATE-VECTOR',ISTATE)
      NBMIX=ISTATE(2)
      MXNL=ISTATE(3)
      NIFISS=ISTATE(4)
      NEDMAC=ISTATE(5)
      ITRANC=ISTATE(6)
      NALBP =ISTATE(8)
C----
C  RECOVER HOMOGENIZED XS  INFORMATION
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPEDIT,'STATE-VECTOR',ISTATE)
      NMERGE=ISTATE(1)
      NGCOND=ISTATE(2)
      LCOR=(ISTATE(17).EQ.1)
C     --- CHECK 'FLUX1-CORR  ' DIRECTORY ---
      CALL LCMLEN(IPFLUR,'FLUX1-CORR  ',ILCMLN,ILCMTY)
C     --- IF DIRECTORY EXIST ENABLE LCOR ---
      LCOR = .FALSE.
      IF(ILCMLN .EQ. -1) LCOR = .TRUE.
      CALL SETARA(IBASE,NREG,IMERGE)
      CALL SETARA(IBASE,NGCOND,IGCOND)
      CALL XDISET(IBASE(IMERGE),NREG,0)
      CALL XDISET(IBASE(IGCOND),NGCOND,0)
      CALL LCMGET(IPEDIT,'REF:IMERGE',IBASE(IMERGE))
      CALL LCMGET(IPEDIT,'REF:IGCOND',IBASE(IGCOND))
C---
C CHECK THE HOMOGENIZED XS TREATED
C---
      NAME(1)='TOTAL '
      NAME(2)='TRANC '
      NAME(3)='NUSIGF'
      NAME(4)='NFTOT '
      NAME(5)='CHI   '
      NAME(6)='ABS   '
      NAMREF='MACROREF    '
      CALL XDISET(IXSFL,NNAM+1,0)
      CALL XDISET(INDICE,NNAM,0)
      CALL LCMSIX(IPEDIT,NAMREF,ILCMUP)
      WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') 1,NGCOND
      CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
      DO 150 INAM=1,NNAM
        CALL LCMLEN(IPEDIT,NAME(INAM),ILCMLN,ILCMTY)
        IF (ILCMLN.GT.0) IXSFL(INAM)=1
 150  CONTINUE
      CALL LCMLEN(IPEDIT,'SCAD 0      ',ILCMLN,ILCMTY)
      IF (ILCMLN.GT.0) IXSFL(NNAM+1)=1
      CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
      CALL LCMSIX(IPEDIT,NAMREF,ILCMDN)
C---
C MERGED PARAMETERS
C---
      IF (NIFISS.GT.0) THEN
       MNIFIS=1
      ELSE
       MNIFIS=0
      ENDIF
      IF (IXSFL(1) .EQ. 1) INDICE(1)=2
      IF (IXSFL(2) .EQ. 1) INDICE(2)=10
      IF (IXSFL(3) .EQ. 1) THEN
        INDICE(3)=13
        INDICE(5)=9
      ENDIF
      IF (IXSFL(6) .EQ. 1) INDICE(6)=3
      IF(IXSFL(4) .EQ. 1) INDICE(4)=13+2*MNIFIS
C----
C  RECOVER FLUX INFORMATION
C----
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPFLUR,'STATE-VECTOR',ISTATE)
      ITYPEC=ISTATE(1)
      ILEAK=ISTATE(2)
      ISADJ=ISTATE(8)
      NGROUP=ISTATE(9)
      MAXFIS=MAX(1,NIFISS)
      CALL SETARA(RBASE,NGROUP,IREACT)
      CALL XDRSET(RBASE(IREACT),NGROUP,0.0)
C----
C  READ PER EXECUTION OPTIONS
C----
      CALL PERGET(IPRINT,NAMSAV,ITYPER,LLIN,
     >            LMOC)
      IF (IPFLUP.EQ.0 .AND. ITYPER.GT.0) THEN
         CALL XABORT(NAMSBR//': PERTURBED FLUX REQUIRED')
      ELSE IF (ITYPER.EQ.0) THEN
         IPFLUP=0
      ENDIF
      IF(IPRINT .GE. 1) THEN
        IF(LCOR) THEN
          WRITE(IOUT,'(1X,A6,2X,A33)') 
     >    NAMSBR,'GPT CORRECTION MODE (LCOR) : ON  '
        ELSE
          WRITE(IOUT,'(1X,A6,2X,A33)') 
     >    NAMSBR,'GPT CORRECTION MODE (LCOR) : OFF '
        ENDIF
        WRITE(IOUT,'(1X,A6,2X,A24)') 
     >  NAMSBR,'GPT CORRECTION MODE : ON'
      ENDIF
      IF (ITYPER.EQ.2) THEN
C---
C COMPUTE PERTURBED HOMOGENIZED PORPERTIES
C---
       LSCE=.FALSE.
       IPTMP=0
       NTENER=0
       NELEMT=NMERGE*NGCOND
       NELEMD=(1+NMERGE)*NGCOND
       NTAUXT=13+3*NIFISS+MXNL+NEDMAC+1
       CALL SETARA(RBASE,2*NELEMD*NTAUXT,ITAUXT)
       CALL SETARA(RBASE,2*NMERGE,IVOLME)
       CALL SETARA(RBASE,2*NELEMT*NGCOND*MXNL,ISCATD)
       CALL SETARA(RBASE,(NBMIX+1)*NGROUP*NNAM,ISAD)
       CALL SETARA(RBASE,4*NREG*NGROUP,IFLINT)
       CALL SETARA(RBASE,NGCOND,IDISFC)
       CALL SETARA(IBASE,NMERGE,MATMC)
       CALL SETARA(IBASE,2*NEDMAC,INAMEA)
       CALL SETARA(RBASE,NREG*MAX(NIFISS,1),IFFUEL)
       CALL SETARA(RBASE,NREG*MAX(NIFISS,1),IFFNFT)
       CALL SETARA(IBASE,NREG,IFUELR)
       CALL SETARA(IBASE,2*MAX(NIFISS,1),INFI)
       CALL SETARA(IBASE,NBMIX*MAX(NIFISS,1),IMFI)
       CALL SETARA(IBASE,NMERGE*MAX(NIFISS,1),IMFF)
       CALL SETARA(RBASE,NREG*NGROUP,JFLUXE)
       CALL LCMGET(IPFLUP,'K-EFFECTIVE',EIGENK)
       CALL LCMSIX(IPFLUP,'FLUXDIRECT  ',ILCMUP)
       CALL SADDTX(IPEDIT,IPTMP ,IPFLUP,IPLIBP,NGROUP,NGCOND,
     >             NBMIX ,NREG  ,NMERGE,MXNL  ,NIFISS,NEDMAC,
     >             NTAUXT,IXSFL ,LSCE  ,NAMSAV,EIGENK,NTENER,
     >             HVECT ,ITRANC,
     >             IBASE(IMAT)  ,RBASE(IVOL)  ,IBASE(IKFLX) ,
     >             IBASE(IGCOND),IBASE(IMERGE),RBASE(JFLUXE),
     >             RBASE(IVOLME),RBASE(ITAUXT),RBASE(IFLINT),
     >             RBASE(ISCATD),IBASE(INAMEA),RBASE(IFFUEL),
     >             IBASE(IFUELR),IBASE(MATMC) ,IBASE(INFI)  ,
     >             IBASE(IMFI)  ,IBASE(IMFF)  ,RBASE(IFFNFT),
     >             RBASE(ISAD)  )
       IF(IKLIBP .GT. 0) CALL LCMSIX(IPLIBP,'MACROLIB',ILCMDN)
       CALL LCMSIX(IPFLUP,'FLUXDIRECT  ',ILCMDN)
       CALL RLSARA(RBASE(JFLUXE))
       CALL RLSARA(IBASE(IMFF))
       CALL RLSARA(IBASE(IMFI))
       CALL RLSARA(IBASE(INFI))
       CALL RLSARA(IBASE(IFUELR))
       CALL RLSARA(RBASE(IFFNFT))
       CALL RLSARA(RBASE(IFFUEL))
       CALL RLSARA(IBASE(INAMEA))
       CALL RLSARA(IBASE(MATMC))
       CALL RLSARA(RBASE(IDISFC))
       CALL RLSARA(RBASE(IFLINT))
       CALL RLSARA(RBASE(ISAD))
       CALL RLSARA(RBASE(ISCATD))
       CALL RLSARA(RBASE(IVOLME))
       CALL RLSARA(RBASE(ITAUXT))
      ELSE
C---
C PERFORM PERTURBATIONS
C---
C---
C COMPUTE VARIATION IN INPUT MACROLIBS
C--
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JTOTLR)
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JABSR)
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JTRANR)
       CALL SETARA(RBASE,NBMIX*NGROUP*MAXFIS*3    ,JFISSR)
       CALL SETARA(RBASE,NBMIX*NGROUP*3           ,JFIXER)
       CALL SETARA(RBASE,NBMIX*MAXFIS             ,JEFISR)
       CALL SETARA(RBASE,NBMIX*NGROUP*NGROUP*MXNL ,JSCATR)
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JTOTLP)
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JABSP)
       CALL SETARA(RBASE,NBMIX*NGROUP             ,JTRANP)
       CALL SETARA(RBASE,NBMIX*NGROUP*MAXFIS*3    ,JFISSP)
       CALL SETARA(RBASE,NBMIX*NGROUP*3           ,JFIXEP)
       CALL SETARA(RBASE,NBMIX*MAXFIS             ,JEFISP)
       CALL SETARA(RBASE,NBMIX*NGROUP*NGROUP*MXNL ,JSCATP)
       CALL PERMAC(IPLIBR,IPLIBP,NBMIX ,NGROUP,
     >             MXNL  ,NIFISS,MAXFIS,LOLDXS,
     >             RBASE(JTOTLR),RBASE(JTRANR),RBASE(JFISSR),
     >             RBASE(JFIXER),RBASE(JSCATR),RBASE(JEFISR),
     >             RBASE(JTOTLP),RBASE(JTRANP),RBASE(JFISSP),
     >             RBASE(JFIXEP),RBASE(JSCATP),RBASE(JEFISP),
     >             RBASE(JABSR),RBASE(JABSP),
     >             NALBP)
       IF(IKLIBP .GT. 0) CALL LCMSIX(IPLIBP,'MACROLIB',ILCMDN)
       IF(IKLIBR .GT. 0) CALL LCMSIX(IPLIBR,'MACROLIB',ILCMDN)
C------
C COMPUTE VARIATIONS VECTORS
C------
       CALL SETARA(RBASE,NREG*NGROUP,JVARFL)
       CALL SETARA(RBASE,NUNKNO*NGROUP,JVACOR)
       CALL SETARA(RBASE,NUNKNO*NGROUP,JFUNKN)
       CALL SETARA(RBASE,NUNKNO*NGROUP,JFUNKA)
       CALL SETARA(RBASE,NREG*NGROUP*3,JDELTA)
       CALL SETARA(RBASE,2*NREG*MAXFIS,DQFDIR)
       CALL SETARA(RBASE,NREG*NBMIX*NGROUP,JCORMA)
       IF( IPRINT.GE.1000)
     >   WRITE(IOUT,'(1X,A20)') 'RUNNING PER->>PERVEC'
       CALL PERVEC(IPFLUR,IPFLUP,NBMIX ,NGROUP,MXNL  ,NIFISS,
     >             MAXFIS,NUNKNO,NREG  ,LOLDXS,KEFFP ,LCOR  ,
     >             LLIN,
     >             IBASE(IKFLX) ,IBASE(IMAT)  ,RBASE(IVOL)  ,
     >             RBASE(JTOTLP),RBASE(JTRANP),RBASE(JFISSP),
     >             RBASE(JFIXEP),RBASE(JSCATP),RBASE(JFISSR),
     >             RBASE(JFUNKN),RBASE(JFUNKA),RBASE(JDELTA),
     >             RBASE(DQFDIR),RBASE(JCORMA),RBASE(JVARFL),
     >             RBASE(JVACOR),
     >             IPRINT,LMOC,RBASE(IREACT)   )
       IF( IPRINT.GE.1000) 
     >   WRITE(IOUT,'(1X,A20)') 'RUNNING PERVEC->>PER'
       CALL RLSARA(RBASE(JCORMA))
       CALL RLSARA(RBASE(DQFDIR))
       CALL RLSARA(RBASE(JDELTA))
       CALL RLSARA(RBASE(JFUNKA))
       CALL RLSARA(RBASE(JSCATR))
       CALL RLSARA(RBASE(JEFISR))
       CALL RLSARA(RBASE(JFIXER))
       CALL RLSARA(RBASE(JFISSR))
       CALL RLSARA(RBASE(JTRANR))
       CALL RLSARA(RBASE(JABSR))
       CALL RLSARA(RBASE(JTOTLR))
C-----
C  COMPUTE PERTURBATION
C----
       CALL SETARA(RBASE,NUNKNO*NGROUP,JGAMMA)
       CALL SETARA(RBASE,2*NMERGE*NGCOND,IDFINT)
       CALL SETARA(RBASE,2*NMERGE*NGCOND,IDRINT)
       NELEMT=NMERGE*NGCOND
       NELEMD=(1+NMERGE)*NGCOND
       NTAUXT=13+3*MNIFIS+MXNL+NEDMAC+1
       CALL SETARA(RBASE,2*NELEMD*NTAUXT,ITAUXT)
       CALL SETARA(RBASE,2*NELEMT*NGCOND*MXNL,ISCATD)
       CALL SETARA(IBASE,2*NEDMAC,INAMEA)
       IF( IPRINT.GE.1000)
     >   WRITE(IOUT,'(1X,A20)') 'RUNNING PER->>PERPER'
       CALL PERPER(IPFLUR,IPFLUP,IPEDIT,NBMIX ,NGROUP,MXNL ,
     >             NIFISS,MAXFIS,NUNKNO,NREG  ,LOLDXS,KEFFP,
     >             NMERGE,IXSFL ,MNIFIS,NAME  ,NGCOND,NTAUXT,
     >             NEDMAC,EIGENK,NAMSAV,INDICE,LCOR  ,
     >             IBASE(IKFLX) ,IBASE(IMAT),RBASE(IVOL),
     >             IBASE(IMERGE),IBASE(IGCOND),RBASE(JTOTLP),
     >             RBASE(JTRANP),RBASE(JFISSP),RBASE(JFIXEP),
     >             RBASE(JSCATP),RBASE(JFUNKN),RBASE(JGAMMA),
     >             RBASE(IDFINT),RBASE(IDRINT),RBASE(ITAUXT),
     >             RBASE(ISCATD),IBASE(INAMEA),RBASE(JVARFL),
     >             RBASE(JVACOR),RBASE(JABSP))
       IF( IPRINT.GE.1000) 
     >   WRITE(IOUT,'(1X,A20)') 'RUNNING PERPER->>PER'
       CALL RLSARA(IBASE(INAMEA))
       CALL RLSARA(RBASE(ISCATD))
       CALL RLSARA(RBASE(ITAUXT))
       CALL RLSARA(RBASE(IDRINT))
       CALL RLSARA(RBASE(IDFINT))
       CALL RLSARA(RBASE(JGAMMA))
       CALL RLSARA(RBASE(JFUNKN))
       CALL RLSARA(RBASE(JVACOR))
       CALL RLSARA(RBASE(JVARFL))
C------
C RELEASE MACROLIB INFORMATION
C------
       CALL RLSARA(RBASE(JSCATP))
       CALL RLSARA(RBASE(JEFISP))
       CALL RLSARA(RBASE(JFIXEP))
       CALL RLSARA(RBASE(JFISSP))
       CALL RLSARA(RBASE(JTRANP))
       CALL RLSARA(RBASE(JABSP))
       CALL RLSARA(RBASE(JTOTLP))
      ENDIF
C----
C SAVING  GROUP-BASED DELTAREACTIVITY ESTIMATE ON DIRECTORY *CREACT*
C----
      IF(ITYPER.EQ.0 .AND. LLIN) THEN
        CNAMT='DELTAREACTIV'
        CALL LCMPUT(IPEDIT,CNAMT,NGROUP,2, RBASE(IREACT))
C----
C SAVING  GROUP-BASED DLAMBDA/LAMBDA ESTIMATE ON DIRECTORY CLMBDA
C----
        CALL LCMGET(IPFLUR,'K-EFFECTIVE ',REFKEF)
       DO 600 IGR=1,NGROUP
          RBASE(IREACT-1+IGR) = -RBASE(IREACT-1+IGR)*REFKEF
 600   CONTINUE 
        CNAMT='DLMBD/LAMBDA'
        CALL LCMPUT(IPEDIT,CNAMT,NGROUP,2, RBASE(IREACT) )
        CALL LCMGET(IPEDIT,CNAMT,RBASE(IREACT))
        DNUM = 0.000E+0
        DO 601 IGR=1,NGROUP
          DNUM = DNUM + RBASE(IREACT-1+IGR)/REFKEF
 601    CONTINUE
        WRITE(IOUT,'(1X,A17,2X,E20.10)') 'DELTA LAMBDA   = ',DNUM
      ENDIF
C----
C  RELEASE OTHERS
C----
      CALL RLSARA(RBASE(IREACT))
C----
C  RELEASE CONDENSATION/MERGE VECTOR
C----
      CALL RLSARA(IBASE(IGCOND))
      CALL RLSARA(IBASE(IMERGE))
C----
C  RELEASE GENERAL TRACKING INFORMATION
C----
      CALL RLSARA(IBASE(IKFLX))
      CALL RLSARA(RBASE(IVOL))
      CALL RLSARA(IBASE(IMAT))
      RETURN
      END
