*DECK PERGET
      SUBROUTINE PERGET(IPRINT,NAMSAV,ITYPER,LLIN,
     >                  LMOC)
C
C---------------------------  PERGET  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : PERGET
C       USE      : READ AND ANALYZE DATA FOR PER MODULE
C       AUTHOR   : T. Courau 2000/08/01
C                  M. Assawaroongruengchot 2007/01/01
C
C   2- ROUTINE PARAMETERS:
C      IPRINT  : PRINT SELECTION FOR PER MODULE:                I
C               = 0/1/2/3 NO PRINT/SHORT PRINT/LONG
C      NAMSAV  : NAME OF THE DIRECTORY WHERE THE
C                INFORMATION IS STORED                          C(12)
C      ITYPER  : TYPE OF PERTURBATION CONSIDERED                I
C               = 0 THE REFERENCE FLUX IS USED IN
C                   THE PETURBATION FORMULA
C               = 1 THE PERTURBED FLUX  IS USED IN
C                   THE PETURBATION FORMULA
C               = 2 THE HOMOGENIZED PROPERTIES ARE
C                   COMPUTED DIRECTLY WITH THE PERTURBED FLUX
C      LLIN  : FLAG TO COMPUTE SENSITIVITY COEFFICIENT          L
C               IF (LLIN) 2nd ORDERS TERM ARE NOT COMPUTED IN
C               PERTURBATION FORMULAS
C      LMOC  : FLAG TO USE MOC CALCULATION                      L
C
C---------------------------   PERGET  --------------------------------
C
      IMPLICIT    NONE
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='PERGET')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPRINT,ITYPER
      LOGICAL     LLIN
      CHARACTER   NAMSAV*12
      LOGICAL     LMOC
C----
C  LOCAL PARAMETERS
C----
      INTEGER     ITYPLU,INTLIR
      CHARACTER   CARLIR*4
      REAL        REALIR
      DOUBLE PRECISION DBLLIR
C---
C INITIALIZE OPTIONS
C---
      IPRINT=1
      NAMSAV='MACROPER'
      ITYPER=0
      LLIN=.FALSE.
      LMOC=.FALSE.
C----
C  READ OPTIONS
C----
 100  CONTINUE
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
      IF(ITYPLU .EQ. 10) GO TO 1000
      IF (ITYPLU.NE.3) CALL XABORT(NAMSBR//
     > ': READ ERROR - CHARACTER VARIABLE EXPECTED')
      IF (CARLIR.EQ.'SAVE') THEN
       CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
       IF (ITYPLU.NE.3 .OR. CARLIR(1:2) .NE. 'ON') CALL XABORT(NAMSBR//
     >  ': READ ERROR - CHARACTER ON  EXPECTED AFTER KEYWORD SAVE')
       CALL REDGET(ITYPLU,INTLIR,REALIR,NAMSAV,DBLLIR)
       IF (ITYPLU.NE.3) CALL XABORT(NAMSBR//
     > ': READ ERROR - CHARACTER VARIABLE EXPECTED')
      ELSE IF (CARLIR.EQ.'TYPE') THEN
       CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
       IF (ITYPLU.NE.3)  CALL XABORT(NAMSBR//
     >  ': READ ERROR - CHARACTER KEYWORD EXPECTED AFTER KEYWORD TYPE')
       IF (CARLIR.EQ.'DIR') THEN
         ITYPER=0
       ELSE IF  (CARLIR.EQ.'PER') THEN
         ITYPER=1
       ELSE IF  (CARLIR.EQ.'CALC') THEN
         ITYPER=2
       ELSE
        CALL  XABORT(NAMSBR//': BAD KEYWORD AFTER TYPE')
       ENDIF
      ELSE IF(CARLIR .EQ. 'EDIT') THEN
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': READ ERROR - EDIT LEVEL EXPECTED')
        IPRINT=INTLIR
      ELSE IF (CARLIR(1:4).EQ.'LIN') THEN
       LLIN=.TRUE.
      ELSE IF (CARLIR(1:4).EQ.'MOC') THEN
       LMOC=.TRUE.
      ELSE IF(CARLIR(1:1) .EQ. ';') THEN
       GO TO 1000
      ELSE
        CALL  XABORT(NAMSBR//': BAD CHARACTER KEYWORD: '//CARLIR)
      ENDIF
      GO TO 100
 1000 CONTINUE
      RETURN
      END
