*DECK PIJCPL
      SUBROUTINE PIJCPL(NREGIO,NBMIX ,NELPIJ,MATCOD,VOLUME,XSSIGT,
     >                  PIJSYM,PIS   )
C
C---------------------------  PIJCPL  ---------------------------------
C
C   1-  PROGRAMME STATISTICS:
C
C          NAME       :  PIJCPL
C          FUNCTION   :  COMPUTE CP MATRIX LEAKAGE MATRIX
C          DATE       :  2000/01/21
C          AUTHOR     :  G. MARLEAU
C
C   2-  PARAMETERS:
C      INPUT
C         NREGIO  : NUMBER OF REGIONS CONSIDERED       I
C         NBMIX   : NUMBER OF MIXTURES                 I
C         NELPIJ  : DIMENSION OF SYMMETRIC PIJ MATRIX  I
C         MATCOD  : MATERIAL CODE IN REGION            I(NREGIO)
C         VOLUME  : VOLUME OF REGION                   R(NREGIO)
C         XSSIGT  : TOTAL MACROSCOPIC X.S.             R(NBMIX)
C         PIJSYM  : GROUP CONDENSED REDUCE/SYMMETRIC   R(NELPIJ)
C                   PIJ MATRIX
C      OUTPUT
C         PIS     : SCRATCH STORAGE.                   R(NREGIO)
C
C---------------------------   PIJCPL  --------------------------------
C
      IMPLICIT   NONE
      INTEGER    NREGIO,NBMIX,NELPIJ
      INTEGER    MATCOD(NREGIO)
      REAL       VOLUME(NREGIO),XSSIGT(0:NBMIX),
     >           PIJSYM(NELPIJ),PIS(NREGIO)
C----
C LOCAL VARIABLES
C----
      INTEGER          INDPOS,I,J,MATNUM
      DOUBLE PRECISION SUM
C----
C  INTRINSIC FUNCTION FOR POSITION IN CONDENSE PIJ MATRIX
C----
      INDPOS(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
      DO 100 I=1,NREGIO
        SUM=0.0D0
        DO 110 J=1,NREGIO
          MATNUM=MATCOD(J)
          SUM=SUM+XSSIGT(MATNUM)*PIJSYM(INDPOS(I,J))/VOLUME(I)
110     CONTINUE
        PIS(I)=1.0D0-SUM
100   CONTINUE
      RETURN
      END
