*DECK QIJPRL
      SUBROUTINE QIJPRL(IPSYS ,NREG  ,NGRP  ,NGRT  ,
     >                  LGRP  ,VOLUME,SIGINV,PIS   ,ARRAY )
C
C-------------------------    QIJPRL    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : QIJPRL
C     LEVEL    : 4 (CALLED BY 'XL3TRK')
C     USE      : THIS ROUTINE PUT LEAKAGE PROBABILITIES (CP)
C                IN LCM GROUP-BY-GROUP FORMAT.
C                AND STORE THEM ON IPSYS
C     CREATION : 2000/01/21
C     AUTHOR   : G. MARLEAU
C
C 2- PARAMETERS:
C  INPUT
C     IPSYS   : POINTER TO SYSTEM OBJECT.            I
C     NREG    : # OF ZONES FOR GEOMETRY.             I
C     NGRP    : # OF GROUPS TREATED HERE.            I
C     NGRT    : TOTAL # OF GROUPS.                   I
C     LGRP    : FIRST GROUP POSITION.                I(NGRP)
C     VOLUME  : VOLUME VECTOR.                       R(NREG)
C     SIGINV  : SIGT INVERSE VECTOR                  R(NREG)
C     PIS     : LEAKAGE MATRIX                       D(NGRP,NREG)
C  OUTPUT
C     ARRAY   : SINGLE-PRECISION LEAKAGE MATRIX      R(NREG)
C
C-------------------------    QIJPRL    -------------------------------
C
      IMPLICIT         NONE
      INTEGER          IPSYS,NREG,NGRP,NGRT
      INTEGER          LGRP(NGRP)
      REAL             SIGINV(NGRP,NREG),VOLUME(NREG),ARRAY(NREG)
      DOUBLE PRECISION PIS(NGRP,NREG)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER  CGRPNM*12
      INTEGER    IGRP, IV
      INTEGER    ILCMUP,  ILCMDN
      PARAMETER (ILCMUP=1,ILCMDN=2)
C----
C  LOOP OVER GROUPS
C----
      DO 100 IGRP=1,NGRP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') LGRP(IGRP),NGRT
        CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
        DO 110 IV=1,NREG
          ARRAY(IV)=PIS(IGRP,IV)*SIGINV(IGRP,IV)/VOLUME(IV)
 110    CONTINUE
        CALL LCMPUT(IPSYS,'DRAGON-PIS  ',NREG,2,ARRAY)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMDN)
 100  CONTINUE
      RETURN
      END
