*DECK QIJPRT
      SUBROUTINE QIJPRT(IPSYS,LGRP,NGRP,NGRT,NREG,PROB,ARRAY,IPRT)
C
C-------------------------    QIJPRT    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : QIJPRT
C     LEVEL    : 4 (CALLED BY 'XL3TRK')
C     USE      : THIS ROUTINE PUT COLLISION PROBABILITIES (CP)
C                IN LCM GROUP-BY-GROUP FORMAT.
C     AUTHOR   : R. ROY (96-09-24)
C
C 2- PARAMETERS:
C  INPUT
C     IPSYS   : POINTER TO SYSTEM OBJECT.            I
C     IBEGGR  : FIRST GROUP POSITION.                I
C     NGRP    : # OF GROUPS TREATED HERE.            I
C     NGRT    : TOTAL # OF GROUPS.                   I
C     NREG    : # OF ZONES FOR GEOMETRY.             I
C     PROB    : -CP- MATRIX FOR ALL TYPES.           D(NGRP,*)
C     IPRT    : PRINTING INDEX.                      I
C  OUTPUT
C     ARRAY   : WORKING ARRAY FOR SINGLE-PRECISION CP.    R(*)
C-----------------------------------------------------------------------
      IMPLICIT   NONE
      INTEGER    IOUT
      PARAMETER (IOUT=6)
      INTEGER    IPSYS,IPRT,NGRP,NGRT,NREG,NREG2,ISTART,LGRP(NGRP)
      DOUBLE PRECISION PROB(NGRP,*)
      REAL       ARRAY(*)
      CHARACTER  CGRPNM*12
      INTEGER    IGRP, IV, JV
      INTEGER    ILCMUP,  ILCMDN
      PARAMETER (ILCMUP=1,ILCMDN=2)
      NREG2= NREG*NREG
      ISTART= (NREG*(NREG+1))/2
      DO 80 IGRP=1,NGRP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') LGRP(IGRP),NGRT
        CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
        DO 81 IV=1,NREG2
          ARRAY(IV)= PROB(IGRP,IV+ISTART)
  81    CONTINUE
        CALL LCMPUT(IPSYS,'DRAGON-PCSCT',NREG2,2,ARRAY)
        CALL LCMSIX(IPSYS,' ',ILCMDN)
  80  CONTINUE
      IF(IPRT.GE.8)THEN
        ISTART= (NREG*(NREG+1))/2
        DO 180 IGRP=1,NGRP
          WRITE(IOUT,1200) LGRP(IGRP)
          WRITE(IOUT,1300) (JV,JV=1,NREG)
          DO 181 IV= 1,NREG
            WRITE(IOUT,1400) IV,
     >        (PROB(IGRP,ISTART+IV+(JV-1)*NREG),JV=1,NREG)
 181      CONTINUE
 180    CONTINUE
      ENDIF
C
      RETURN
 1200 FORMAT(1X,'GROUP # ',I10,' --------------------------')
 1300 FORMAT (//53H SCATTERING MODIFIED COLLISION PROBABILITIES MATRIX :
     1 //(11X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,
     2 I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,2HJ=,I4,:,5X,
     3 2HJ=,I4,:,5X,2HJ=,I4))
 1400 FORMAT (3H I=,I4,2H: ,1P,11E11.3/(9X,11E11.3))
      END
