*DECK QIJWPR
      SUBROUTINE QIJWPR(LOPT,NREG,NSOUT,LGRP,NGRP,SIGTAL,PROB)
C
C-------------------------    QIJWPR    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : QIJWPR
C     LEVEL    : 2 (CALLED BY 'XL3TRK')
C     USE      : PRINT-OUT FOR PROBABILITY MATRICES
C     AUTHOR   : R. ROY
C
C 2- PARAMETERS:
C  INPUT
C     LOPT    : PRINT-OUT FORM                         I
C               LOPT.LE.0
C                PRINT ALL  PSS/PVS/PVV
C               LOPT.GT.0
C                PRINT ONLY PVV
C     NREG    : TOTAL NUMBER OF REGIONS                I
C     NSOUT   : NUMBER OF OUTER SURFACE                I
C     LGRP    : LIST OF GROUPS.                        I(NGRP)
C     NGRP    : # OF GROUPS.                           I
C     SIGTAL  : ALBEDO-CROSS SECTION VECTOR            R(NSOUT:NREG)
C               IS=NSOUT,-1; SIGTAL(IS)=ALBEDO(-IS)
C               IV=1,NREG ;   SIGTAL(IV)=SIGT(IV)
C     PROB    : COMPRESS PROBABILITY MATRIX            R(NPLEN)
C               NPLEN=(NREG-NSOUT+2)*(NREG-NSOUT+1)/2
C               IND(I,J)=MAX(I-NSOUT+1,J-NSOUT+1)
C                       *(MAX(I-NSOUT+1,J-NSOUT+1)-1)/2
C                       +MIN(I-NSOUT+1,J-NSOUT+1)
C
C         JS=NSOUT,-1;                I=IND(0,JS)
C           PROB(I)=VOLSUR(JS)
C         IV=1,NREG;                  I=IND(IV,0)
C           SIGT(IV).GT.0.0
C             PROB(I)=SIGT(IV)*VOLSUR(IV)
C           SIGT(IV).EQ.0.0
C             PROB(I)=VOLSUR(IV)
C
C         IS=NSOUT,-1; JS=NSOUT,IS; I=IND(IS,JS)
C           PROB(I)=VOLSUR(IS)*PSS(IS,JS)
C         IV=1,NREG; JS=NSOUT,-1;    I=IND(IV,JS)
C           SIGT(IV).GT.0.0
C             PROB(I)=SIGT(IV)*VOLSUR(IV)*PVS(IV,JS)
C           SIGT(IV).EQ.0.0
C             PROB(I)=VOLSUR(IV)*PVS(IV,JS)
C         IV=1,NREG; JV=1,IV;         I=IND(IV,JV)
C           SIGT(IV).GT.0.0 AND SIGT(JV).GT.0.0
C             PROB(I)=SIGT(IV)*SIGT(JV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).GT.0.0 AND SIGT(JV).EQ.0.0
C             PROB(I)=SIGT(IV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).EQ.0.0 AND SIGT(JV).GT.0.0
C             PROB(I)=SIGT(JV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).EQ.0.0 AND SIGT(JV).EQ.0.0
C             PROB(I)=VOLSUR(IV)*PVV(IV,JV)
C
C-------------------------    QIJWPR    -------------------------------
C
      IMPLICIT            NONE
      INTEGER           IUNOUT,   LOPT,   NREG,  NSOUT,   NGRP,
     >              LGRP(NGRP),    IND,      I,      J,   NSUR,   NVOL,
     >                   NSURC,  NSURM,  NVOLC,  NVOLM,     IP,     IR,
     >                      JR,      K,     IG
      PARAMETER        (IUNOUT=6)
      REAL              SIGTAL(NGRP,NSOUT:NREG)
      DOUBLE PRECISION  PROB(NGRP,*), BILANP(10), XSJR, WPR
C
      IND(I,J) = MAX(I-NSOUT+1,J-NSOUT+1)*(MAX(I-NSOUT+1,J-NSOUT+1)-1)/2
     >         + MIN(I-NSOUT+1,J-NSOUT+1)
C
      WPR(K,I,J)= PROB(K, IND(I,J) ) / PROB(K, IND(I,0) )
C
CNOTE:
C     IF( SIGT(I).NE.0.0 )THEN
C        PROB(IND(I,0)= SIGT(I) * VOLSUR(I)
C     ELSE
C        PROB(IND(I,0)= VOLSUR(I)
C     ENDIF
C
      NSUR=  NSOUT
      NVOL=  NREG
      DO 100 K= 1, NGRP
      IG= LGRP(K)
      WRITE(IUNOUT,'( 8H GROUP #,I3, 10H --------- )') IG
C
      WRITE(IUNOUT,'(24H REGIONAL CROSS SECTIONS)')
      WRITE(IUNOUT,'(5(1X,6HREGION,5X,13HCROSS SECTION))')
      WRITE(IUNOUT,'(5(1X,I6,3X,E15.7))') (JR,SIGTAL(K,JR),JR=1,NVOL)
      IF( LOPT.LE.0 )THEN
         NSURC = -1
         DO 40 IP  = 1, (9 - NSUR) / 10
            NSURM= MAX( NSUR, NSURC-9 )
            WRITE(IUNOUT,'(30H0  SURFACE CONSERVATION LAWS: ,
     >                     31H( P.S<-S + P.V<-S = 1 + ERR.S ) ,
     >                     31H FOR XS.TOTAL=0, REDUCED P.V<-S ,
     >                     11H IS PRINTED )')
            WRITE(IUNOUT,'(1X,8H(P.S<-S),1X,10( A5,    I6,:)/)')
     >               (' SUR ',-IR,IR= NSURC, NSURM, -1)
            DO 10 IR  =NSURC, NSURM, -1
               BILANP(IR-NSURM+1)= 0.0
   10       CONTINUE
            DO 20 JR = -1,  NSUR, -1
               WRITE(IUNOUT,'(5H SUR ,I4,1X,10F11.8)')
     >                          -JR, (WPR(K,IR,JR),IR=NSURC,NSURM,-1)
               DO 20 IR  = NSURC, NSURM, -1
                  BILANP(IR-NSURM+1)=  BILANP(IR-NSURM+1)
     >                              +  WPR(K,IR,JR)
   20       CONTINUE
            WRITE(IUNOUT,'(1X,8H(P.V<-S) )')
            DO 30 JR  =  1,  NVOL,  1
               IF( SIGTAL(K,JR).EQ.0.0 ) THEN
                  WRITE(IUNOUT,'(5H VOL ,I4,1X,3H 0*,10(F8.5,:,3H 0*))')
     >                      JR,(WPR(K,IR,JR),IR=NSURC,NSURM,-1)
                  XSJR= 0.0
               ELSE
                  WRITE(IUNOUT,'(5H VOL ,I4,1X,10F11.8)')
     >                      JR,(WPR(K,IR,JR),IR=NSURC,NSURM,-1)
                  XSJR= 1.0
               ENDIF
               DO 30 IR  = NSURC, NSURM, -1
                  BILANP(IR-NSURM+1)= BILANP(IR-NSURM+1)
     >                              + XSJR * WPR(K,IR,JR)
   30       CONTINUE
            WRITE(IUNOUT,'(1H )')
            WRITE(IUNOUT,'(5H SUM ,5X,10F11.8)')
     >                          (BILANP(IR-NSURM+1),IR=NSURC,NSURM,-1)
            NSURC = NSURC - 10
   40    CONTINUE
      ENDIF
      NVOLC =  1
      DO 90 IP  = 1, (9 + NVOL) / 10
         NVOLM= MIN( NVOL, NVOLC+9 )
         IF( LOPT.LE.0 )THEN
            WRITE(IUNOUT,'(30H0  VOLUME  CONSERVATION LAWS: ,
     >                     31H( P.S<-V + P.V<-V = 1 + ERR.V ) ,
     >                     31H FOR XS.TOTAL=0, REDUCED P.V<-V ,
     >                     11H IS PRINTED )')
         ELSE
            WRITE(IUNOUT,'(30H0  VOLUME  CONSERVATION LAWS: ,
     >                     32H( SUM OF P.V<-V = 1 + ESCAPE.V ) ,
     >                     31H FOR XS.TOTAL=0, REDUCED P.V<-V ,
     >                     11H IS PRINTED )')
         ENDIF
         DO 50 IR  = NVOLC, NVOLM,   1
            BILANP(IR-NVOLC+1)= 0.0
   50    CONTINUE
         IF( LOPT.LE.0 )THEN
            WRITE(IUNOUT,'(1X,8H(P.S<-V),1X,10( A5 ,  I6,:)/)')
     >                    (' VOL ',IR,IR=NVOLC,NVOLM, 1)
            DO 60 JR = -1,  NSUR, -1
               WRITE(IUNOUT,'(5H SUR ,I4,1X,10F11.8)')
     >         -JR, (WPR(K,IR,JR),IR=NVOLC,NVOLM, 1)
            DO 60 IR  = NVOLC, NVOLM,   1
               BILANP(IR-NVOLC+1)= BILANP(IR-NVOLC+1)
     >                           + WPR(K,IR,JR)
   60       CONTINUE
            WRITE(IUNOUT,'(1X,8H(P.V<-V) )')
         ELSE
            WRITE(IUNOUT,'(1X,8H(P.V<-V),1X,10( A5 ,  I6,:)/)')
     >                    (' VOL ',IR,IR=NVOLC,NVOLM, 1)
         ENDIF
C
         DO 80 JR =  1,  NVOL,  1
            IF( SIGTAL(K,JR).EQ.0.0 )THEN
               WRITE(IUNOUT,'(5H VOL ,I4,1X,3H 0*,10(F8.5,:,3H 0*))')
     >         JR,(WPR(K,IR,JR),IR=NVOLC,NVOLM,1)
               XSJR= 0.0
            ELSE
               WRITE(IUNOUT,'(5H VOL ,I4,1X,10F11.8)')
     >         JR,(WPR(K,IR,JR),IR=NVOLC,NVOLM,1)
               XSJR= 1.0
            ENDIF
         DO 80 IR  = NVOLC, NVOLM,   1
            BILANP(IR-NVOLC+1)= BILANP(IR-NVOLC+1)
     >                        + XSJR*WPR(K,IR,JR)
   80    CONTINUE
         WRITE(IUNOUT,'(1H )')
         WRITE(IUNOUT,'(5H SUM ,5X,10F11.8)')
     >                         (BILANP(IR-NVOLC+1),IR=NVOLC,NVOLM, 1)
         NVOLC = NVOLC + 10
   90 CONTINUE
  100 CONTINUE
C
      RETURN
      END
