*DECK SADDTX
      SUBROUTINE SADDTX(IPEDIT,IPTMP ,IPFLUX,IPMACR,NGROUP, NGCOND,
     >                  NBMIX ,NREGIO,NMERGE,NL    ,NIFISS,NEDMAC,
     >                  NTAUXT,IXSFL ,LSCE  ,NAMSAV,EIGENK,NTENER,
     >                  HVECT ,ITRANC,MATCOD,VOLUME,KEYFLX,IGCOND,
     >                  IMERGE,FLUXES,
     >                  VOLMER,RATECM,FLXINT,
     >                  SCATTD,NAMEAD,FFUEL ,
     >                  IFUELR,MATMC ,NAMFI ,
     >                  MIXFI ,MIXFF ,FFNFT ,
     >                  SADXS )
C
C---------------------------  SADDTX  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : SADDTX
C      USE      : COMPUTE REACTION RATES & GENERALIZED ADJOINT SOURCES
C      AUTHOR   : T. COURAU 2000/08/01
C      REMARK   : THIS ROUTINE IS INSPIRED FROM EDIDTX
C
C  2- ROUTINE PARAMETERS:
C    INPUT/OUTPUT
C      IPEDIT   : POINTER TO THE GENERALIZED            I
C                 ADJOINT SOURCES & INTEGRAL PROPERTIES
C      IPTMP    : TEMPORARY POINTER TO THE GENERALIZED  I
C                 ADJOINT SOURCES
C      IPFLUX   : POINTER TO THE SOLUTION               I
C      IPMACR   : POINTER TO THE MACROLIB               I
C      NGROUP   : NUMBER OF GROUPS                      I
C      NGCOND   : NUMBER OF GROUPS CONDENSED            I
C      NBMIX    : NUMBER OF MIXTURES                    I
C      NREGIO   : NUMBER OF REGIONS                     I
C      NMERGE   : NUMBER OF REGIONS MERGED              I
C      NL       : NUMBER OF LEGENDRE ORDERS             I
C      NIFISS   : NUMBER OF FISSILE ISOTOPES            I
C      NEDMAC   : NUMBER OF ADITIONAL EDITION X-S       I
C      NTAUXT   : NUMBER OF REACTION RATE EDITS         I
C      IXSFL    : FLAG FOR THE XS TO BE TREATED         I(NNAM+1)
C                1 TOTAL, 2 TRANC, 3 NUSIGF, 4 NFTOT,
C                5 CHI, 6  SCAD
C      LSCE     : FLAG TO COMPUTE THE GENERALIZED       L
C                 ADJOINT SOURCES
C      NAMSAV   : NAME OF THE RECORD WHERE
C                 THE HOMOGENIZED XS A PRINTED          C(12)
C      EIGENK   : EIGENVALUE FOR PROBLEM                R
C      NTENER   : ENERGY PRESENCE INDEX                 I
C      HVECT    : EXTRA EDIT NAMES                      C(NEDMAC)*6
C      ITRANC   : TYPE OF TRANSPORT CORRECTION          I
C      MATCOD   : MATERIAL PER REGION                   I(NREGIO)
C      VOLUME   : VOLUME OF REGION                      R(NREGIO)
C      KEYFLX   : AVERAGE FLUX POSITION PER REGION      I(NREGIO)
C      IGCOND   : LIMIT CONDENSED GROUPS                I(NGCOND)
C      IMERGE   : INDEX OF MERGED REGION                I(NREGIO)
C      FLUXES   : FLUXES                                R(NREGIO,NGROUP)
C      VOLMER   : VOLUME OF REGION MERGED               D(NMERGE)
C      RATECM   : AVERAGED REGION/GROUP X-S             D(0:NMERGE,
C                 = RATECM(*,*,1) = FLUXES                NGCOND,NTAUXT)
C                 = RATECM(*,*,2) = TOTAL
C                 = RATECM(*,*,3) = ABS
C                 = RATECM(*,*,4) = FISSIONS
C                 = RATECM(*,*,5) = PRODUCTIONS
C                 = RATECM(*,*,6) = TOTAL LEAKAGES
C                 = RATECM(*,*,7) = TOTAL OUT OF GROUP SCATTERING
C                 = RATECM(*,*,8) = DIAGONAL SCATTERING X-S
C                 = RATECM(*,*,9) = CHI
C                 = RATECM(*,*,10) = WIMS TYPE TRANSPORT CORRECTION
C                 = RATECM(*,*,11) = X-DIRECTED LEAKAGES
C                 = RATECM(*,*,12) = Y-DIRECTED LEAKAGES
C                 = RATECM(*,*,13) = Z-DIRECTED LEAKAGES
C                 = RATECM(*,*,13+JJ) NUSIGF FOR JJ
C                 = RATECM(*,*,13+NIFISS+JJ) CHI FOR JJ
C                 = RATECM(*,*,13+2*NIFISS+JJ) NFTOT FOR JJ
C                 = RATECM(*,*,13+3*NIFISS+IL) SIGS FOR IL
C                 = RATECM(*,*,13+3*NIFISS+NL+IE) EDIT IE
C                 = RATECM(*,*,NTAUXT)= 1/V MERGE CONDENSED
C      FLXINT   : INTEGRATED FLUX                       R(NREGIO,NGROUP,
C                                                                     4)
C      SCATTD   : DOUBLE PRECISION SCATTERING RATES     D(NMERGE,
C                                                         NGCOND,NGCOND,
C                                                                    NL)
C      NAMEAD   : EXTRA EDIT NAMES (INT)                I(2,NEDMAC)
C      FFUEL    : NEUTRON PRODUCTION IN FUEL            R(NREGIO,NIFISS)
C      IFUELR   : FUEL REGION LOCATION                  I(NREGIO)
C      MATMC    : MATERIAL PER MERGED REGION            I(NMERGE)
C      NAMFI    : NAME OF FISSILE ISOTOPE               I(2,NIFISS)
C      MIXFI    : MATERIAL OF FISSILE ISOTOPE           I(NBMIX,NIFISS)
C      MIXFF    : MATERIAL OF FISSILE ISOTOPE           I(NMERGE,NIFISS)
C      FFNFT    : FISSION IN FUEL                       R(NREGIO,NIFISS)
C      SADXS    : XS FOR ADJOINT SOURCE                 R(0:NBMIX,
C                                                       NGROUP,NNAM)
C  3- LOCAL  PARAMETERS
C      NNAM     : NUMBER OF STANDARD XS TREATED         I
C
C---------------------------   SADDTX  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     ILCMUP,ILCMDN,NNAM
      CHARACTER   NAMSBR*6
      PARAMETER  (ILCMUP=1,ILCMDN=2,NNAM=6,NAMSBR='SADDTX')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IPTMP,IPFLUX,IPMACR,NGROUP,NGCOND,NBMIX,
     >            NREGIO,NMERGE,NL,NIFISS,NEDMAC,NTAUXT,
     >            NTENER,ITRANC,IXSFL(NNAM+1),MATCOD(NREGIO),
     >            KEYFLX(NREGIO),IGCOND(NGCOND),IMERGE(NREGIO),
     >            NAMEAD(2,NEDMAC),IFUELR(NREGIO),MATMC(NMERGE),
     >            NAMFI(2,NIFISS),MIXFI(NBMIX,NIFISS),
     >            MIXFF(NMERGE,NIFISS),INDICE(NNAM)
      CHARACTER   HVECT(NEDMAC)*6,NAME(NNAM)*6,NAMSAV*12
      REAL        VOLUME(NREGIO),FLUXES(NREGIO,NGROUP),EIGENK,
     >            FLXINT(NREGIO,NGROUP,4),
     >            FFUEL(NREGIO,NIFISS),
     >            FFNFT(NREGIO,NIFISS),SADXS(0:NBMIX,NGROUP,NNAM)
      LOGICAL     LSCE
      DOUBLE PRECISION VOLMER(NMERGE),RATECM(0:NMERGE,NGCOND,NTAUXT),
     >            SCATTD(NMERGE,NGCOND,NGCOND,NL)
C----
C  MEMORY ALLOCATION PARAMETERS
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     ISIGMA,INGSCT,IFGSCT,IPOSCT,IXSCAT,XSSCAT,IWORK,
     >            IPCHI,IPFIS,ISUM,SASCAT,DASCAT, FLAGMX,ISCATC,
     >            INJJ, IIJJ,IIPOS,IFACT
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,TEXT12*12,CDUFIS*8
      INTEGER     ISIGR,IMRG,ILFI,ILSC,ILED,ILOV,IED,ITC,
     >            NNTOTF,IREGIO,ILCMLN,ILCMTY,NFLUXE,
     >            IGROUP,IGRC,IGRFIN,IGRDEB,MATNUM,IFIS,
     >            ITF,IRAT,ISIGMX,IMIX
      REAL        FLXFIS
      DOUBLE PRECISION TOTFIS,FXSOUR,FLXREN
C----
C  ALLOCATE WORK VECTOR AND INITIALIZE REQUIRED VECTORS
C----
      CALL XDRSET(SADXS,(NBMIX+1)*NGROUP*NNAM,0.0)
      CALL SETARA(RBASE,NBMIX*MAX(NIFISS,1)+1,ISIGMA)
      CALL SETARA(IBASE,NBMIX,INGSCT)
      CALL SETARA(IBASE,NBMIX,IFGSCT)
      CALL SETARA(IBASE,NBMIX,IPOSCT)
      CALL SETARA(RBASE,NBMIX*NGROUP,IXSCAT)
      CALL SETARA(RBASE,NBMIX*NGROUP*NGROUP*NL,XSSCAT)
      CALL XDRSET(FFUEL,NREGIO*MAX(NIFISS,1),0.0)
      CALL XDRSET(FFNFT,NREGIO*MAX(NIFISS,1),0.0)
      CALL XDISET(IFUELR,NREGIO,0)
      CALL XDDSET(VOLMER,NMERGE,0.0D0)
      CALL XDDSET(RATECM,(NMERGE+1)*NGCOND*NTAUXT,0.0D0)
      RBASE(ISIGMA)=0.0
      ISIGR=ISIGMA+1
      DO 100 IMRG=1,NMERGE
        MATMC(IMRG)=IMRG
 100  CONTINUE
      ILFI=13
      ILSC=ILFI+3*NIFISS
      ILED=ILSC+NL
      ILOV=ILED+NEDMAC+1
C----
C  FIND EDIT XS
C----
      IF(NEDMAC .GT. 0) THEN
        CALL LCMGET(IPMACR,'ADDXSNAME',NAMEAD)
        DO 110 IED=1,NEDMAC
          WRITE(HVECT(IED),'(A4,A2)') (NAMEAD(ITC,IED),ITC=1,2)
 110    CONTINUE
      ENDIF
C----
C  FIND FISSION ISOTOPES AND MIXTURES
C----
      NNTOTF=0
      IF(NIFISS .GT. 0) THEN
         CDUFIS='MACROFIS'
         READ(CDUFIS,'(2A4)') (NAMFI(ITC,1),ITC=1,2)
         DO 120 IMRG=1,NMERGE
            MIXFF(IMRG,1)=-1
 120     CONTINUE
      ENDIF
C----
C  COMPUTE MERGED VOLUME AND READ MULTIGROUP FLUXES
C----
      DO 130 IREGIO=1,NREGIO
        IMRG=IMERGE(IREGIO)
        IF(IMRG .GT. 0) THEN
          VOLMER(IMRG)=VOLMER(IMRG)+DBLE(VOLUME(IREGIO))
        ENDIF
 130  CONTINUE
      CALL LCMLEN(IPFLUX,'FLUX  1',ILCMLN,ILCMTY)
      IF(ILCMLN .EQ. 0) CALL XABORT(NAMSBR//': MISSING FLUX INFO.')
      CALL SETARA(RBASE,ILCMLN,IWORK)
      NFLUXE=1
C----
C  COMPUTE MERGED INTEGRATED CURRENTS
C----
      DO 180 IGROUP=1,NGROUP
        WRITE(TEXT12,'(4HFLUX,I3)') IGROUP
        CALL LCMGET(IPFLUX,TEXT12,RBASE(IWORK))
        DO 181 IREGIO=1,NREGIO
          FLUXES(IREGIO,IGROUP)=RBASE(IWORK+KEYFLX(IREGIO)-1)
 181    CONTINUE
 180  CONTINUE
C----
C  COMPUTE INTEGRATED FLUX
C----
      DO 190 IGROUP=1,NGROUP
        DO 191 IREGIO=1,NREGIO
          FLXINT(IREGIO,IGROUP,1)=FLUXES(IREGIO,IGROUP)
     >                           *VOLUME(IREGIO)
 191    CONTINUE
 190  CONTINUE
      IGRFIN=0
      TOTFIS=0.0D0
      FXSOUR=0.0D0
      DO 200 IGRC=1,NGCOND
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        DO 210 IGROUP=IGRDEB,IGRFIN
C----
C  READ FIXE SOURCES/COMPUTE FIXE PRODUCTION RATE AND TOTAL SOURCE
C----
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMLEN(IPMACR,'FIXE',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'FIXE',RBASE(ISIGR))
            CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  VOLUME,RBASE(ISIGMA),RATECM(0,IGRC,5))
            DO 211 IMRG=1,NMERGE
              FXSOUR=FXSOUR+DBLE(RATECM(IMRG,IGRC,5))
 211        CONTINUE
          ENDIF
C----
C  COMPUTE MERGED INTEGRATED FLUX
C----
          CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                RATECM(0,IGRC,1))
C----
C  READ NUSIGF X-S/ COMPUTE NEUTRON PRODUCTION RATES
C----
          CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'NUSIGF',RBASE(ISIGR))
            DO 212 IREGIO=1,NREGIO
              IF(MATCOD(IREGIO) .GT. 0) THEN
                MATNUM=ISIGMA+MATCOD(IREGIO)
                DO 213 IFIS=1,NIFISS
                  IF(RBASE(MATNUM) .GT. 0.0) THEN
                    FLXFIS=FLXINT(IREGIO,IGROUP,1)*RBASE(MATNUM)
                    FFUEL(IREGIO,IFIS)=FFUEL(IREGIO,IFIS)+FLXFIS
                    TOTFIS=TOTFIS+DBLE(FLXFIS)
                    IFUELR(IREGIO)=1
                  ENDIF
                  MATNUM=MATNUM+NBMIX
 213            CONTINUE
              ENDIF
 212        CONTINUE
            MATNUM=ISIGMA
            DO 313 IFIS=1,NIFISS
              DO 312 IMIX=1,NBMIX
                MATNUM=MATNUM+1
                SADXS(IMIX,IGROUP,3)=SADXS(IMIX,IGROUP,3)+RBASE(MATNUM)
 312          CONTINUE
 313        CONTINUE
          ENDIF
C----
C  READ NFTOT X-S/ COMPUTE FISSION RATES
C----
          CALL LCMLEN(IPMACR,'NFTOT',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            NNTOTF=1
            CALL LCMGET(IPMACR,'NFTOT',RBASE(ISIGR))
            DO 214 IREGIO=1,NREGIO
              IF(MATCOD(IREGIO) .GT. 0) THEN
                MATNUM=ISIGMA+MATCOD(IREGIO)
                DO 215 IFIS=1,NIFISS
                  IF(RBASE(MATNUM) .GT. 0.0) THEN
                    FLXFIS=FLXINT(IREGIO,IGROUP,1)*RBASE(MATNUM)
                    FFNFT(IREGIO,IFIS)=FFNFT(IREGIO,IFIS)+FLXFIS
                  ENDIF
                  MATNUM=MATNUM+NBMIX
 215            CONTINUE
              ENDIF
 214        CONTINUE
            MATNUM=ISIGMA
            DO 315 IFIS=1,NIFISS
              DO 314 IMIX=1,NBMIX
                MATNUM=MATNUM+1
                SADXS(IMIX,IGROUP,4)=SADXS(IMIX,IGROUP,4)+RBASE(MATNUM)
 314          CONTINUE
 315        CONTINUE
          ENDIF
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 210    CONTINUE
 200  CONTINUE
C----
C  RENORMALIZE FLUXES USING EIGENVALUE IF NOT FIXED SOURCES
C----
      IF(FXSOUR .EQ. 0.0D0 .AND. TOTFIS .GT. 0.0D0 .AND. LSCE) THEN
        FLXREN=1.0D0/TOTFIS
        CALL LCMLEN(IPFLUX,'FLUX  1',ILCMLN,ILCMTY)
        DO 220 IGROUP=1,NGROUP
          WRITE(TEXT12,'(4HFLUX,I3)') IGROUP
          CALL LCMGET(IPFLUX,TEXT12,RBASE(IWORK))
          DO 221 IREGIO=1,NREGIO
            DO 222 ITF=1,NFLUXE
              FLXINT(IREGIO,IGROUP,ITF)=FLXINT(IREGIO,IGROUP,ITF)*FLXREN
 222        CONTINUE
            RBASE(IWORK+KEYFLX(IREGIO)-1)=RBASE(IWORK+KEYFLX(IREGIO)-1)
     >                                                          *FLXREN
 221      CONTINUE
          CALL LCMPUT(IPFLUX,TEXT12,ILCMLN,2,RBASE(IWORK))
 220    CONTINUE
        CALL RLSARA(RBASE(IWORK))
        DO 230 IFIS=1,NIFISS
          DO 231 IREGIO=1,NREGIO
          FFUEL(IREGIO,IFIS)=FFUEL(IREGIO,IFIS)*FLXREN
          FFNFT(IREGIO,IFIS)=FFNFT(IREGIO,IFIS)*FLXREN
 231      CONTINUE
 230    CONTINUE
        DO 240 IGRC=1,NGCOND
          DO 241 IMRG=1,NMERGE
            RATECM(IMRG,IGRC,1)=RATECM(IMRG,IGRC,1)*FLXREN
 241      CONTINUE
 240    CONTINUE
      ENDIF
      IGRFIN=0
      DO 260 IGRC=1,NGCOND
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        DO 280 IGROUP=IGRDEB,IGRFIN
C----
C  TOTAL, ABSORPTION, ECT RATES
C----
          WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGROUP,NGROUP
          CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
          CALL LCMLEN(IPMACR,'TOTAL',ILCMLN,ILCMTY)
          IF(ILCMLN .EQ. 0) CALL XABORT(NAMSBR//
     >    ': READ ERROR FOR RECORD-> TOTAL')
          CALL LCMGET(IPMACR,'TOTAL',SADXS(1,IGROUP,1))
          CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),SADXS(0,IGROUP,1),
     >                RATECM(0,IGRC,2))
C----
C  Store total rates in absorption rates
C----
          CALL LCMGET(IPMACR,'TOTAL',SADXS(1,IGROUP,6))
          CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                FLXINT(1,IGROUP,1),SADXS(0,IGROUP,6),
     >                RATECM(0,IGRC,3))
C----
C  READ ADDITIONAL X-SECTIONS
C----
          IF(NEDMAC .GT. 0) THEN
            DO 282 IED=1,NEDMAC
              CALL LCMGET(IPMACR,HVECT(IED),RBASE(ISIGR))
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1),RBASE(ISIGMA),
     >                    RATECM(0,IGRC,ILED+IED))
 282        CONTINUE
          ENDIF
C----
C  FISSION SPECTRUM AND NU*SIGF
C----
          IRAT=ILFI
          CALL LCMLEN(IPMACR,'NUSIGF',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'NUSIGF',RBASE(ISIGR))
            ISIGMX=ISIGMA
            DO 283 IFIS=1,NIFISS
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                    RATECM(0,IGRC,4))
               IRAT=IRAT+1
               CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                      FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                      RATECM(0,IGRC,IRAT))
              ISIGMX=ISIGMX+NBMIX
              RBASE(ISIGMX)=0.0
 283        CONTINUE
          ENDIF
          IRAT=ILFI+NIFISS
          CALL LCMLEN(IPMACR,'CHI',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'CHI',RBASE(ISIGR))
            ISIGMX=ISIGMA
            DO 284 IFIS=1,NIFISS
              CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                    FFUEL(1,IFIS),RBASE(ISIGMX),
     >                    RATECM(0,IGRC,5))
              DO 384 IMIX=1,NBMIX
                SADXS(IMIX,IGROUP,5)=SADXS(IMIX,IGROUP,5)
     >                              +RBASE(ISIGMX+IMIX)
 384          CONTINUE
              ISIGMX=ISIGMX+NBMIX
              RBASE(ISIGMX)=0.0
 284        CONTINUE
          ENDIF
          IRAT=ILFI+2*NIFISS
          IF(NNTOTF .EQ. 1) THEN
            CALL LCMLEN(IPMACR,'NFTOT',ILCMLN,ILCMTY)
            IF(ILCMLN .GT. 0) THEN
              CALL LCMGET(IPMACR,'NFTOT',RBASE(ISIGR))
              ISIGMX=ISIGMA
              DO 286 IFIS=1,NIFISS
                IRAT=IRAT+1
                CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                      FLXINT(1,IGROUP,1),RBASE(ISIGMX),
     >                      RATECM(0,IGRC,IRAT))
                ISIGMX=ISIGMX+NBMIX
                RBASE(ISIGMX)=0.0
 286          CONTINUE
            ENDIF
          ENDIF
C----
C  TYPE TRANSPORT CORRECTION
C----
          CALL LCMLEN(IPMACR,'TRANC',ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            CALL LCMGET(IPMACR,'TRANC',SADXS(1,IGROUP,2))
            CALL EDIRAT(     1,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  FLXINT(1,IGROUP,1),SADXS(0,IGROUP,2),
     >                  RATECM(0,IGRC,10))
          ENDIF
          CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
 280    CONTINUE
 260  CONTINUE
C----
C  SCATTERING AND ABSORPTION
C---
      CALL SADSCT(IPMACR,NGROUP,NGCOND,NBMIX ,NREGIO,
     >            NMERGE,NL    ,NIFISS,NTAUXT,MATCOD,
     >            IGCOND,IMERGE,RATECM,FLXINT,SCATTD,
     >            RBASE(XSSCAT),IBASE(INGSCT),IBASE(IFGSCT),
     >            IBASE(IPOSCT),RBASE(IXSCAT),SADXS(0,1,6))
C----
C  FISSION SPECTRUM NORMALIZATION
C----
      IF(FXSOUR .EQ. 0.0D0 .AND. TOTFIS .GT. 0.0D0) THEN
        DO 350 IGRC=1,NGCOND
          DO 351 IFIS=1,NIFISS
            CALL EDIRAT(     0,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  FFUEL(1,IFIS),RBASE(ISIGMA),
     >                  RATECM(0,IGRC,9))
 351      CONTINUE
 350    CONTINUE
        DO 360 IGRC=1,NGCOND
          DO 361 IMRG=1,NMERGE
            IF(RATECM(IMRG,IGRC,9) .NE. 0.0D0) THEN
              RATECM(IMRG,IGRC,9)=RATECM(IMRG,IGRC,5)
     >                           /RATECM(IMRG,IGRC,9)
            ENDIF
 361      CONTINUE
 360    CONTINUE
      ENDIF
      CALL RLSARA(RBASE(IXSCAT))
      CALL RLSARA(IBASE(IPOSCT))
      CALL RLSARA(IBASE(IFGSCT))
      CALL RLSARA(IBASE(INGSCT))
      CALL RLSARA(RBASE(ISIGMA))
C----
C  COMPUTE MERGED/CONDENSED X-S
C----
      NAME(1)='TOTAL '
      NAME(2)='TRANC '
      NAME(3)='NUSIGF'
      NAME(4)='NFTOT '
      NAME(5)='CHI   '
      NAME(6)='ABS   '
      INDICE(1)=2
      INDICE(6)=3
      IF (ITRANC .GT. 0) THEN
       INDICE(2)=10
      ELSE
       INDICE(2)=0
       IXSFL(2)=0
      ENDIF
      IF (NIFISS .GT. 0) THEN
        INDICE(3)=13
        INDICE(5)=9
      ELSE
        INDICE(3)=0
        IXSFL(3)=0
        INDICE(5)=0
        IXSFL(5)=0
      ENDIF
      IF(NNTOTF .EQ. 1) THEN
        INDICE(4)=13+2*NIFISS
      ELSE
       INDICE(4)=0
       IXSFL(4)=0
      ENDIF
C---
C PRINT MERGED/CONDENSED XS
C---
      CALL SETARA(RBASE,NMERGE*NGCOND,ISCATC)
      CALL SETARA(IBASE,NMERGE,IIJJ)
      CALL SETARA(IBASE,NMERGE,INJJ)
      CALL SETARA(IBASE,NMERGE,IIPOS)
      CALL SETARA(RBASE,NMERGE,IFACT)
      CALL SADPXS(IPEDIT,NAMSAV,NGCOND,NMERGE,NL     ,ITRANC,
     >            NIFISS,NEDMAC,NTAUXT,NNAM  ,NAMEAD ,NAME  ,
     >            INDICE,IXSFL ,HVECT ,EIGENK,RATECM ,SCATTD,
     >            RBASE(ISCATC),IBASE(IIJJ)  ,IBASE(INJJ)   ,
     >            IBASE(IIPOS),RBASE(IFACT))
      CALL RLSARA(RBASE(IFACT))
      CALL RLSARA(IBASE(IIPOS))
      CALL RLSARA(IBASE(INJJ))
      CALL RLSARA(IBASE(IIJJ))
      CALL RLSARA(RBASE(ISCATC))
C----
C  COMPUTE GENERALIZED ADJOINT SOURCES
C----
      IF (LSCE) THEN
       CALL SETARA(RBASE,NBMIX*NGROUP*MAX(NIFISS,1),IPCHI)
       CALL SETARA(RBASE,NBMIX*NGROUP*MAX(NIFISS,1),IPFIS)
       CALL SETARA(RBASE,2*MAX(NIFISS,1),ISUM)
       CALL SETARA(RBASE,NBMIX*NGROUP*NGCOND*NL,SASCAT)
       CALL SETARA(RBASE,2*NBMIX*NGROUP*NGCOND*NL,DASCAT)
       CALL SETARA(IBASE,NBMIX,FLAGMX)
       CALL SADPSA(IPTMP ,NGCOND,NMERGE ,NL    ,NREGIO,
     >             NGROUP,ITRANC,NIFISS,NEDMAC,NNTOTF,
     >             NTAUXT,NBMIX ,NNAM  ,NAMEAD,IMERGE,
     >             IGCOND,NAME  ,INDICE,IXSFL ,MATCOD,
     >             HVECT ,RATECM,SCATTD,SADXS ,
     >             RBASE(XSSCAT),IBASE(FLAGMX),RBASE(IPCHI) ,
     >             RBASE(IPFIS) ,RBASE(ISUM)  ,RBASE(SASCAT),
     >             RBASE(DASCAT))
       CALL RLSARA(IBASE(FLAGMX))
       CALL RLSARA(RBASE(DASCAT))
       CALL RLSARA(RBASE(SASCAT))
       CALL RLSARA(RBASE(ISUM))
       CALL RLSARA(RBASE(XSSCAT))
       CALL RLSARA(RBASE(IPFIS))
       CALL RLSARA(RBASE(IPCHI))
      ENDIF
      RETURN
      END
