*DECK SPHGEO
      SUBROUTINE SPHGEO(MAXPTS,MAXMER,IPGEO1,IPGEO2,IPRINT,NREGIO,
     1 NMERGE,IMERGE,XX,YY,INUM,IGEN,IORI,IMAT,NMC)
C
C-----------------------------------------------------------------------
C
C RECOVER THE GEOMETRY INFORMATION FROM LCM (STORED BY MODULE GEO:) AND
C COMPUTE A CORRESPONDING MACRO-GEOMETRY (I.E. A PURE GEOMETRY THAT CAN
C BE TREATED BY BIVAC OR TRIVAC) TOGETHER WITH NMERGE AND ARRAY IMERGE.
C
C INPUT PARAMETERS:
C   MAXPTS : ALLOCATED STORAGE FOR ARRAYS OF DIMENSION NMCEL.
C   MAXMER : ALLOCATED STORAGE FOR ARRAYS OF DIMENSION NMERGE.
C   IPGEO1 : POINTER TO THE ORIGINAL GEOMETRY (L_GEOM SIGNATURE).
C   IPGEO2 : POINTER TO THE MACRO-GEOMETRY (L_GEOM SIGNATURE).
C   IPRINT : PRINT FLAG. EQUAL TO 0 FOR NO PRINT.
C   NREGIO : NUMBER OF REGIONS.
C   NMERGE : =1 TO INDICATE A HOMOGENEOUS MACRO-CALCULATION.
C
C OUTPUT PARAMETERS:
C   NMERGE : NUMBER OF MERGED REGIONS (EQUAL TO THE NUMBER OF PHYSICAL
C            CELLS IN EURYDICE).
C   IMERGE : INDEX OF MERGED REGIONS. DIMENSION IMERGE(NREGIO)
C
C SCRATCH STORAGE:
C   XX,YY  : DIMENSION XX(MAXPTS),YY(MAXPTS)
C   INUM   : DIMENSION INUM(2*MAXPTS)
C   IGEN   : DIMENSION IGEN(MAXPTS)
C   IORI   : DIMENSION IORI(2*MAXPTS)
C   IMAT   : DIMENSION IMAT(2*MAXPTS)
C   NMC    : DIMENSION NMC(MAXPTS+1)
C
C------------------------------------- AUTHOR: A. HEBERT ; 08/04/91 ----
C
      IMPLICIT NONE
C----
C PARAMETERS
C----
      INTEGER     NSTATE
      PARAMETER  (NSTATE=40)
C----
C MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL         BASE
      COMMON       BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1))
      INTEGER     IISS,IRAYRE,IMIL,INBREG,IMILIE,IRAYON,ICELL,
     1            IXXX,IYYY,NRINFO,MATANN,JRAN,KEYMRG,MATALB,JVS,
     2            NRODS,JRODS,NRODR,JRODR,MATROD,ISPLIT,JRAD,NXRS,JVRG,
     3            IMESHX,IMESHY,NXRI
C----
C INTERFACE VARIABLES
C----
      INTEGER     MAXPTS,MAXMER,IPGEO1,IPGEO2,IPRINT,NREGIO,NMERGE
      INTEGER     IMERGE(*),INUM(*),IGEN(*),IORI(*),IMAT(*),NMC(*),
     >            NCODE(6),ICODE(6),ISTATE(NSTATE),KCHAR(3)
      REAL        XX(*),YY(*),ZCODE(6),ALBEDO(6),XXX(2),YYY(2)
C----
C LOCAL VARIABLES
C----
      INTEGER     ICLS,LR,IPR2,IR,NMCEL,NGEN,IPAS,LX,LY,IHEX,NSURW,
     1            MAXJ,IAPP,NVOLW,IROT,NANW,MNANW,NRTW,MSRODW,MARODW,
     2            NSURFW,NRT,NMATW,II,I,IKK,IKG,K1,LXM,LXP,K2,I1,I2,
     3            IBLK
      REAL        COTE,RADMIN,SIDE
      CHARACTER   HSMG*131,TYPE(0:9)*16,HSIGN*12
      LOGICAL     ILK,LL1,LL2,LHOM
C
C----
C DATA
C----
      DATA TYPE  / 'VIRTUAL',      'HOMOGENEOUS',   'CARTESIAN 1-D',
     1             'TUBE 1-D',     'SPHERE 1-D',    'CARTESIAN 2-D',
     2             'TUBE 2-D',     'CARTESIAN 3-D', 'HEXAGONAL 2-D',
     3             'HEXAGONAL 3-D'                               /
C
C RECOVER ASSEMBLY INFORMATION FROM THE ORIGINAL GEOMETRY.
C
      LHOM=(NMERGE.EQ.1)
      CALL LCMGET(IPGEO1,'STATE-VECTOR',ISTATE)
      IF( ((ISTATE(1).EQ.5).AND.(ISTATE(8).EQ.1)).OR.
     1     ((ISTATE(1).EQ.8).AND.(ISTATE(8).EQ.1)).OR.
     2     ((ISTATE(1).EQ.20).AND.(ISTATE(13).EQ.0)).OR.
     3     ((ISTATE(1).EQ.24).AND.(ISTATE(13).EQ.0)) ) THEN
         ICLS=0
         LR=0
         CALL SETARA(BASE,NREGIO,IISS)
         CALL SETARA(BASE,MAXPTS,IRAYRE)
         CALL SETARA(BASE,MAXPTS,IMIL)
         CALL SETARA(BASE,MAXPTS,INBREG)
         CALL SETARA(BASE,MAXPTS,IMILIE)
         CALL SETARA(BASE,MAXPTS,IRAYON)
         CALL SETARA(BASE,3*MAXPTS,ICELL)
         CALL SETARA(BASE,MAXPTS+1,IXXX)
         CALL SETARA(BASE,MAXPTS+1,IYYY)
         IPR2=MAX(0,IPRINT-5)
         CALL READEU(MAXPTS,IPGEO1,IR,BASE(IISS),ILK,NMCEL,NMERGE,NGEN,
     1   INUM,IGEN,IPAS,LX,LY,XX,YY,BASE(IRAYRE),NMC,IORI,NCODE,ZCODE,
     2   IHEX,IPR2,BASE(IMIL),BASE(INBREG),BASE(IMILIE),
     3   BASE(IRAYON),BASE(ICELL),BASE(IXXX),BASE(IYYY))
         CALL RLSARA(BASE(IYYY))
         CALL RLSARA(BASE(IXXX))
         CALL RLSARA(BASE(ICELL))
         CALL RLSARA(BASE(IRAYON))
         CALL RLSARA(BASE(IMILIE))
         CALL RLSARA(BASE(INBREG))
         CALL RLSARA(BASE(IMIL))
         CALL RLSARA(BASE(IRAYRE))
         CALL RLSARA(BASE(IISS))
      ELSE IF( ((ISTATE(1).EQ.3).OR.(ISTATE(1).EQ.20).OR.
     1          (ISTATE(1).EQ.24)).AND.(ISTATE(13).GE.1)) THEN
        IROT=3
        LX=0
        LY=0
        IF(ISTATE(1).EQ.3) THEN
          NSURW=1
          ICLS=1
        ELSE IF(ISTATE(1).EQ.20) THEN
          NSURW=4
          ICLS=2
          LX=1
          LY=1
        ELSE IF(ISTATE(1).EQ.24) THEN
          NSURW=6
          ICLS=3
        ENDIF
        MAXJ=1
        CALL XCGDIM(IPGEO1,MAXPTS,NSURW,IROT,IAPP,MAXJ,NVOLW,
     1              NANW,MNANW,NRTW,MSRODW,MARODW,NSURFW)
*
* ALLOCATE BLOCK FOR READING GEOMETRY INFORMATION
        CALL SETARA(IBASE,2*NANW,NRINFO)
        CALL SETARA(IBASE,NANW,MATANN)
        CALL SETARA(BASE,NANW,JRAN)
        CALL SETARA(IBASE,NSURW+NVOLW+1,KEYMRG)
        CALL SETARA(IBASE,NSURW+NVOLW+1,MATALB)
        CALL SETARA(BASE,NSURW+NVOLW+1,JVS)
        CALL SETARA(IBASE,3*NRTW,NRODS)
        CALL SETARA(BASE,2*NRTW,JRODS)
        CALL SETARA(IBASE,NRTW,NRODR)
        CALL SETARA(BASE,MSRODW*NRTW,JRODR)
        CALL SETARA(IBASE,MSRODW*NRTW,MATROD)
        CALL SETARA(IBASE,MNANW,ISPLIT)
        CALL SETARA(BASE,MNANW,JRAD)
        CALL SETARA(IBASE,NRT,NXRS)
        CALL SETARA(IBASE,NRT*NANW,NXRI)
        CALL SETARA(BASE,2*NRT,JVRG)
        CALL XCGGEO(IPGEO1,IROT,NSURW,NVOLW,NANW,MNANW,NRTW,MSRODW,
     1  IPRINT,ILK,NMATW,BASE(JRAN),IBASE(MATANN),IBASE(NRODS),
     2  BASE(JRODS),IBASE(MATROD),IBASE(NRODR),BASE(JRODR),
     3  IBASE(NRINFO),IBASE(MATALB),BASE(JVS),IBASE(ISPLIT),BASE(JRAD),
     4  COTE,RADMIN,NCODE,ICODE,ZCODE,ALBEDO,IBASE(KEYMRG),IBASE(NXRS),
     5  IBASE(NXRI),BASE(JVRG))
        CALL RLSARA(BASE(JVRG))
        CALL RLSARA(IBASE(NXRI))
        CALL RLSARA(IBASE(NXRS))
        CALL RLSARA(BASE(JRAD))
        CALL RLSARA(IBASE(ISPLIT))
        CALL RLSARA(IBASE(MATROD))
        CALL RLSARA(BASE(JRODR))
        CALL RLSARA(IBASE(NRODR))
        CALL RLSARA(BASE(JRODS))
        CALL RLSARA(IBASE(NRODS))
        CALL RLSARA(BASE(JVS))
        CALL RLSARA(IBASE(MATALB))
        CALL RLSARA(IBASE(KEYMRG))
*
* STORE INFORMATION FOR NEW GEOMETRY
        IPAS=NVOLW
        NMCEL=NANW
        NMERGE=NANW
        IHEX=0
        XX(1)=0.0
        NMC(1)=0
        DO 200 II=1,NANW
          XX(II+1)=BASE(JRAN-1+II)
          INUM(II)=II
          IGEN(II)=II
          NMC(II+1)=IBASE(NRINFO+2*(II-1))
 200    CONTINUE
        IF(NSURW.EQ.1) THEN
          LR=NANW
        ELSE IF(NSURW.EQ.4) THEN
          LR=NANW-1
          XXX(1)=0.0
          XXX(2)=XX(NANW+1)
          YYY(1)=0.0
          YYY(2)=COTE
        ELSE
          LR=NANW-1
          SIDE=XX(NANW+1)
        ENDIF
*
        CALL RLSARA(BASE(JRAN))
        CALL RLSARA(IBASE(MATANN))
        CALL RLSARA(IBASE(NRINFO))
      ELSE
         CALL XABORT('SPHGEO: INVALID TYPE OF INPUT GEOMETRY.')
      ENDIF
      IF(IPAS.NE.NREGIO) THEN
         WRITE(HSMG,'(45HSPHGEO: INCONSISTENT NUMBER OF REGIONS. IPAS=,
     1   I6,8H NREGIO=,I6)') IPAS,NREGIO
         CALL XABORT(HSMG)
      ENDIF
*
* COMPUTE IMERGE ARRAY.
      IF(LHOM) THEN
*        HOMOGENEOUS MACRO-CALCULATION.
         DO 10 I=1,NREGIO
10       IMERGE(I)=1
         NMERGE=1
         DO 15 I=1,NMCEL
15       IMAT(I)=1
      ELSE
*        CELL-WISE HETEROGENEOUS MACRO-CALCULATION.
         IPAS=0
         DO 30 IKK=1,NMERGE
         IKG=IGEN(IKK)
         I2=NMC(IKG+1)-NMC(IKG)
         DO 20 I=1,I2
20       IMERGE(IPAS+I)=IKK
30       IPAS=IPAS+I2
         IF(IPAS.NE.NREGIO) THEN
            CALL XABORT('SPHGEO: INCONSISTENT ARRAY NMC.')
         ENDIF
         DO 35 I=1,NMCEL
35       IMAT(I)=INUM(I)
      ENDIF
      IF(NMERGE.GT.MAXMER) THEN
         WRITE(HSMG,'(37HSPHGEO: INSUFFICIENT STORAGE (MAXMER=,I5,
     1   47H). THE MERGE OPTION SHOULD NOT BE USED IN EDI:.)') MAXMER
         CALL XABORT(HSMG)
      ENDIF
      IF(IPRINT.GE.5) THEN
         WRITE (6,'(/23H SPHGEO: MERGING INDEX:/(1X,14I5))') (IMERGE(I),
     1   I=1,NREGIO)
      ENDIF
*
* COMPUTE THE MACRO (PURE) GEOMETRY.
      CALL XDRSET(ISTATE,NSTATE,0)
      CALL LCMPUT(IPGEO2,'MIX',NMCEL,1,IMAT)
      DO 50 I=1,6
   50 ICODE(I)=0
      CALL LCMPUT(IPGEO2,'NCODE',6,1,NCODE)
      CALL LCMPUT(IPGEO2,'ZCODE',6,2,ZCODE)
      CALL LCMPUT(IPGEO2,'ICODE',6,1,ICODE)
      IF(ICLS.EQ.0) THEN
        IF(IHEX.EQ.0) THEN
          ISTATE(1)=5
          CALL SETARA(BASE,LX+1,IMESHX)
          CALL SETARA(BASE,LY+1,IMESHY)
          BASE(IMESHX)=0.0
          BASE(IMESHY)=0.0
          LL1=((NCODE(2).EQ.3).AND.(NCODE(3).EQ.3))
          LL2=((NCODE(1).EQ.3).AND.(NCODE(4).EQ.3))
          IBLK=0
          DO 60 K1=1,LY
            LXM=1
            LXP=LX
            IF(LL1) LXP=K1
            IF(LL2) LXM=K1
            DO 60 K2=LXM,LXP
              IBLK=IBLK+1
              IKK=INUM(IBLK)
              IF(IKK.EQ.0) GO TO 60
              IF(MOD(IORI(IBLK)-1,2).EQ.0) THEN
                BASE(IMESHX+K2)=BASE(IMESHX+K2-1)+XX(IGEN(IKK))
                BASE(IMESHY+K1)=BASE(IMESHY+K1-1)+YY(IGEN(IKK))
              ELSE
                BASE(IMESHX+K2)=BASE(IMESHX+K2-1)+YY(IGEN(IKK))
                BASE(IMESHY+K1)=BASE(IMESHY+K1-1)+XX(IGEN(IKK))
              ENDIF
   60     CONTINUE
          CALL LCMPUT(IPGEO2,'MESHX',LX+1,2,BASE(IMESHX))
          CALL LCMPUT(IPGEO2,'MESHY',LY+1,2,BASE(IMESHY))
          CALL RLSARA(BASE(IMESHY))
          CALL RLSARA(BASE(IMESHX))
        ELSE
          ISTATE(1)=8
          IF(IHEX.EQ.10) THEN
            IHEX=1
          ELSE IF(IHEX.EQ.11) THEN
            IHEX=2
          ENDIF
          CALL LCMPUT(IPGEO2,'IHEX',1,1,IHEX)
          CALL LCMPUT(IPGEO2,'SIDE',1,2,XX(1))
        ENDIF
      ELSE
        CALL LCMPUT(IPGEO2,'RADIUS',LR+1,2,XX)
        IF(ICLS.EQ.1) THEN
          ISTATE(1)=3
        ELSE IF(ICLS.EQ.2) THEN
          ISTATE(1)=20
          CALL LCMPUT(IPGEO2,'MESHX',LX+1,2,XXX)
          CALL LCMPUT(IPGEO2,'MESHY',LY+1,2,YYY)
        ELSE
          ISTATE(1)=24
          IHEX=9
          CALL LCMPUT(IPGEO2,'IHEX',1,1,IHEX)
          CALL LCMPUT(IPGEO2,'SIDE',1,2,SIDE)
        ENDIF
      ENDIF
      ISTATE(2)=LR
      ISTATE(3)=LX
      ISTATE(4)=LY
      ISTATE(6)=NMCEL
      ISTATE(7)=NMERGE
      CALL LCMPUT(IPGEO2,'STATE-VECTOR',NSTATE,1,ISTATE)
      HSIGN='L_GEOM'
      READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      CALL LCMPUT(IPGEO2,'SIGNATURE',3,3,KCHAR)
      IF(IPRINT.GT.0) THEN
         HSIGN='SPH-GEO'
         WRITE (6,510) HSIGN,1,TYPE(ISTATE(1))
         IF(IPRINT.GT.1) THEN
            WRITE (6,520) ISTATE(1),TYPE(ISTATE(1)),(ISTATE(I),I=2,7)
         ENDIF
      ENDIF
      RETURN
*
  510 FORMAT(/39H SPHGEO: CREATION OF A GEOMETRY NAMED ',A12,7H' ON LE,
     1 3HVEL,I3,11H WITH TYPE ,A16,1H.)
  520 FORMAT(/30H STATE VECTOR (PURE GEOMETRY):/
     1 7H ITYPE ,I6, 4H   (,A16,1H)/
     2 7H LR    ,I6,20H   (NUMBER OF TUBES)/
     3 7H LX    ,I6,22H   (X-DIMENSION INDEX)/
     4 7H LY    ,I6,22H   (Y-DIMENSION INDEX)/
     5 7H LZ    ,I6,22H   (Z-DIMENSION INDEX)/
     6 7H LREG  ,I6,22H   (NUMBER OF REGIONS)/
     7 7H MAXMIX,I6,25H   (MAX. NB. OF MIXTURES)/1X,60(1H-)/)
      END
