*DECK SYBILT
      SUBROUTINE SYBILT(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* SYBIL TYPE (2-D) TRACKING MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_TRACK).
*  HENTRY(2) : READ-ONLY TYPE(L_GEOM)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 23/09/94 ---
*
      INTEGER   IOUT
      PARAMETER(IOUT=6,NSTATE=40)
      CHARACTER HENTRY(*)*12,TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12
      DOUBLE PRECISION DBLINP
      DIMENSION IENTRY(*),JENTRY(*),KENTRY(*),ITITL(18),
     1 ISTATE(NSTATE),KCHAR(3),JQUA2(2),IPARAM(15)
      COMMON BASE(1)
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.1)
     >  CALL XABORT('SYBILT: TWO PARAMETERS EXPECTED.')
      IPTRK=KENTRY(1)
      IPGEOM=KENTRY(2)
      IF(IENTRY(1).NE.1)
     >  CALL XABORT('SYBILT: LINKED LIST EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1))
     >  CALL XABORT('SYBILT: ENTRY IN CREATE OR MODIF MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     >  CALL XABORT('SYBILT: RHS READ-ONLY DDS EXPECTED.')
      CALL LCMGET(IPGEOM,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.NE.'L_GEOM') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('SYBILT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_GEOM EXPECTED.')
      ENDIF
      HSIGN='L_TRACK'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPTRK,'SIGNATURE',3,3,KCHAR)
      HSIGN='SYBIL'
      READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      CALL LCMPUT(IPTRK,'TRACK-TYPE',3,3,KCHAR)
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
*
      IMPX=1
      IF(JENTRY(1).EQ.0) THEN
         TITLE=' '
         MAXPTS=ISTATE(6)
         MAXZ=10000
         MAXJ=MAX(18,4*MAXPTS)
         MULTC=3
         IWIGN=3
         INORM=0
         IQW=0
         JQUA1=5
         JQUA2(1)=6
         JQUA2(2)=3
         IQUA10=5
      ELSE IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(IPTRK,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'L_TRACK') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('SYBILT: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_TRACK EXPECTED.')
         ENDIF
         CALL LCMGET(IPTRK,'TRACK-TYPE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         IF(HSIGN.NE.'SYBIL') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('SYBILT: TRACK-TYPE OF '//TEXT12//' IS '//HSIGN
     1      //'. SYBIL EXPECTED.')
         ENDIF
         CALL XDISET(ISTATE,NSTATE,0)
         CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
         MAXPTS=ISTATE(1)
         ITG=ISTATE(7)
         MAXZ=ISTATE(8)
         MAXJ=ISTATE(9)
   10    IF(ITG.EQ.2) THEN
            CALL LCMSIX(IPTRK,'PURE-GEOM',1)
            CALL LCMGET(IPTRK,'PARAM',IPARAM)
            CALL LCMSIX(IPTRK,' ',2)
            JQUA1=IPARAM(3)
         ELSE IF(ITG.EQ.3) THEN
            CALL LCMSIX(IPTRK,'DOITYOURSELF',1)
            CALL LCMGET(IPTRK,'PARAM',IPARAM)
            CALL LCMSIX(IPTRK,' ',2)
            JQUA1=IPARAM(2)
         ELSE IF(ITG.EQ.4) THEN
            CALL LCMSIX(IPTRK,'EURYDICE',1)
            CALL LCMGET(IPTRK,'PARAM',IPARAM)
            CALL LCMSIX(IPTRK,' ',2)
            MULTC=IPARAM(2)
            IWIGN=IPARAM(3)
            INORM=IPARAM(12)
            IQW=IPARAM(13)
            JQUA1=IPARAM(10)
            JQUA2(1)=IPARAM(8)
            JQUA2(2)=IPARAM(9)
         ELSE IF(ITG.EQ.10) THEN
            CALL LCMSIX(IPTRK,'BIHET',1)
            CALL LCMGET(IPTRK,'PARAM',IPARAM)
            CALL LCMSIX(IPTRK,' ',2)
            ITG=IPARAM(6)
            IQUA10=IPARAM(8)
            GO TO 10
         ENDIF
      ENDIF
      IRECT=0
      IHALT=0
      ILIGN=0
   20 CALL REDGET(INDIC,NITMA,RELINP,TEXT4,DBLINP)
      IF(INDIC.EQ.10) GO TO 30
      IF(INDIC.NE.3) CALL XABORT('SYBILT: CHARACTER DATA EXPECTED.')
      IF(TEXT4.EQ.'EDIT') THEN
         CALL REDGET(INDIC,IMPX,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED(1).')
      ELSE IF(TEXT4.EQ.'MAXR') THEN
         CALL REDGET(INDIC,MAXPTS,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED(2).')
         MAXJ=MAX(MAXJ,4*MAXPTS)
      ELSE IF(TEXT4.EQ.'MAXJ') THEN
*        ALLOCATED STORAGE FOR STORING THE INTERFACE CURRENTS.
         CALL REDGET(INDIC,MAXJ,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'MAXZ') THEN
*        ALLOCATED STORAGE FOR STORING THE TRACKING INFORMATION.
         CALL REDGET(INDIC,MAXZ,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'TITL') THEN
         CALL REDGET(INDIC,NITMA,RELINP,TITLE,DBLINP)
         IF(INDIC.NE.3) CALL XABORT('SYBILT: TITLE EXPECTED.')
      ELSE IF(TEXT4.EQ.'ROTH') THEN
         MULTC=1
      ELSE IF(TEXT4.EQ.'ROT+') THEN
         MULTC=2
      ELSE IF(TEXT4.EQ.'DP00') THEN
         MULTC=3
      ELSE IF(TEXT4.EQ.'DP01') THEN
         MULTC=4
      ELSE IF(TEXT4.EQ.'ASKE') THEN
*        USE ASKEW CYLINDERIZATION IN EURYDICE.
         IWIGN=1
      ELSE IF(TEXT4.EQ.'WIGN') THEN
*        USE WIGNER CYLINDERIZATION IN EURYDICE.
         IWIGN=2
      ELSE IF(TEXT4.EQ.'SANC') THEN
*        USE SANCHEZ CYLINDERIZATION IN EURYDICE.
         IWIGN=3
      ELSE IF(TEXT4.EQ.'HALT') THEN
*        STOP AT THE END OF TRACKING.
         IHALT=1
      ELSE IF(TEXT4.EQ.'LIGN') THEN
*        PRINT THE TRACKING INFORMATION.
         ILIGN=1
      ELSE IF(TEXT4.EQ.'RENO') THEN
*        NORMALIZE TRACKS.
         INORM=0
      ELSE IF(TEXT4.EQ.'NORE') THEN
*        DO NOT NORMALIZE TRACKS.
         INORM=1
      ELSE IF(TEXT4.EQ.'RECT') THEN
*        DO NOT CONSIDER THE SYMMETRIES OF SQUARE CELLS IN EURYDICE.
         IRECT=1
      ELSE IF(TEXT4.EQ.'GAUS') THEN
*        USE GAUSS QUADRATURES IN ANGLE AND SPACE.
         IQW=0
      ELSE IF(TEXT4.EQ.'EQW') THEN
*        USE EQUAL WEIGHT QUADRATURES IN ANGLE AND SPACE.
         IQW=1
      ELSE IF(TEXT4.EQ.'QUA1') THEN
*        1-D QUADRATURE PARAMETER.
         CALL REDGET(INDIC,JQUA1,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'QUA2') THEN
*        2-D QUADRATURE PARAMETERS (ANGLE AND SPACE).
         CALL REDGET(INDIC,JQUA2(1),RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
         CALL REDGET(INDIC,JQUA2(2),RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.'QUAB') THEN
         CALL REDGET(INDIC,IQUA10,RELINP,TEXT4,DBLINP)
         IF(INDIC.NE.1) CALL XABORT('SYBILT: INTEGER DATA EXPECTED.')
      ELSE IF(TEXT4.EQ.';') THEN
         GO TO 30
      ELSE
         CALL XABORT('SYBILT: '//TEXT4//' IS AN INVALID KEY WORD.')
      ENDIF
      GO TO 20
*
   30 IF(TITLE.NE.' ') THEN
         READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
         CALL LCMPUT(IPTRK,'TITLE',18,3,ITITL)
      ENDIF
      TEXT12=HENTRY(2)
      READ(TEXT12,'(3A4)') (ITITL(I),I=1,3)
      CALL LCMPUT(IPTRK,'LINK.GEOM',3,3,ITITL)
*
      IF(MAXPTS.EQ.0) CALL XABORT('SYBILT: MAXPTS NOT DEFINED.')
      CALL SETARA(BASE,MAXPTS,IMAT)
      CALL SETARA(BASE,MAXPTS,IVOL)
      CALL SETARA(BASE,MAXPTS,IIDL)
      CALL SYBTRK (IPTRK,IPGEOM,IMPX,MAXPTS,MAXJ,MAXZ,TITLE,
     1 MULTC,IWIGN,IHALT,ILIGN,INORM,IRECT,IQW,JQUA1,JQUA2,IQUA10,
     2 BASE(IMAT),BASE(IVOL),BASE(IIDL))
      CALL RLSARA(BASE(IIDL))
      CALL RLSARA(BASE(IVOL))
      CALL RLSARA(BASE(IMAT))
*
      IF(IMPX.GT.1) THEN
         CALL XDISET(ISTATE,NSTATE,0)
         CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
         WRITE(IOUT,110) (ISTATE(I),I=1,9)
      ENDIF
      RETURN
*
  110 FORMAT(/14H STATE VECTOR:/
     1 7H NREG  ,I6,' (NUMBER OF REGIONS)'/
     2 7H NUN   ,I6,' (NUMBER OF UNKNOWNS)'/
     3 7H ILK   ,I6,' (0=LEAKAGE PRESENT/1=LEAKAGE ABSENT)'/
     4 7H NBMIX ,I6,' (MAXIMUM NUMBER OF MIXTURES USED)'/
     5 7H NSURF ,I6,' (NUMBER OF OUTER SURFACES)'/
     6 7H NANI  ,I6,' (FLUX ANISOTROPY ORDER)'/
     6 7H ITG   ,I6,' (TYPE OF GEOMETRY)'/
     7 7H MAXZ  ,I6,' (TRACKING LENGTH)'/
     8 7H MAXJ  ,I6,' (INTERNAL STORAGE LENGTH FOR CURRENTS)')
      END
