*DECK XDRCRE
      SUBROUTINE XDRCRE(NAMMOD,IBEAF )
*
*-----------------------------------------------------------------------
*
*Purpose:
* To print DRAGON credits.
*
*Copyright:
* Copyright (C) 2004 Ecole Polytechnique de Montreal
*
*Author(s): G. Marleau
*
*Parameters: input
* NAMMOD  name of DRAGON module.
* IBEAF   flag for beginning or finishing module where
*         \begin{itemize} 
*         \item IBEAF=1  before module execution;
*         \item IBEAF=-1 after module execution.
*         \end{itemize} 
*
*-----------------------------------------------------------------------
*
      IMPLICIT         NONE
*----
*  SUBROUTINE ARGUMENTS
*----
      CHARACTER        NAMMOD*12
      INTEGER          IBEAF
*----
*  LOCAL PARAMETERS
*----
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='XDRCRE')
*----
*  LOCAL VARIABLES
*----
      CHARACTER        USE*72,AUT*72
      INTEGER          ICOPYR
*----
*  PRINT CREDITS
*----
      ICOPYR=0
      IF(IBEAF .EQ. 1) THEN
        WRITE(IOUT,6000) NAMMOD
        IF     (NAMMOD .EQ.  'ASM:        ') THEN      
          USE='TO BUILT SYSTEM MATRICES (CP AND IC)'
          AUT='A. HEBERT, G. MARLEAU, R. ROY'
        ELSE IF(NAMMOD .EQ.  'CFC:        ') THEN      
          USE='CREATE FEEDBACK COEFFICIENT DATABASE'
          AUT='T. SISSAOUI'
        ELSE IF(NAMMOD .EQ.  'CPO:        ') THEN      
          USE='CREATE REACTOR COMPOSITION DATABASE'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'EDI:        ') THEN      
          USE='EDITING MODULE'
          AUT='A. HEBERT, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'EVO:        ') THEN      
          USE='ISOTOPIC DEPLETION AND FUEL BURNUP'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'EXCELL:     ') THEN      
          USE='3-D EXCELT MODULE COMBINED WITH ASM'
          AUT='R. ROY'
        ELSE IF(NAMMOD .EQ.  'EXCELT:     ') THEN      
          USE='EXCELL TRACKING IN 2 AND 3-D'
          AUT='G. MARLEAU, M. OUISLOUMEN, R. ROY'
        ELSE IF(NAMMOD .EQ.  'FLU:        ') THEN      
          USE='SOLVE CP OR JPM EQUATIONS FOR FLUX'
          AUT='T. COURAU, A. HEBERT, G. MARLEAU, I. PETROVIC'
        ELSE IF(NAMMOD .EQ.  'GEO:        ') THEN      
          USE='GEOMETRY DEFINITION'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'INFO:       ') THEN      
          USE='INFORMATION ON WATER, UO2 AND THO2'
          AUT='R. ROY'
        ELSE IF(NAMMOD .EQ.  'JPMT:       ') THEN      
          USE='JPM 2-D TRACKING'
          AUT='A. HEBERT, G. MARLEAU, M. OUISLOUMEN'
        ELSE IF(NAMMOD .EQ.  'LIB:        ') THEN      
          USE='MICROSCOPIC XS-LIBRARY PROCESSING'
          AUT='A. HEBERT, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MAC:        ') THEN      
          USE='MACROSCOPIC X-S PROCESSOR'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MOCC:       ') THEN      
          USE='METHOD OF CYCLIC CHARACTERISTICS'
          AUT='R. ROY'
        ELSE IF(NAMMOD .EQ.  'MRG:        ') THEN      
          USE='MERGE EXCELL TRACKING FILE'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'PSP:        ') THEN      
          USE='GENERATES PS GRAPHICS FOR DRAGON'
          AUT='K.E. KOHLER, G. MARLEAU'
          ICOPYR=1
        ELSE IF(NAMMOD .EQ.  'SHI:        ') THEN      
          USE='SELF-SHIELDING BY IMPROVED STAMMLER METHOD'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'SYBILT:     ') THEN      
          USE='SYBIL 2-D TRACKING'
          AUT='A. HEBERT'
        ELSE IF(NAMMOD .EQ.  'HST:        ') THEN      
          USE='CELL HISTORY MODULE'
          AUT='G. MARLEAU, E. VARIN'
        ELSE IF(NAMMOD .EQ.  'SAD:        ') THEN      
          USE='COMPUTE GENERALIZED ADJOINT SOURCES AND FLUXES'
          AUT='T. COURAU, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'PER:        ') THEN      
          USE='COMPUTE PERTURBATIONS AND FLUXES'
          AUT='T. COURAU, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'MCU:        ') THEN      
          USE='UNIVERSAL 3-D CHARACTERISTICS SOLVER'
          AUT='M. DAHMANI, R. ROY, G.J. WU'
        ELSE IF(NAMMOD .EQ.  'NXT:        ') THEN      
          USE='New tracking in 2-D and 3-D (compatible with EXCELT)'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'TLM:        ') THEN      
          USE='Generate Matlab line tracing file'
          AUT='C. PLAMONDON, G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'SUS:        ') THEN      
          USE='Generate SUSD3D flux and adjoint files'
          AUT='G. MARLEAU'
        ELSE IF(NAMMOD .EQ.  'NDIST:      ') THEN      
          USE='Generate normal distribution of error'
          AUT='G. MARLEAU'
        ELSE
          USE='NO DESCRIPTION AVAILABLE FOR THIS MODULE'
          AUT='NO AUTHOR PROVIDED FOR THIS MODULE'
        ENDIF
        WRITE(IOUT,6100) USE,AUT
        IF(ICOPYR .EQ. 1) THEN
          WRITE(IOUT,6111)
        ELSE
          WRITE(IOUT,6110)
        ENDIF
      ELSE
        WRITE(IOUT,6001) NAMMOD
      ENDIF
      RETURN
*----
*  FORMATS
*----
 6000 FORMAT('->@BEGIN MODULE : ',A12)
 6001 FORMAT('->@END MODULE   : ',A12)
 6100 FORMAT('->@DESCRIPTION  : ',A72/
     >       '->@CREDITS      : ',A72)
 6110 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL ')
 6111 FORMAT('->@COPYRIGHTS   : ECOLE POLYTECHNIQUE DE MONTREAL '/
     >       '                  K.E. KOHLER FOR PSPLOT          ')
      END  
