*DECK XDREXP
      SUBROUTINE XDREXP(DX,NBX)
C
C
C**** ROUTINE    XDREXP: R.ROY (10/1998), VERSION 0.1
C                        CALLED BY DRAGON.
C
C                        ROUTINE WILL CONSTRUCT EXPONENTIAL TABLES
C                                        FOR LINEAR INTERPOLATION.
C
C****  INPUT:   *DX    * STEP FOR TABLES        (HERE: DX=0.02D0)
C               *NBX   * ORDER OF TABLES        (HERE: NBX=7936)
C
C**** OUTPUT:   A COMMON FOR LINEAR EXPONENTIAL TABLES IS FILLED
C               AND SAVED WITH NAME: /EXP1/
C
C**** NOTE:     YOU MAY UNCOMMENT THE FOLLOWING FORTRAN INSTRUCTION:
      IMPLICIT NONE
C
      INTEGER          I, NBX
      DOUBLE PRECISION DX, X0, X1, PAS, XLIM, EX0, EX1
      DOUBLE PRECISION DEPS, DREF, DZERO, DONE
      PARAMETER      ( DEPS= 1.D-10, DREF= 1.D0/512.D0,
     >                 DZERO= 0.D0, DONE=1.D0 )
C
C     SPACE AND VALUES FOR EXPONENTIAL TABLES
      REAL             E0, E1, PAS1, DX1, XLIM1
      INTEGER          MEX1
      PARAMETER      ( MEX1=7936 )
C
      COMMON /EXP1/ E0(0:MEX1),E1(0:MEX1),PAS1,DX1,XLIM1
      SAVE   /EXP1/
C
      IF( NBX.NE.  7936 ) GO TO 97
      IF( DX .GT. DREF+DEPS .OR. DX .LT. DREF-DEPS  ) GO TO 98
      PAS=   DONE/DX
      XLIM=  DBLE(NBX)*DX
      XLIM1= XLIM
      PAS1= PAS
C
C     WE CONSTRUCT THE LINEAR TABLES USING ACCURATE *EXP* VALUES
C
      X0=  DZERO
      EX0= DZERO
      DO 20 I= 0, NBX-1
C
C        STORE CONSTANT VALUE:
         X1= X0 + DX
         EX1= DONE - EXP(-X1)
C
C        STORE STEP AND CONSTANT VALUES:
         E1(I)= REAL(((EX1-EX0)/(X1-X0)))
         E0(I)= REAL( EX0 - X0 * ((EX1-EX0)/(X1-X0)))
         X0= X1
         EX0= EX1
   20 CONTINUE
      E0(NBX)= 1.0
      E1(NBX)= 0.0
      RETURN
C
C     ERROR SECTION
   97 CALL XABORT('XDREXP: EXP LINEAR TABLES HAVE 7937 ELEMENTS')
   98 CALL XABORT('XDREXP: EXP LINEAR TABLES HAVE A STEP OF 1/512')
      END
