      SUBROUTINE LCMSTA(IPLIS1,IPLIS2)
*
*-----------------------------------------------------------------------
*
* COMPARE THE FLOATING POINT INFORMATION CONTAINED IN THE ACTIVE
* DIRECTORIES OF TWO LINKED LISTS OR XSM FILES POINTED BY IPLIS1 AND
* IPLIS2.
*
* INPUT PARAMETERS:
*  IPLIS1 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  IPLIS2 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 21/12/93 ----
*
      CHARACTER NAMT*12,CTMP1*4,CTMP2*4,HNAME1*12,HNAME2*12,NAMMY*12
      REAL RR1(8),RR2(8)
      DOUBLE PRECISION DD1(4),DD2(4)
      INTEGER IBASE(1)
      LOGICAL LCM,LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1)),(RR1(1),DD1(1)),
     1 (RR2(1),DD2(1))
*
      CALL LCMVAL(IPLIS1,' ')
      CALL LCMVAL(IPLIS2,' ')
      NAMT=' '
      CALL LCMNXT(IPLIS1,NAMT,HNAME1,NAMMY,LCM)
      NAMT=' '
      CALL LCMNXT(IPLIS2,NAMT,HNAME2,NAMMY,LCM)
      IFILE=KDROPN('DUMMYSQ',0,2,0,0)
      IF(IFILE.LE.0) CALL XABORT('LCMSTA: KDROPN FAILURE.')
      CALL LCMEXP(IPLIS1,0,IFILE,1,1)
      REWIND(IFILE)
      READ(IFILE) JLEVEL,NAMT,ITY1,ILON1
      IF(JLEVEL.NE.1) CALL XABORT('LCMSTA: INVALID EXPORT FILE.')
      ILEVEL=1
   10 IF(ITY1.EQ.3) ILON1=(ILON1+3)/4
      IF((ITY1.EQ.4).OR.(ITY1.EQ.6)) ILON1=2*ILON1
      DO 15 I=1,ILEVEL-JLEVEL
      CALL LCMSIX(IPLIS2,' ',2)
   15 CONTINUE
      ILEVEL=JLEVEL
      CALL LCMLEN(IPLIS2,NAMT,ILON2,ITY2)
      IF((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) THEN
         WRITE(6,'(/21H LCMSTA: TWO BLOCKS '',A12,6H'' OF '',A12,
     1   7H'' AND '',A12,23H'' ARE OF UNEQUAL TYPE (,2I4,8H) OR LEN,
     2   5HGTH (,2I7,2H).)') NAMT,HNAME1,HNAME2,ITY1,ITY2,ILON1,ILON2
         DO 20 I=1,1+(ILON1-1)/8
         READ(IFILE)
   20    CONTINUE
         GO TO 110
      ENDIF
      IF(ITY1.EQ.0) THEN
*        DIRECTORY DATA.
         ILEVEL=ILEVEL+1
         CALL LCMSIX(IPLIS2,NAMT,1)
         WRITE (6,'(/23H STEP UP TO DIRECTORY '',A12,2H''.)') NAMT
      ELSE
         CALL SETARA(BASE,ILON1,IAS1)
         CALL SETARA(BASE,ILON2,IAS2)
         CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
         IF(ITY1.EQ.1) THEN
*           INTEGER DATA.
            DO 25 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (IBASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   25       CONTINUE
            DO 30 I=1,ILON1
            IF(IBASE(IAS1+I-1).NE.IBASE(IAS2+I-1)) THEN
               WRITE(6,'(/40H LCMSTA: INCONSISTENT INTEGER DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               GO TO 100
            ENDIF
   30       CONTINUE
         ELSE IF((ITY1.EQ.2).OR.(ITY1.EQ.6)) THEN
*           COMPARE THE TWO SINGLE PRECISION OR COMPLEX BLOCKS.
            DO 35 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (BASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   35       CONTINUE
            EPSMAX=0.0
            EPSAVG=0.0
            INGRO=0
            WRITE(6,'(/40H LCMSTA: COMPARE REAL OR COMPLEX BLOCK '',A12,
     1      32H'' IN LINKED LISTS OR XSM FILES '',A12,7H'' AND '',A12,
     2      2H'':)') NAMT,HNAME1,HNAME2
            DO 50 I=1,ILON1
            ABSEP=ABS(BASE(IAS1+I-1)-BASE(IAS2+I-1))
            IF(EPSMAX.LT.ABSEP) THEN
               EPSMAX=ABSEP
               INGRO=I
            ENDIF
   50       EPSAVG=EPSAVG+ABSEP
            EPSAVG=EPSAVG/REAL(ILON1)
            WRITE (6,'(/5H LEN=,I6,5X,7HEPSMAX=,E10.5,13H IN COMPONENT,
     1      I6/16X,7HEPSAVG=,E10.5)') ILON1,EPSMAX,INGRO,EPSAVG
         ELSE IF(ITY1.EQ.3) THEN
*           CHARACTER*4 DATA.
            DO 55 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (BASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   55       CONTINUE
            DO 60 I=1,ILON1
              WRITE(CTMP1,'(A4)') BASE(IAS1+I-1)
              WRITE(CTMP2,'(A4)') BASE(IAS2+I-1)
              IF(CTMP1.NE.CTMP2) THEN
               WRITE(6,'(/40H LCMSTA: INCONSISTENT CHARACTER DATA ON ,
     1         29HTHE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               GO TO 100
              ENDIF
   60       CONTINUE
         ELSE IF(ITY1.EQ.4) THEN
*           COMPARE THE TWO DOUBLE PRECISION BLOCKS.
            EPSMAX=0.0
            EPSAVG=0.0
            INGRO=0
            WRITE(6,'(/41H LCMSTA: COMPARE DOUBLE PRECISION BLOCK '',
     1      A12,32H'' IN LINKED LISTS OR XSM FILES '',A12,7H'' AND '',
     2      A12,2H'':)') NAMT,HNAME1,HNAME2
            DO 80 IL=1,1+(ILON1-1)/8
            DO 70 I=1,MIN(8,ILON1-(IL-1)*8)
   70       RR2(I)=BASE(IAS2+(IL-1)*8+I-1)
            READ(IFILE) (DD1(I),I=1,MIN(4,ILON1/2-(IL-1)*4))
            DO 80 I=1,MIN(4,ILON1/2-(IL-1)*4)
            ABSEP=ABS(SNGL(DD1(I)-DD2(I)))
            IF(EPSMAX.LT.ABSEP) THEN
               EPSMAX=ABSEP
               INGRO=(IL-1)*8+I
            ENDIF
   80       EPSAVG=EPSAVG+ABSEP
            EPSAVG=EPSAVG/REAL(ILON1)
            WRITE (6,'(/5H LEN=,I6,5X,7HEPSMAX=,E10.5,13H IN COMPONENT,
     1      I6/16X,7HEPSAVG=,E10.5)') ILON1,EPSMAX,INGRO,EPSAVG
         ELSE IF(ITY1.EQ.5) THEN
*           LOGICAL DATA.
            DO 85 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (LBASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   85       CONTINUE
            DO 90 I=1,ILON1
            IF(LBASE(IAS1+I-1).NEQV.LBASE(IAS2+I-1)) THEN
               WRITE(6,'(/40H LCMSTA: INCONSISTENT LOGICAL DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               GO TO 100
            ENDIF
   90       CONTINUE
         ELSE
            CALL XABORT('LCMSTA: INVALID DATA TYPE.')
         ENDIF
  100    CALL RLSARA(BASE(IAS2))
         CALL RLSARA(BASE(IAS1))
      ENDIF
  110 READ(IFILE,END=130) JLEVEL,NAMT,ITY1,ILON1
      GO TO 10
*
  130 DO 140 I=1,ILEVEL-1
      CALL LCMSIX(IPLIS2,' ',2)
  140 CONTINUE
      IRC=KDRCLS(IFILE,2)
      IF(IRC.LT.0) CALL XABORT('LCMSTA: KDRCLS FAILURE.')
      RETURN
      END
