      SUBROUTINE XSMSIX(IPLIST,NAMP,IACT)
*
*-----------------------------------------------------------------------
*
* MOVE IN THE HIERARCHICAL STRUCTURE OF A XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*  NAMP  : CHARACTER*12 NAME OF THE SON DIRECTORY IF IACT=1.
*  IACT  : TYPE OF MOVEMENT IN THE HIERARCHICAL STRUCTURE.
*          0: RETURN TO THE ROOT DIRECTORY;
*          1: MOVE TO A SON DIRECTORY;
*          2: MOVE TO THE PARENT DIRECTORY.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      PARAMETER (IPRIM=3,IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
*     IPRIM=ADDRESS OF THE ROOT DIRECTORY.
*     KLONG=LENGTH OF A DIRECTORY EXTENT IN MEMORY.
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      LOGICAL LBASE(1)
      COMMON IBASE(1)
      EQUIVALENCE (IBASE(1),LBASE(1))
*
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(22HXSMSIX: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         CALL XABORT(HSMG)
      ENDIF
      IF(IACT.EQ.0) THEN
         IF(LBASE(PFXSM+IMODIF)) THEN
            DO 10 J=1,IBASE(PFXSM+INMT)
            WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10       CONTINUE
            WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
            CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1      IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2      IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3      IBASE(PFXSM+IIDIR))
            LBASE(PFXSM+IMODIF)=.FALSE.
         ENDIF
         IBASE(PFXSM+IIDIR)=IPRIM
      ELSE IF(IACT.EQ.2) THEN
         IF(LBASE(PFXSM+IMODIF)) THEN
            DO 20 J=1,IBASE(PFXSM+INMT)
            WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20       CONTINUE
            WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
            CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1      IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2      IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3      IBASE(PFXSM+IIDIR))
            LBASE(PFXSM+IMODIF)=.FALSE.
         ENDIF
         IBASE(PFXSM+IIDIR)=IBASE(PFXSM+IIROOT)
      ELSE IF(IACT.EQ.1) THEN
         NAMT=NAMP
         DO 30 J=1,IBASE(PFXSM+INMT)
         WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   30    CONTINUE
         WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         CALL XSMREP(NAMT,2,IBASE(PFXSM+IIFILE),LBASE(PFXSM+IMODIF),CMT,
     1   IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),
     2   MYNAME,IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),
     3   IBASE(PFXSM+IJTYP),IBASE(PFXSM+IIDIR),III)
         READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
         DO 40 J=1,IBASE(PFXSM+INMT)
         READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   40    CONTINUE
         IF(III.GT.0) THEN
*           THE SON LEVEL ALREADY EXISTS.
            IF(IBASE(PFXSM+IJTYP+III-1).NE.0) THEN
               WRITE(HSMG,'(15HXSMSIX: BLOCK '',A12,15H'' IS NOT A DIRE,
     1         23HCTORY OF THE XSM FILE '',A12,2H''.)') NAMT,HNAME
               CALL XABORT(HSMG)
            ENDIF
            IF(LBASE(PFXSM+IMODIF)) THEN
               CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1         IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2         IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3         IBASE(PFXSM+IIDIR))
               LBASE(PFXSM+IMODIF)=.FALSE.
            ENDIF
            IBASE(PFXSM+IIDIR)=IBASE(PFXSM+IIOFS+III-1)
         ELSE
*           THE SON LEVEL DOES NOT EXISTS AND IS CREATED.
            IF(IBASE(PFXSM+IIMPF).EQ.2) THEN
               WRITE(6,'(/26H TRY TO CREATE DIRECTORY '',A12,7H'' FROM ,
     1         11HDIRECTORY '',A12,2H''.)') NAMT,MYNAME
               WRITE(HSMG,'(22HXSMSIX: THE XSM FILE '',A12,9H'' IS OPEN,
     1         19H IN READ-ONLY MODE.)') HNAME
               CALL XABORT(HSMG)
            ENDIF
            IF(IBASE(PFXSM+INMT).EQ.IOFMAX) THEN
*              THE ACTIVE DIRECTORY IS FULL. CREATE AN EXTENT.
               IPOS=IBASE(PFXSM+ILINK)
               IBASE(PFXSM+ILINK)=IBASE(PFXSM+IIOFT)
               IF(LBASE(PFXSM+IMODIF)) THEN
                  CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,
     1            IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),
     2            IBASE(PFXSM+IIROOT),MYNAME,IBASE(PFXSM+IIOFS),
     3            IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     4            IBASE(PFXSM+IIDIR))
               ELSE
                  CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+ILINK),
     1            IBASE(PFXSM+IIDIR)+3,1,IRC)
                  IF(IRC.NE.0) THEN
                     WRITE(HSMG,'(24HXSMSIX: KDIPUT ERROR NB.,I6,4H ON ,
     1               10HXSM FILE '',A12,2H''.)') IRC,HNAME
                     CALL XABORT(HSMG)
                  ENDIF
               ENDIF
               IBASE(PFXSM+IIDIR)=IBASE(PFXSM+ILINK)
               IBASE(PFXSM+ILINK)=IPOS
               IBASE(PFXSM+IIOFT)=IBASE(PFXSM+IIOFT)+KLONG
               IBASE(PFXSM+INMT)=0
            ENDIF
            IBASE(PFXSM+INMT)=IBASE(PFXSM+INMT)+1
            NMT=IBASE(PFXSM+INMT)
            READ(NAMT,'(3A4)') (IBASE(PFXSM+ICMT+(NMT-1)*3+I),I=0,2)
            CMT(NMT)=NAMT
            IBASE(PFXSM+IJLON+NMT-1)=-1
            IBASE(PFXSM+IJTYP+NMT-1)=0
            IBASE(PFXSM+IIOFS+NMT-1)=IBASE(PFXSM+IIOFT)
            IBASE(PFXSM+IIOFT)=IBASE(PFXSM+IIOFT)+KLONG
            CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,NMT,
     1      IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2      IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3      IBASE(PFXSM+IIDIR))
*           CREATE A NEW DIRECTORY.
            IBASE(PFXSM+IIROOT)=IBASE(PFXSM+IIDIR)
            READ(NAMT,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
            IBASE(PFXSM+IIDIR)=IBASE(PFXSM+IIOFS+NMT-1)
            IBASE(PFXSM+INMT)=0
            IBASE(PFXSM+ILINK)=IBASE(PFXSM+IIDIR)
            LBASE(PFXSM+IMODIF)=.TRUE.
            RETURN
         ENDIF
      ELSE
         WRITE(HSMG,'(31HXSMSIX: INVALID ACTION NUMBER (,I3,9H) FOR XSM,
     1   7H FILE '',A12,2H''.)') IACT,HNAME
         CALL XABORT(HSMG)
      ENDIF
      CALL XSMDIR(1,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1 IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2 IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3 IBASE(PFXSM+IIDIR))
      READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      DO 50 J=1,IBASE(PFXSM+INMT)
      READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   50 CONTINUE
      RETURN
      END
