*DECK ALCACT
      SUBROUTINE ALCACT(LCACT,NG,XG,WG)
C
C     AUTHOR: R.ROY (09/1998)
C
C             *ALCACT* WILL GENERATE POLAR QUADRATURE SETS
C                      (USED IN THE MOCC: CHARACTERISTICS MODULE)
C
C      INPUT: *LCACT*  IS THE DIRECT ACCESS UNIT FOR OBJECT CODE
C                      =1 WILL GENERATE ISO-WEIGHT QUADRATURE
C                      =2 WILL GENERATE UNIF-ANGLE QUADRATURE
C                      =3 WILL GENERATE OPTIMAL-KI QUADRATURE
C
C     OUTPUT: *NG*     IS THE ORDER OF QUADRATURE (# OF POINTS/WEIGHTS)
C             *XG*     ARE THE POINTS  (DEFINED AS REAL XG(NG))
C             *WG*     ARE THE WEIGHTS  (DEFINED AS REAL XG(NG))
C
      IMPLICIT NONE
      INTEGER  LCACT, NG, IG
      REAL     XG(NG), WG(NG)
      REAL     XMCD(2), WMCD(2)
      DOUBLE PRECISION PI, PHIM, PHIP, DELPHI, WTEST, XTEST, YTEST,
     >                 ZTEST, ZERO, ONE, HALF, QUART
      PARAMETER( PI=3.14159265358979D0, ZERO=0.D0, ONE=1.D0,
     >           HALF=0.5D0, QUART=0.25D0 )
      SAVE XMCD, WMCD
      DATA XMCD, WMCD /0.273658, 0.865714, 0.139473, 0.860527 /
      IF( LCACT.EQ.1 )THEN
         DELPHI= ONE/DBLE(NG)
         PHIM  = ZERO
         XTEST = ZERO
         DO 10 IG= 1, NG
            PHIP  = DBLE(IG) * DELPHI
            WTEST = PHIP - PHIM
            WG(IG)= REAL( WTEST )
            YTEST = SQRT(ONE - PHIP * PHIP) * PHIP + ASIN(PHIP)
            ZTEST = HALF * (YTEST - XTEST) / WTEST
            XG(IG)= REAL( SQRT(ONE - ZTEST*ZTEST) )
            PHIM  = PHIP
            XTEST = YTEST
   10    CONTINUE
      ELSEIF( LCACT.EQ.2 )THEN
         DELPHI= PI/DBLE(2*NG)
         PHIM  = ZERO
         DO 20 IG= 1, NG
            PHIP  = DBLE(IG) * DELPHI
            WTEST = SIN(PHIP) - SIN(PHIM)
            WG(IG)= REAL( WTEST )
            XTEST = HALF * (PHIP - PHIM)
            YTEST = QUART * (SIN(PHIP+PHIP) - SIN(PHIM+PHIM))
            ZTEST = (XTEST + YTEST) / WTEST
            XG(IG)= REAL( SQRT(ONE - ZTEST*ZTEST) )
            PHIM= PHIP
   20    CONTINUE
      ELSEIF( LCACT.EQ.3 )THEN
         IF( NG.NE.2 ) CALL XABORT('ALCACT: LCACA=3 => NG=2')
         DO 30 IG= 1, NG
            XG(IG)= SQRT(ONE - XMCD(IG)*XMCD(IG))
            WG(IG)= WMCD(IG)
   30    CONTINUE
      ELSE
         CALL XABORT('ALCACT: *LCACA* IS 1, 2 OR 3')
      ENDIF
      RETURN
      END
